commit 13b4521341781293c41ac898aa9c2d2f6bc1f21d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Feb 5 14:42:49 2024 +0100

    Preparing for rpm 4.19.1.1

commit ab3ec5583a0039bd86ea4a0f05ce5a9c82a00236
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 30 15:08:34 2024 +0200

    Fix couple of leaks in rpmpgppubkeyfingerprint test prog
    
    Tracking the test-programs themselves is kinda silly but since it
    could reveal leaks from librpm side, we better pay attention.
    These could do with a goto exit-refactoring.
    
    (cherry picked from commit 5f5fa88521791052592e12d7f671722b8cc81ac8)

commit 368d82e0b26685384b96097eac5049420119d6f8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 30 15:04:03 2024 +0200

    Tip-toe around rpmfiFN() thin ice in fsm
    
    Any pointer gotten from rpmfiFN() is only valid until the next
    rpmfiFN() call, and here the path can end up inside plugins which
    may have their own reasons for calling rpmfiFN(). At which point
    the dest we passed would be invalid. strdup() it to appease ASAN,
    but this needs a saner solution really.
    
    (cherry picked from commit 7bf818c8344ecbf0e14a26e6393582ae79df864e)

commit 5976558efe7228e4351f68560ac8d8bf16846ea0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 30 15:01:55 2024 +0200

    Fix a bunch of argv leaks in the Lua extension
    
    (cherry picked from commit 04b3317e619d4efd8f86275904e1af00b40ffb6b)

commit 054371607aa620220c4c64843b70d6ee565f4396
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 30 14:55:54 2024 +0200

    Fix spec parser leaks from %*trans -f <file>
    
    The untrans-versions leak because grepping around didn't turn up
    the trans-counterparts ... because they didn't exist either.
    Those leaks are adults by now.
    
    (cherry picked from commit 26a1323022e3153d99b2f1095fe040f52fb2e3f3)

commit 2ec4f84c16694413d9223544d172ba8fff5ca054
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 31 10:09:07 2024 +0200

    Add a note about rpmfiFN()/rpmfiOFN() pointer validity to API docs
    
    (cherry picked from commit 4b656321d6a735d4ac5d299ea6b977d6bf3c68f7)

commit 8e5f8ab2141f44e3442087aa7af41a444ae16ddc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 24 12:44:34 2024 +0200

    Fix a theoretical use of uninitialized struct members
    
    If rpmScriptFromTriggerTag() was called with tm other than the three
    handled cases in the switch, the rpmtd_s structs would be uninitialized
    and weird things could happen. The value of tm is hardwired in all the
    existing callers AFAICS but the extra safety doesn't hurt either.
    
    Discovered by static analysis in RHEL.
    
    (cherry picked from commit 656fe42af1d497c35769c740fcc98950e1455bad)

commit 494e104c40491dcd435fd7d16ea16a6e6a56ba99
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 24 12:03:39 2024 +0200

    Use unsigned integers for buildtime too for Y2K38 safety
    
    This little patch buys us 68 extra years to move to 64bit time tags
    in rpm. That seems achievable.
    
    Fixes: #1228
    (cherry picked from commit 97aa64d8281974fb369c66d5aef8650515b89c52)

commit 8a6e59a8b1b9670cebd6058ac56f85c91f803f1f
Author: Takuya Wakazono <pastalian46@gmail.com>
Date:   Thu Jan 18 18:41:11 2024 +0900

    Don't use _nl_msg_cat_cntr if it's not available
    
    musl doesn't need to use libintl from GNU gettext because it has its
    own NLS implementation. Assuming _nl_msg_cat_cntr exists breaks the
    build against the musl system.
    
    (cherry picked from commit f401979a4c4829d68e9614860644bdb74b6dda66)

commit ac42433e0f57a0d8ac05f471eb0880c687a85ed6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 16 15:46:57 2024 +0200

    Simplify the cache lookup logic, no functional changes
    
    (cherry picked from commit 593059db0fe7e63163254d3b7c25cc641dbd44cb)

commit ac155918ef257f0ed2355c6e8b9378ef040ca689
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 16 15:05:34 2024 +0200

    Make user/group lookup caching minimally thread-safe
    
    Now with the caching data in a single struct from the previous commit,
    we can easily make this per-thread for a minimal fix for thread-safety.
    
    Fixes: #2826
    (cherry picked from commit c86f0888dd7572afb5b7abe673199423ff1940aa)

commit 6ef8541ac48e742a100857d72c486a632dd9d458
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jan 15 12:30:58 2024 +0200

    Centralize user/group lookup caching into a single data structure
    
    Collect all the cached data into a struct for sanity.
    It's worth noting that this also simplifies the caching, we no longer
    keep separate name to id and id to name caches (totaling four).
    We simply cache one id/name for for user and another for group data.
    Also, reset ids to 0 rather than -1, this is far more obviously a safe
    value as we have special cases to handle id 0.
    
    rpmugUname() and rpmugGname() are have no users in the current codebase,
    so this was developed wrt commit c576d96930bfaf8f4328170de4c2915e76c1f715
    where they still are used, to avoid nasty surprises later on if somebody
    finds a new case for these.
    
    (cherry picked from commit 309db68b33eebae38d1247374f63c0f7f2883594)

commit ec079d5337047d92b13901fb6a2cac692352aa5d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 16 14:59:08 2024 +0200

    Remember to free user/group cache on librpm shutdown (again)
    
    I think this was here previously but has gotten erreonously removed
    at some point - we do use rpmug from librpm so we need to free it too.
    
    (cherry picked from commit dec8bcc6757b095f1682fd9cfc1dbd338aabaf49)

commit 40a95b23fa7d181ecbdd42b957026e1f75c0486e
Author: Alexander Kanavin <alex@linutronix.de>
Date:   Tue Jan 16 13:43:36 2024 +0100

    CMakeLists.txt: restore readline support as an explicit option
    
    This was lost in autotools -> cmake transition. The particular
    reason to make it explicit is that readline is gpl version 3
    licensed, and in some builds components under that license
    need to be excluded.
    
    (backported from commit b2e8a2bed582a9ccc70fbbf3c8586bdd712ea4d1)

commit b83c5601dec76cd8dfab0567111957db6182743b
Author: Matteo Croce <teknoraver@meta.com>
Date:   Mon Jan 15 08:27:17 2024 -0500

    Don't attempt to install html pages if they're not built
    
    When building from git on a system without Doxygen, html pages are not
    built and the install fails with:
    
            Install the project...
            -- Install configuration: ""
            CMake Error at docs/cmake_install.cmake:51 (file):
              file INSTALL cannot find "/html": No such file or directory.
            Call Stack (most recent call first):
              cmake_install.cmake:47 (include)
    
    Conditionally install html docs only if we build them.
    
    (cherry picked from commit 6098fe1e9f735ab3a603eb429e01300ae48bf4fe)

commit f274d74778bcb486db24c8f077b40c0d266daf8b
Author: Matteo Croce <teknoraver@meta.com>
Date:   Fri Jan 5 21:39:03 2024 +0100

    Add missing include
    
    The build fails because of a missing include in cmake:
    
        CMake Error at CMakeLists.txt:353 (check_symbol_exists):
          Unknown CMake command "check_symbol_exists".
    
    Include the needed file to fix the issue.
    
    (cherry picked from commit 2300eb6e064473b148474486e2ffd2106f8bab86)

commit 7d0a7c27d132ed0abb4b2bc414b822c84b7dce44
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 4 11:26:03 2024 +0200

    rpmcli.h forces a public dependency on popt includes
    
    This is mildly annoying, librpm users don't need to link to popt but
    this one include in rpmcli.h (that most API users wont even use) forces
    a public dependency on it.
    
    Another possibility could be splitting out the "cli" part of librpm
    one way or another, but that doesn't seem worth all the trouble it would
    be.
    
    (cherry picked from commit 75965c1e712b000763df922223fa1a2db284fc03)

commit 25972feebff18b1215eea5e77c685e51fc9b1eee
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 4 11:25:10 2024 +0200

    Drop unnecessary rpmcli.h include from rpmbuild.h
    
    (cherry picked from commit dbd5307bdf3ef82ec1fa49e36fb10a3b8bdc98bb)

commit 0d443fb2feca454229b36a00347f2c5dee6502fe
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 20 09:44:45 2023 +0200

    Fix libintl linkage and include directories (cmake transition fallout)
    
    We checked for libintl in the top-level CMakeLists.txt but then never
    used it for anything. This only ever worked on glibc where this all
    is bundled in. Unfortunately Intl only becomes an importable target
    in cmake >= 3.20 which is too new for us to rely on for now.
    
    Python bindings are omitted here because we don't have any translated
    messages in there. Whether we should is another topic.
    
    (backported from commit a77c1d0670e3563af3c4ce3e9dd53879d76acb9b)

commit 3b4ee84da47ab788cba13ebf78e1b3fb3025f4ac
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 20 09:38:09 2023 +0200

    Cosmetics: fix rpmio cmake indentation style
    
    (cherry picked from commit 6e507ddd9cb8a6ce5c6e6604cd6e7d4b1c4bc8f7)

commit b8d6fe3c68de4255b3cfb6c154287bb40f116e4b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 19 10:44:01 2023 +0200

    Conditionalize libdw and libelf linkage to librpmbuild
    
    I clearly remember testing the behavior wrt these and concluding that the
    cmake exported interface syntax doesn't require conditionalizing.
    Clearly it does though, so dunno what I was supposed to have tested
    back then.
    
    Suggested-by: Mark Dascher <mark@papertrail.com>
    (cherry picked from commit d6736bdc81f2f089edac3a7fc8dc414639780edd)

commit dbf745cc9b478cb432c5c5cf3467461d5e8ce45a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 19 10:29:51 2023 +0200

    Fix missing private linkage to iconv and popt in librpmbuild and sign
    
    Yet more rather obvious fallout from the cmake transition. It's strange
    these don't fail the build on Linux.
    
    Suggested-by: Mark Dascher <mark@papertrail.com>
    (cherry picked from commit 513595cdf0b45ab5096e91415c0591f3d39d4d98)

commit 51614425548deafa437205fc222809ba91b00573
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 19 10:24:34 2023 +0200

    Fix rpm2archive build regression due to missing libgen.h include
    
    Should've been in commit 04d49fbd2f3f470669dccfba0a4f2264509a4513
    where basename() usage was introduced.
    
    And because the standard version of basename() has non-const argument,
    we run into rpm2archive using non-standard const argument to main(),
    because popt got it wrong. Move the const-cast to the popt invocation
    for consistency with the other codebase.
    
    Suggested-by: Mark Dascher <mark@papertrail.com>
    (cherry picked from commit 4e171567cedb247177ef25b767850057088b655c)

commit f2d78c6d606a105528b05111d3e24ebb6877bf65
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Dec 18 12:25:04 2023 +0200

    Fix unconditional dependency on non-POSIX GLOB_ONLYDIR flag
    
    This regressed when we axed our internal glob copy in commit
    66fa46c006bae0f28d93238b8f7f1c923645eee5. Luckily GLOB_ONLYDIR is only
    an optimization so we can just skip it if not available.
    
    (cherry picked from commit 57f3711846f44da0f37cbc5dd66e8fba80a3bee1)

commit 9b02bb1b673537d480d774a0fe989b7d634f64af
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 12 16:49:27 2023 +0200

    Fix hard dependency on strchrnul() GNU extension
    
    We missed the use of this non-standard function on review. rpmsort
    needs to be fixed to not rely on GNU extensions but in the meanwhile
    we need to check for that function and disable if not present.
    
    (backported from commit 5f74110974ff3bcdd058c13c605bfbf6d4a1e586)

commit dbd4f8f03d8b66b6af541078f0195107eff1c402
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 12 16:42:42 2023 +0200

    Fix hard dependency on libelf (cmake transition fallout)
    
    Conditionalize elfdeps build on libelf availability.
    
    (cherry picked from commit 8758fff7f7ac6f491f8b2980b6bc2370e46a4ac4)

commit 1da87856df1995b8a3bb533f9039e51e9810c568
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 15 13:15:29 2023 +0200

    Fix regression in Lua scriptlet runaway child detection
    
    Commit a8107659ef3dd4855729bf65aa4d70f784cb5a5f moved the detection
    to parent using waitpid(), but this causes it to complain on any
    process in the same process group. In the usual rpm context we don't
    have any, but we can't very well tell API users not to have any
    children. And then failed to detect a runaway Lua child in one of
    our own tests. Uff.
    
    rpmlog() in the child has the issues mentioned in the originating
    commit, but that's a problem that needs to be solved elsewhere.
    Revert back to issuing a warning when we actually *are* in the child
    process, so there are no false positive possible. Use EXIT_FAILURE
    like in the original version, dunno why I'd changed that.
    
    Update the rpmlua test to expect the deserved warning, and use
    stdio for printing its "normal" output, the catch there is that we
    need to flush the io in the child.
    
    Reported at https://bugzilla.redhat.com/show_bug.cgi?id=2254463
    
    (cherry picked from commit bb4aaaa2e8e4bdfc02f9d98ab2982074051c4eb2)

commit 79d56121e86b52f2f652fdd37203be8862208645
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Dec 13 11:58:01 2023 +0100

    Fix markdown formatting in man page
    
    (cherry picked from commit 195b5cd3c7138495dea29c501159372e8410eb1f)

commit 9f64db92a689897eeca26cfa06a4c8f47ae59467
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 13 11:57:50 2023 +0200

    Don't warn about missing user/group on skipped files
    
    There's no reason to complain about missing user/group for entities
    we don't create at all. It's cosmetical only, but "regressed" in the
    4.17 fsm robustness rewrite.
    
    Reported in https://issues.redhat.com/browse/RHEL-18037
    
    (cherry picked from commit 6c66abd34cccbb5b3c063f8f613e0c2faffc415f)

commit 98b301ebb44fb5cabb56fc24bc3aaa437c47c038
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Dec 12 11:40:33 2023 +0100

    Preparing for rpm 4.19.1

commit 4eb72997ef06cbc44bc24a2f6352532539f173ec
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Dec 11 15:50:15 2023 +0100

    Print full path if file removal fails
    
    For normal debug output the basename of the files are sufficient as when
    debugging is enabled the directories are also printed. But here the
    warning is given without a debug flag so we need the full context right
    there.
    
    (cherry picked from commit dcf8c5abc64eb0fe3c81482008b8a13bec19eb20)

commit 5dfb9877dd2b433879c0a2e57608c05aac5da029
Author: Frank Dana <ferdnyc@gmail.com>
Date:   Tue Oct 31 11:31:39 2023 -0400

    docs/macros.md: Fix expansion shorthand
    
    (cherry picked from commit f4ad03dc2a62de1f182fc4c7841784a35bc6ae22)

commit f9873aed0a2e871d11d7ce740380b7bc8347ec1f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Dec 7 17:21:04 2023 +0100

    Refactor cmake config for man pages
    
    No functional changes, just reduces verbosity a bit.
    
    (cherry picked from commit 014b09de6fd0e4a295b0e751f2ef30eaa7c1aa04)

commit 4b5c47236b0a34fe33cd3d484f1ad745f2c7fe93
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Dec 7 17:19:35 2023 +0100

    Build all manuals regardless of enabled features
    
    Commit 1870f4df16d9f20e5a5341ea000c5b8aa19a2d21 stopped the installation
    of man pages for disabled features.  We were still building them all,
    though, so they appeared in dist tarballs as they should have.
    
    This was lost in the cmake translation where the opposite problem was
    introduced: only man pages for enabled features are now built, meaning
    that when preparing a tarball, you need to make sure all the features
    are enabled in your build in order to have all the man pages pre-built
    and bundled.
    
    Fix this "regression" by building all man pages unconditionally again
    while only installing those that are enabled.
    
    (backported from commit ddc0ad85a58a9f678cfd26fa7c6246ff314ff2ff)

commit 234b34d918839a70771ec57ef3b01e29fd069c46
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Dec 5 11:03:47 2023 +0100

    Don't include git refs in ChangeLog
    
    Right now, we "leak" any local branch or tag names into the ChangeLog
    which is unnecessary (e.g. "experiment-foo-123") and also just pollutes
    the diff when comparing ChangeLogs between releases.  Only show the
    plain log.
    
    Fixes: #2647
    (cherry picked from commit 017b5a4141e1143fc43acf276bdc6bfb6c1eb91a)

commit 77d3529c31ca090a40b8d3959a0bcdd721a556d6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 30 13:33:46 2023 +0200

    Never use current user info or file ownership during build
    
    There's no situation where rpmbuild should use uid/gid from either
    the filesystem or current user. The former made sense in the
    pre-historic times before Buildroot was a thing, but in the last 20+
    years that's always the wrong thing to do. Always. The only user/group
    info rpm can legitimately use is the one that is explicitly specified in
    the packaging, and otherwise fallback to root/equivalent.
    
    Besides fixing a long-standing annoyance with src.rpm file ownership,
    this also fixes a regression in 4.19.0 where a non-local or otherwise
    unresolvable user info could cause a segfault during rpmbuild (RhBug:2248763).
    
    Fixes: #2604
    (backported from commit a0553eb38a01772254cd48fef7ad116294cf801a)

commit d146585a7e064edb67ca0f4f354f3bfb67400c9b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 14:26:50 2023 +0200

    Bumb CI to Fedora 39
    
    No particular reason this time, but nice to be on the same page with
    the system rpm.
    
    (cherry picked from commit c576d96930bfaf8f4328170de4c2915e76c1f715)

commit 6fd08587514f3b3c903ad195f4834d8756b679a9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 13:41:17 2023 +0200

    Optimize Doxygen output for C
    
    This simply uses terminology better suited for C, such as "data
    structures" instead of "classes" and so on.
    
    (cherry picked from commit 15bd653a5be4fdb60269c2a712c0049bddccd600)

commit 993191a89d85514ca8a3e5570047f012b7b8420c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 13:30:14 2023 +0200

    Honor ENABLE_WERROR on Doxygen too
    
    (cherry picked from commit 5d7a192c9279ac24e57d443e417a8fb7ecffc012)

commit b1207ee9933c25c8e45d0350c873cde9d7b4a15f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 13:26:17 2023 +0200

    Silence not-documented warnings from Doxygen
    
    These litter our build logs with redundant noise from undocumented
    macros and typedefs that aren't really worth the trouble to document.
    Sadly Doxygen doesn't have fine-grained controls for emitted warnings.
    
    (cherry picked from commit c47ee2435fa673c32103c7e3dda380de1641d3ab)

commit 11daac6757abecd9f01246e11c822afd96d861fd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 13:19:48 2023 +0200

    Fix a bunch of undocumented-warnings from Doxygen
    
    No functional changes, just docs.
    
    (backported from commit 06ea60361f12251664187b0d1dd80848ba92d352)

commit 5d3f82a7596a48aab05356623f67cdc69bdaed4f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Dec 1 11:23:40 2023 +0200

    Drop autoconf-era leftover Doxygen config
    
    (cherry picked from commit 3ffa334a990c0a431ea33ded839b8dd82a93a786)

commit 135f94955e8f7d9b61584f0dc72960c241ec6797
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 29 13:18:33 2023 +0200

    Clarify pgpParsePkts() and pgpReadPkts() API docs
    
    Both process exactly one ASCII-armored block, this wasn't clear in
    the docs.
    
    Fixes: #2387
    (cherry picked from commit bccf58f0d414a90fe2aca736255f126ad2bf45b2)

commit ca6236cf7bcba1f44c4924dc47d74adfdc964f43
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 16 14:22:15 2023 +0200

    Fix integer overflow in memory calculations on 32bit systems
    
    "long int" on at least x86 Linux is exactly the same as a plain "int",
    so calculations can easily overflow. 32bit systems are not expected to
    have hundreds of gigabytes of memory but a 32bit process on a x86_64 can
    run into all sorts of funny things, such having 500GB system memory. At
    which point the type capable of addressing all of process memory is
    absolutely useless for calculating the total memory.
    
    Use uint64_t in the memory calculations to make the size explicit. Of course
    one day we may cross that border too, but I hope to be retired by then.
    
    Fixes https://issues.redhat.com/browse/RHEL-16557
    
    (cherry picked from commit 1cd9f9077a2829c363a198e5af56c8a56c6bc346)

commit 5ab960e9feea3c29565917a7e1fc3108129c4a0d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 27 14:32:42 2023 +0200

    Avoid compiler complaints from Transmeta Crusoe detection on x86 builds
    
    Multi-character character constants are implementation defined, and
    while it MAY be reliable enough on i386 gcc, even that produces a
    warning. I don't have a test-Robinson here so rather than risk a
    conversion to string comparison like the other is_arch() tests are,
    just write out the integer and leave the character constant as a
    reference comment.
    
    (cherry picked from commit d0e03b21cabfcd090e70620f3e19227e6519f1c3)

commit 0d38b67ce31b471d0e1e51c383b96b6e72ef38f4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 27 13:42:30 2023 +0200

    Fix a bunch of integer size mismatch warnings on 32bit builds
    
    (cherry picked from commit 54a79a19c4ff82a0874588ebe24fce21462f7926)

commit f615aa118f33f3ad437b9a236009d175a9b0f106
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 27 11:52:34 2023 +0200

    Emit full paths for file disposition diagnostics on --fsmdebug
    
    The full path is visible in the actual file operations later, but the
    pre-flight disposition diagnostics is unreadable without the full path.
    This regressed in the switch to relative paths for the *at() API family
    for the symlink CVE fixes.
    
    (cherry picked from commit c140768202e271b60910644c1e4bf848a50218d3)

commit 27afe5f0b036c16649b33ee4f3c98bc19ba0000d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 20 10:43:16 2023 +0200

    Add support for retrieving %generate_buildrequires section from the spec
    
    Should've been in commit 58dcfddc376a7c97de1432f0082be0d5f01adbcd
    
    (cherry picked from commit c359a5cd354ae963175091c8e6ed2bde918771a2)

commit a9eacf9285b875a4e62fc26a09857835b590ce88
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Nov 17 12:16:48 2023 +0100

    Extend test README
    
    Fixes: #2611
    (cherry picked from commit 949f2819749ddb8854162bf544d83a1a1402291c)

commit 78a9bd120b1ce809ac8a4daf2ec91fb439d1fc21
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 16 11:19:14 2023 +0200

    Fix segfault on %{?getncpus}, regression in 4.19.x
    
    Commit deaebd0c89a6d453bb971fd8f5a3b858e7a95733 assumed there would
    always be args, but in the macro existence test none are set up.
    
    Reported as a side-issue in https://issues.redhat.com/browse/RHEL-16557
    
    (cherry picked from commit c110ad11c33aeb0fe9ef1d494d689b59e47e855e)

commit d8cc2775f07c0f4365ec29937e221fcd09a52ea4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 15 14:44:42 2023 +0200

    Document pgpPrtParamsSubkeys() returning only signing-capable keys
    
    Since commit a9cca032a2b7c0c6bcacc6ab4ecd25c95cc75305 we've only
    returned signing capable subkeys, but this has seemed like an
    implementation detail. Make it explicit.
    
    Fixes: #2515
    (cherry picked from commit 01fb42d42ca710bf24e3af841d43b4e3d60b3aef)

commit 217caa46e1aad597a870b0abb8371b26ff7d6176
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 15 09:24:28 2023 +0200

    Fix %{getncpus proc/thread} potentially returning zero
    
    Add the missing sanity check/fixup for memory starved systems where
    we end up returning zero cpus. Should've been in commit
    deaebd0c89a6d453bb971fd8f5a3b858e7a95733 originally.
    
    Reported in https://issues.redhat.com/browse/RHEL-16557
    
    (cherry picked from commit 6714ec7068a0343dcb4aaaeb4fe49940c129292f)

commit 6dd356915f2163686794e4c1779abe4eac72d9db
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 14 11:59:18 2023 +0200

    Add a test-case for invalid intermediate symlink owner (CVE-2021-35939)
    
    This should've been in commit 96ec957e281220f8e137a2d5eb23b83a6377d556
    but back then we didn't have a good way to test ownership matters.
    
    (cherry picked from commit 0091214d2f2b489f4d38464c8d217cd7f5aba50a)

commit 406a1beee0b60a33ef2078116b4a749adcda157c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 14 11:37:48 2023 +0200

    Fix wrong return code on O_DIRECTORY open of invalid symlink
    
    The dir argument to fsmOpenpath() is supposed to be a rough O_DIRECTORY
    equivalent, and if the path is actually a misowned symlink it should
    return ENOTDIR instead of ELOOP. Makes the resulting error messages
    at least a little more comprehensible.
    
    (cherry picked from commit 89ce4e7ca592f5abafc3f25aeaa07d36a7b43a61)

commit 40eda139494886f707d5827774b478fea8db0eec
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 14 09:07:28 2023 +0200

    Allow version to be omitted in the replace test spec
    
    (cherry picked from commit 2c20f9677eff989817148d236543191dec0d8059)

commit f6216e71e44f327d4f8f5a40d8312d72b1fda3f6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 15:24:37 2023 +0200

    Refactor / cleanup rpm2archive entry fillup a bit
    
    Do all the entry fillup in the function intended for that,
    no functional changes intended. Drop the unnecessary nlink check
    from the unpacking: if there's content, it should unpacked.
    
    (cherry picked from commit 3151a187402767ab87ec91d34bb7337dee89af92)

commit a24f9ba1fbce426c75aeec911dc808d646599e1f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 15:18:55 2023 +0200

    Document rpm2cpio as obsolete, add pointer to rpm2archive.
    
    (cherry picked from commit f6b47609a963a6cf2d3181a0bb90437c330d401f)

commit ee9314b09a69c56de9247a1a6d3d40c71ada5fdd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 10:30:46 2023 +0200

    Add cpio format support to rpm2archive
    
    cpio is a legacy format but content in that format will remain with us
    for a very, very, very long time still. Better support the format here
    than have to support a separate tool just for the purpose.
    
    The "new ascii cpio" format can't host files larger than 4GB, but
    most rpm content fits and will continue to do so in that range easily,
    so instead of just outlawing the good 'ole format, just skip over
    anything we can't handle and emit a warning.
    
    Additionally, if invoked as "rpm2cpio", behave like it: no compression,
    cpio format.
    
    (cherry picked from commit 04d49fbd2f3f470669dccfba0a4f2264509a4513)

commit db1996e4e982d86531714373e17fc8df059615d7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 13:45:14 2023 +0200

    Fix uid, gid and nlinks not getting populated by rpm2archive
    
    Take advantage of rpmfiStat() and archive_entry_copy_stat() which
    handle most of the dirty work here. Hardlink sizes are special because
    in archives, the file size is 0 except for the one with the content,
    but otherwise of course hardlinked files have sizes as usual.
    
    (cherry picked from commit b86f6ad4f0c557f64ffbb53dbb90e4f2d9f85a7c)

commit 9829e88af044f45398302b683b45b454bf526c39
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 10:46:48 2023 +0200

    At least try to handle write errors in rpm2archive
    
    (cherry picked from commit fa1fbe95ed12ea7dd916cc277ac2cb227d7f9621)

commit 0488c494f7098313a81c8ebd4714a78605beaefa
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 13:34:06 2023 +0200

    Fix some invalid rpm2cpio invocations in the test-suite
    
    runroot is the wrong thing to use with rpm2cpio which doesn't understand
    things like --define. This has only worked because rpm2cpio is dumb
    enough not to look at its arguments at all.
    
    (cherry picked from commit 80d5fc3c9ece8861bb63001e1b76b2fa8b01afd2)

commit 56af525e6f0ca24967f18bf21f46dfdf454b24b1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 09:57:02 2023 +0200

    Use the expected rpm2cpio-like syntax for rpm2archive tests
    
    (cherry picked from commit 243deae923065160e6aba6dbbe825de73ae74276)

commit cf4c02a0d7a0ee49d6209fb7d36bd02fe36141f6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 09:53:30 2023 +0200

    Split the two rpm2archive tests to separate test-cases
    
    No actual change, just allows more comprehensive testing, easier to
    read and add more.
    
    (cherry picked from commit d49e26498e9861e54971a98b2442aaeeb7bfff61)

commit 35b4537b534d97e5e537833e6556608ae5477d2e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 10 10:38:54 2023 +0200

    Fix sbit removal if fchmodat() doesn't support AT_SYMLINK_NOFOLLOW
    
    glibc versions prior to 2020 know about AT_SYMLINK_NOFOLLOW but don't
    actually implement it for fchmodat() and returns ENOSYS when used.
    We don't check the return code in removeSBITS() so this silently fails
    on those older versions.
    
    We already verify the thing is not a link in the fstatat() condition
    because cap_set_fileat() doesn't have any "dont follow" mode at all,
    so we can just as well drop it from the fchmodat() and make this
    work on more libc versions.
    
    Add a test for the suid bit removal while at it.
    
    (cherry picked from commit 7d3d9041af2d75c4709cf7a721daf5d1787cce14)

commit 7676d95fe09f97f584f2ce88655ab0db502ed608
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 9 16:08:53 2023 +0200

    Split the dependency generation test into individual checks
    
    No actual changes, just makes it much easier to read + work with.
    
    (cherry picked from commit e3ab8a9871da5acdadd13d8f62709f4b0259ba1b)

commit b2d5c289e9666ff83fd5eb232b6c969aa2d10017
Author: Dirk Müller <dirk@dmllr.de>
Date:   Thu Nov 9 13:34:15 2023 +0100

    Switch brp-compress to bash
    
    commit f3f763e54d introduced the use of 'read -d' which is
    bash specific.
    
    Signed-off-by: Dirk Müller <dirk@dmllr.de>
    (cherry picked from commit 4d219ed463984d69c532413584a4bd7b5e76e8d9)

commit 1c12a5d614926d9af8c652a856ba9168d9239485
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Nov 7 16:40:36 2023 +0100

    Adapt Dockerfile.fedora to F39
    
    The fedora-repos-modular package is gone from F39.  This commit makes
    the Dockerfile work on a F39 host with the mktree.oci backend since we
    override the release with "podman build --from fedora:39 ..." there.
    
    (cherry picked from commit f851bce1ef69c047a869a3a83b1063a037bcd289)

commit 30f222c6681656313bcd2ab2f185c84ab482ebda
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Nov 8 17:28:09 2023 +0100

    Allow SOURCE_DATE_EPOCH=0 again
    
    Commit 11132fc21fb01ed63c621d852bc081a914d4f021 assumed that the value
    of 0 is never used in practice and thus used it to indicate "disabled",
    however that assumption has turned out to be wrong because ostree uses
    precisely that value as mtime in inodes, which in turn breaks existing
    workflows in this space (see the associated ticket).
    
    Fix this by reverting the above commit (except leaving source_date_epoch
    initialized to 0, to prevent GCC warnings as mentioned in that commit).
    
    As to why not just initialize source_date_epoch to -1: time_t happens to
    be a signed integer on most platforms but POSIX doesn't specify its
    signed-ness.
    
    Add some accompanying tests too.
    
    Fixes: #2679
    (cherry picked from commit bb1eeb49132e2be3582f1e949a20ea5f6c8104cf)

commit 4b6f142f79560f7f4075fb0ffc843d334b3dd146
Author: Takuya Wakazono <pastalian46@gmail.com>
Date:   Wed Nov 8 01:56:56 2023 +0900

    Fix a macro in the comment
    
    Nothing defines RPMHOME, replace it with RPM_CONFIGDIR.
    
    (cherry picked from commit 17f72c4e7f872a70809128160cf1e74be9c4500c)

commit 05b97f011cab0f4576efb9e883ff73722213b2e2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 3 12:15:58 2023 +0200

    Fix comment line handling in sysusers.d(8) files
    
    sysusers.d(8) format permits empty lines and commits, and so must we.
    Add some extra fluff to the test-case for this.
    
    This is the second half of
    https://bugzilla.redhat.com/show_bug.cgi?id=2246236
    
    Fixes: #2741
    (cherry picked from commit a8ec768950f0adb9fb0c264596350fc929437ac8)

commit 5addad402cc360df4f0681b9ffdcec09e5f78788
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 3 11:53:11 2023 +0200

    Handle unsupported 'r' and 'm' sysusers types more gracefully
    
    People will want to use existing sysusers.d files through rpm and while
    we don't support 'r' and 'm' at this time, we shouldn't really call
    them "invalid" and error out. Issue a warning instead, and ignore.
    
    This is the first half of
    https://bugzilla.redhat.com/show_bug.cgi?id=2246236
    
    (cherry picked from commit 43cf645fc1fab93b5424cfc22cb520eb486fdbee)

commit 323e3f7053173a052eefc0ce4fb5aa4f9d879aaf
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 3 11:51:11 2023 +0200

    Fix an apparent thinko/typo in the sysusers test spec
    
    I'm quite sure I didn't really intend to test duplicate files behavior
    here...
    
    (cherry picked from commit d141c874b3281a806bc027d0cf6cf22afd759f7a)

commit 6a9934c781862df84a77c6be47633b37f0b9fee7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 3 11:34:54 2023 +0200

    Use macro error reporting for %add_sysuser errors
    
    Lua has error() but no warning() (obviously) which we'll want in the next
    step, so for consistency lets just use macro.error() instead.
    
    (cherry picked from commit 22e177f428a2afec2db8adad032c17e954ce0a59)

commit 899ffecfdfe9fbb38958d21fd60ee864ceeeef52
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 6 15:58:54 2023 +0200

    Expose and document rpmdb --verifydb operation
    
    After years of BDB, sometimes folks just want some assurance that their db
    is still fine. Properly exposing an operation to do so hopefully makes
    less likely to poke at the db directly (with eg sqlite3 command).
    
    (cherry picked from commit 173b737f40e7da85f79544e3f4ea4ad7b8f7d5c2)

commit d0f98715c990483eed802580a17349f3230831e5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 6 15:58:07 2023 +0200

    Document rpmdb --exportdb and --importdb switches + minor other tweaks
    
    (cherry picked from commit e85a8a63692a37db7df7384310749cbfa796183a)

commit 6bab2c0b1df040800f6274e9ce81eb44163efea2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 6 12:35:56 2023 +0200

    Properly document our different macro types and their scopes
    
    (cherry picked from commit f8b4c99bd874c56cef73ab1ca204e225eebae8a7)

commit 8ae49748bc27fcdfc67c6f724f5a51deb31f690c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Oct 31 16:37:44 2023 +0100

    Exit from mktree on failure
    
    Right now, if the podman image fails to build or rpm fails to
    build/install, we happily continue and run the test-suite, only to
    eventually fail with some cryptic error, such as:
    
        error: cannot find rpm
    
    Not too helpful, indeed.  Instead, just fail the whole tree preparation
    process if we encounter an error.
    
    Fix the return code of unshared() so that we don't fail on that, though.
    Also, when building the RPM layer, use a proper cleanup trap instead of
    ignoring SIGINT since a failing make_install() can now terminate the
    script.
    
    Fixes: #2667
    (cherry picked from commit 302793af0b80defd77c750bdcf1a8721d75353e1)

commit e1b94c6cf10722eb1029f48eb11aeda62f922ed8
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 11:00:07 2023 +0200

    Rename mktree.podman to mktree.oci
    
    This name is a better fit as it puts more emphasis on the format of the
    resulting tree, not as much on the actual container engine used (which
    can be swapped, and currently is in the CI where we use docker instead
    of podman).
    
    Also drop the awkward .docker symlink now and instead pass the container
    engine through the MKTREE_ENGINE environment variable.
    
    (cherry picked from commit 05c3b37d1f8f91c3face5eeafe8d4c76fbdda495)

commit 9f3ff6939c7f9b5e7738feda6420bf43ef903c39
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 13:55:20 2023 +0200

    Remove sudo from GH workflow
    
    Turns out the docker command in CI is set up such that it doesn't need
    an explicit sudo, so remove it.  This will also allow us to easily pass
    environment variables to mktree in the next commit (as otherwise we'd
    have to use the ugly -E, --preserve-env option).
    
    No functional change.
    
    (cherry picked from commit 15897bca7fe2305434fbef3928152019c5e0ce9a)

commit a9f259b35f1883518f8f5c31960cc3f5349842dd
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 16:05:01 2023 +0200

    Remove function keywords from atlocal
    
    These are bashism, not really needed.
    
    (cherry picked from commit 47067768a3d972b80613e4983e840eb36d171fe9)

commit 3b3107c8493b4599a99d8b6ad54d367165225a0c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 10:48:31 2023 +0200

    Move snapshot() back to atlocal
    
    Commit 09e472040ad8bd87d50dac63aa6f72a359ade47e moved the snapshot
    function to mktree.common so that we could later use it in non-cmake
    mode (outside of the build directory) too, to containerize rpmtests
    itself.  In the end, however, we've decided to just use Podman/Docker
    for the outer container as it simplifies things.
    
    Therefore, the snapshot function is no longer needed outside of the
    test-suite, it's an internal implementation detail at this point which
    doesn't have anything to do with mktree, so move it back to atlocal
    where it really belongs.
    
    As a bonus, the rpmtests wrapper can now be simplified a bit more, too.
    
    No functional change.
    
    (cherry picked from commit c7ed626fbf0f88f12556374bcecf0047e648db7c)

commit e68177a9402d7ae8a5ddffa233b2097916368549
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 12 16:05:16 2023 +0200

    Standardize on OCI images in test-suite
    
    Instead of manually bootstrapping our own base "image" using a host
    specific script, just use the official, prebuilt OCI images with
    Podman/Docker.  This has several advantages:
    
    - Standard, ubiquitous OCI images (easy support for other distros)
    - No manual setup of DNF, RPM macros, user namespaces and whatnot
    - Single recipe (Dockerfile) for both the local and CI purposes
    - Outsourced image caching (Podman/Docker storage)
    - Faster (just downloads the prebuilt image)
    - Less dependencies on the host
    
    Now that we've prepared mktree.podman for local use, just switch to it
    in cmake and drop the Fedora backend.  Update the docs and comments
    accordingly, too, those should explain the details.
    
    Fixes: #2643
    (cherry picked from commit 93eef6d3a27f5de4977b1f14e8bf1c101bca76a2)

commit d1a0db2d5221092dc56e9b504cc9f3ecaff577a5
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 19 15:53:32 2023 +0200

    Add native mode to mktree.podman
    
    Instead of building RPM from scratch as part of the image, allow for
    reusing the existing build artifacts on the host to produce the final
    image.
    
    This ensures we test the actual local build, not just the sources, and
    speeds up the whole process, allowing it to be used for local
    development as well.
    
    No immediate effect, we'll hook this up to cmake in the next commit.
    
    (cherry picked from commit 1a7956e008479ad3a3bb58297d920b0ba6f09b44)

commit bb1169f613c0ba8274d9d3036b4b521bd425d339
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 19 16:32:05 2023 +0200

    Add Dockerfile.fedora
    
    Rename the existing Dockerfile and add a symlink for the original
    filename.  This will allow for supporting other, non-Fedora, Linux
    distros in the future and is a prerequisite for the next commits.
    
    (cherry picked from commit ec5ec7923198a481c7798cfe7dc3b521d6376b9c)

commit 87974f7781d1570b22522cf0cf553732c2529b85
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 19 15:02:51 2023 +0200

    Only rebuild the RPM test layer
    
    Right now, we build and tag a new image on each mktree.podman run.  This
    causes an unnecessary buildup of images over time that needs to be
    manually cleaned with podman-image-prune(1).  Instead, tag the base
    layer and then only rebuild the RPM layer.
    
    (cherry picked from commit fe0c09f16f8f6df3ab370d75bab29f3f6b44ebd6)

commit b9de143afd0c629126a1776b7db9869f0166ba8e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 17:18:43 2023 +0200

    Bind mount $PWD at /srv in test container
    
    This is another step towards the unified OCI backend, no functional
    change yet.
    
    (cherry picked from commit 5fd2e028b0672ee37c54eaf8141bbc418bf69c30)

commit f1aa106cc22023a329778ae775840ec65492d937
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Oct 27 17:18:32 2023 +0200

    Use --log only if running from source dir
    
    Log mode is mostly useful in the CI environment so don't enable it by
    default.  This is another step towards the unified OCI backend.
    
    No functional change.
    
    (cherry picked from commit b1eed579f0d71fbcd5f71f2cc8e47b4b5db52660)

commit b61956b1b1006867a82200be5b47f91100174939
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 19 15:02:38 2023 +0200

    Use the new --shell command in mktree.podman
    
    (cherry picked from commit f59100b3e7ec3784d0a0c28c475065789d1762d9)

commit 5f7a9babb52971c20c19049d30033fc89e36fdc6
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 23 21:56:28 2023 +0200

    Add --shell command to rpmtests wrapper
    
    This invokes an interactive shell in a dummy test where all the usual
    test commands work, and is meant as a replacement for what mktree.fedora
    currently does for its shell/atshell commands.  This feature basically
    emulates a single test so it really belongs to the rpmtests wrapper, not
    mktree.
    
    For consistency, also do the permission fixup for rpmtests.dir (just
    like in mktree.fedora), this will be needed once we drop mktree.fedora.
    
    (cherry picked from commit 0dc534891cea3905ba1c3a2100843e61df416bb1)

commit 253617a7fd4136eaceebf1f7c40d1b03e0be231d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 26 17:31:06 2023 +0200

    Refactor rpmtests wrapper
    
    Don't symlink rpmtests itself, we can run it directly from the
    installation directory in the test tree.  This eliminates some extra
    cd-ing.
    
    No functional change.
    
    (cherry picked from commit 9ae317a81b223ec8e2c097f4cf637fdd0ea34e63)

commit 9570ea6e816422263c89344bf1796299fda7c3c6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 31 13:41:25 2023 +0200

    Add a blurb about portability expecations to contributing guidelines
    
    (cherry picked from commit 61000db0bcce33c7c137c927a22f6ab9d926bee1)

commit a4603e89371492f42ffb53df1433f316666c8a09
Author: MridulSharma03 <149292435+MridulSharma03@users.noreply.github.com>
Date:   Tue Oct 31 13:22:08 2023 +0530

    Fix typos
    
    (cherry picked from commit 6e93ab1eb6f5d3cdddd51aaa2c3c93c55f281640)

commit 064d3f1f73cf8c5c074225e0262fe3210860cc8e
Author: Daniel Alley <dalley@redhat.com>
Date:   Wed Oct 25 09:16:35 2023 -0400

    Remove lead checks other than the "magic number" check
    
    Remove checks on the lead's "signature type" and "rpm package format
    version" fields. The lead is a long, long obsolete structure and the
    less we look at it the better, these checks accomplish exactly nothing
    at all.
    
    Fixes: #2423
    (cherry picked from commit b3449a0774487a091bbe59e821b4004b06d4fa66)

commit 9593684255071960e249e9f268ccb2a46c250cb5
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Oct 24 14:06:50 2023 +0200

    Use uniform formatting for SEE ALSO sections
    
    While there is no generally agreed standard for formatting SEE ALSO
    section of man pages we should at least use only one style. Comma separated
    lists are commonly used when referring to other man pages. Both *italic* and
    **bold** are used but the later seems to be more popular - so let's
    stick to that.
    
    Thanks to Frank Dana <https://github.com/ferdnyc> for pointing this out.
    
    Resolves: #2731
    (backported from commit c97fd9359c2582d350315b5e17697649ee7055f3)

commit 627c4a0f3c5e220266464cd13cd813988f46488b
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Oct 20 19:07:32 2023 +0200

    Add %_iconsdir macro
    
    Offer a generic way to place icons in the proper system dir
    
    Resolves: #2196
    (cherry picked from commit bbadc2bb6445e4608251d3b375120a02a8693286)

commit 58d3879662cde529465a940a203e01f678fb4d8d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 19 10:32:52 2023 +0300

    Document the argv[1] (vs 0) in rpmlua manual
    
    Fixes: #2095
    (cherry picked from commit 3b070507abf1ce0b399d45268015fb76a829be9b)

commit 8257e0b3f5287d14b395a41107d53b5df3284e23
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Oct 17 12:41:11 2023 +0200

    Fix regression of mktree not always rebuilding
    
    Commit d4e808ebda3ec1d85fcdb176eae31901b74c6e91 added cmake caching for
    mktree so that we don't rebuild the tree on each "make check"
    invocation.  However, this means we can now easily miss some test
    dependencies being updated since we don't depend on everything, e.g. the
    data/ dir.
    
    To fix this, instead of adding each and every file and directory as a
    dependency of the mktree.output command, just rebuild the tree every
    time.  The base image (made with DNF) is already cached anyway, and the
    added overhead is tiny and outweighs the (potential) engineering hours
    lost due to this.
    
    The funny thing is, this was already fixed once in 2019:
    fc05045008d84429bf51154642e18fda70d3f256
    
    Sometimes you've just gotta fix stuff twice before it sticks!
    
    Fixes: #2725
    (cherry picked from commit 12b073b56ca5f849ae33e75ae99d3f4688392b70)

commit 090729e642089bb7d3d8319bbb7e0d410ed5f287
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Oct 10 14:18:04 2023 +0200

    Add rpmtests wrapper for container use
    
    This script replaces the role of mktree.rootfs in the podman image where
    it serves as a wrapper for the bundled rpmtests that makes it store its
    working files in the current directory (bind mounted from host) by using
    an ugly symlink hack.  The built in -C option can't be used here because
    it looks for atlocal in the destination directory where it obviously
    isn't, hence the hack.
    
    However, calling "mktree check" in the container is pretty confusing so
    move the hack out into a separate rpmtests wrapper so that we can just
    call "rpmtests" as one would expect.  This also makes the hack more
    explicit and obvious.
    
    For consistency, use the same wrapper when running from the build dir
    (mktree.fedora) as well.  Still prefer the locally built test scripts,
    though, and don't print the test log if not asked.
    
    (cherry picked from commit 860b3d82fadd3f9c06c4048337d6200fb1a0a3ba)

commit b59046a4f5017465d51936c9ec12a959b7093f6b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Oct 10 09:13:38 2023 +0200

    Add --read-only argument to mount_tree
    
    Make it more obvious when the tree is mounted as read-only.
    No functional change.
    
    (cherry picked from commit cea7e09d7594c5d72598d510067ae90946bf2e57)

commit d8f7d99549fd9338a7c61b0f657bee3d0b381995
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 9 16:51:20 2023 +0200

    Depend on mktree script when building the tree
    
    A change to the script warrants a rebuild.
    
    (cherry picked from commit 70cc93cadf6aa8da33c3b410ed43896839f40343)

commit 5445f3532df9d26b985dbf774ada86babb0a2f1f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 9 16:47:10 2023 +0200

    Move make_install to after package installation
    
    No functional change, just cosmetic (makes more sense this way).
    
    (cherry picked from commit 0d0303414c70fa2e34b96dd6420597d0e687cac0)

commit d144946c9d72cb04641cd54862cdba872737930f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 9 12:42:53 2023 +0200

    Don't stack overlays in test-suite
    
    Rather than using the root overlay mount in the rpmtests container as
    our lowerdir for per test mounts, just use the original lowerdir from
    the host.
    
    This eliminates the extra level of indirection and enables us to use a
    podman image mount as the lowerdir (to be done later) as otherwise we
    would hit the kernel's limit for maximum fs stacking depth of 2.
    
    Keep the podman backend as is (using "/"), we'll remove it soon anyway.
    
    No functional change.
    
    (cherry picked from commit 03dd0743016bcd332452d564e39eda12d26b43fa)

commit 112c535f2a17636df3bad729352519b3ac8c45ac
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 9 12:37:09 2023 +0200

    Bind mount $PWD at $PWD, not /srv
    
    This allows us to reuse the host paths such as $RPMTREE inside the test
    container which will be needed in the next commits.
    
    No functional change.
    
    (cherry picked from commit 3fe6c981ec67acc971e74fec37b0e3de90937e66)

commit 9826886577d69bd03996c79fbf656d8fe06fbe4b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Oct 9 12:20:39 2023 +0200

    Move $PWD bind mount out of snapshot shell
    
    This command really shouldn't do more than actually invoke the default
    shell and set a user friendly hostname.  Do the host mount only where
    actually needed, i.e. when running rpmtests which creates overlays.
    
    Files can still be shared between the host and sandbox via "make
    atshell" which mounts the sandbox at $RPMTEST.
    
    (cherry picked from commit 1c25b5eb0e705df727e95f413470789db8acaf79)

commit 9b6335d06d5e739183488842b6f17184378173ad
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 10 15:34:19 2023 +0300

    Run the CI build in parallel
    
    The test-suite runs automatically in parallel but the main build
    doesn't.
    
    (cherry picked from commit 2fb0ddaf098c9d6930f7e577be3155a966802efc)

commit a7be58704be9f0750aa9a1734799ba7de621edbd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 10 15:08:32 2023 +0300

    Enable debug information and optimizations in the CI build
    
    The main reason is to get real-world relevant warnings from the CI
    build, gcc with no optimizations seems to miss all sorts of things.
    Debug info is just handy to have around when developing.
    
    (cherry picked from commit 90c037a8cbc2190724f00661acd4d9139b099726)

commit 5f883bb0c3080c69212fc70d2052bd3afebf00ed
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Oct 9 11:27:24 2023 +0300

    Aaargh. Fix Monday morning "the fix is so obvious..."
    
    The ${key} here ends up expanded on cmake level so it still doesn't do
    what it's supposed to do. Just a simple one-liner, eh?
    
    Fixes: 0c7a3be0cd4ecbb3d2a0771b9b679e938b8e3176
    (cherry picked from commit db210b9cafb914690a767a536f98aca1f0c3e985)

commit faa869ceb73bae3b024c168ecf8d9d381220019a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Oct 9 11:15:52 2023 +0300

    Eh, fix Friday afternoon brain-fart in test-suite os detection
    
    This is one of those cases where the answer to "What on earth were you
    thinking?" is "I wasn't".
    
    Fixes: 20c476f6037163024e6e1b8d2a27447d3ce809b1
    (cherry picked from commit 0c7a3be0cd4ecbb3d2a0771b9b679e938b8e3176)

commit 2b953b1fc479bfd32fc0bc93238f306c94a08501
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 6 14:39:33 2023 +0300

    Make test-suite os detection stricter
    
    On Rocky Linux /etc/os-release contains not only ID="rocky", but also
    ID_LIKE="rhel centos fedora" and the grepping got that wrong. Let
    the shell do the work for us.
    
    Reported-by: Dmitry Mikushin <dmitry@kernelgen.org>
    (cherry picked from commit 20c476f6037163024e6e1b8d2a27447d3ce809b1)

commit e48498f422e212df1205e417235bad297b54399c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 6 14:05:30 2023 +0300

    Ensure proper working dir when processing rpmrc, platform and macros
    
    Fixes `cmake --install` failing on these files as the working directory
    is "unexpected" from the trad. makefile POV.
    
    Reported-by: Tomasz Kłoczko <kloczek@github.com>
    (cherry picked from commit f41040358541a8eef8d8e164ffb25234e9e84622)

commit 468cd13416728df9be8d8fdec854d33164bc2894
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 6 13:45:56 2023 +0300

    Return an error on macro expansion failure from Lua macros table too
    
    Fixes: #2653
    (cherry picked from commit 5079c05b001489f1f2e6cbf283c1d72aa83865f9)

commit 68a2bdf7ec8cbf0cdd7a9e5dd981a460942935bd
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Oct 6 11:56:26 2023 +0200

    Add docs/README.md
    
    giving a rough outline of the different doc parts.
    
    Related: #2259
    (cherry picked from commit e0dd875175cf08a1bc11b8ac63badd5d8ff08a93)

commit 508c1f53042806b51828990764d1501409fb23c0
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Oct 5 10:39:47 2023 +0200

    Reword to make sentence easier to understand
    
    Resolves: #2673
    (cherry picked from commit 0dc37b5c2d2fd06d1ff93e0225d952310f0a46a1)

commit 75853859b5af643a304b5a9d6fb09155e090cc9d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Sep 22 15:09:02 2023 +0200

    Don't assume PWD of / in tests
    
    Instead, just use absolute paths everywhere.
    
    No functional change.
    
    (cherry picked from commit a50e092fcb7b032019205cdcc53d9926e884ec36)

commit c6aef49f2a2d8dcf09679964397ec283a89b4189
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 5 11:19:41 2023 +0200

    Ignore non-zero return code in make (at)shell
    
    We want these to always be 0 so that cmake doesn't print an "error" when
    leaving the shell (if the last command happened to fail).
    
    However, since it's a cmake thing, handle that in cmake instead of
    mktree backends.
    
    No functional change, just cosmetic.
    
    (cherry picked from commit dd669840daf15a05d7c705103522298db839e4c0)

commit c5c13a2149b9054f3292e0a4381ae200076a20da
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 5 11:09:50 2023 +0200

    Only rebuild the test tree when sources change
    
    Turn the tree (mktree.output) into a proper build artifact and let cmake
    do its job in determining when to remake it, instead of doing that
    always.
    
    Keep the "tree" target though, it's still useful when you want to build
    the tree manually.
    
    (cherry picked from commit d4e808ebda3ec1d85fcdb176eae31901b74c6e91)

commit ca6f2289ae5ae22282de1b9856b366657a61c1bf
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Oct 5 11:08:26 2023 +0200

    Always let mktree.fedora build run through
    
    Don't stop if there's a base tree already, this way we'll install any
    newly added packages while still letting DNF skip over those already
    installed.
    
    The original intent of this short-circuit conditional was to avoid the
    output noise but then, it's not really that bad and we'll avoid
    unnecessary rebuilds in the next commit anyway.
    
    (cherry picked from commit 3a1fb2e68e090b87e1f9ee7745c4c3d1252ca882)

commit 9da8fcd0a7fe56fbba8349204dda9bf5b1703678
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Oct 6 10:52:26 2023 +0300

    Eliminate some unnecessary rpmpgp.h includes
    
    Stuff has moved around, these are just leftovers.
    
    (cherry picked from commit 314faf551e3be78337374e2e1a31911c8a73d77c)

commit 8a1d265d43b3be341f25ef81c2e5fad4fdb71e4f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Oct 5 08:49:11 2023 +0300

    Split development tests into its own file
    
    These are rather different than the "general" tests otherwise,
    might as well have them in their own set.
    
    (cherry picked from commit f5e0cbad4f794b3104300a5b5bbc39cf9080dcc3)

commit e5e8f6abc499440f4f72097a753bb05ded3d1d40
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Oct 4 17:35:03 2023 +0200

    Add build stages to Dockerfile
    
    Split the build into two stages, "base" and "full", the former of which
    contains rpm's build, runtime and test dependencies but no rpm install.
    
    The "base" stage will effectively replace mktree.fedora in the next
    commits.
    
    Since this moves the self-removal of rpm in front of the cmake configure
    step, we need to put a workaround in place for /usr/bin/pkg-config which
    is a shim that calls the rpm binary, see the inline comment.
    
    See --target in podman-build(1) for more info on how this can be used.
    
    No functional change.
    
    (cherry picked from commit d1fd06c12c11a245353ecd78a3b6a1ad48395543)

commit 2d09a9efbade3d3813b24a943d90ebb30ed60527
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Oct 4 17:23:48 2023 +0200

    Keep record of stock RPM in RPMDB in Dockerfile
    
    RPM still *is* installed in the final image so keep the record.  That
    way, it won't be pulled back in by DNF in "make atshell" when installing
    additional packages into $RPMTEST.
    
    This is already worked around with the explicit exclude in the DNF
    command line in mktree.fedora but that will go away in the next commits.
    
    The version we build and install is likely newer than what the original
    record claims but that doesn't matter, we really just want to satisfy
    the dependency.
    
    (cherry picked from commit 7e87a27f3a657e6971243a4df933806ce373d2dd)

commit b2b31abac4ec64279a2f63703985a39c19c8b021
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Oct 4 15:45:50 2023 +0200

    Rename make target env to atshell
    
    As in "Autotest shell".  We all know naming is hard but this is perhaps
    going to be more accurate and also consistent with "make shell".  It may
    confuse someone's muscle memory but hopefully nobody (besides me) has
    really been using this (rather new) feature just yet.
    
    (cherry picked from commit 46c64c3f90ad2de00ef57175a4fd252ed0080e71)

commit aa587f677d537ae5aabc50d328b306c016a0ff2b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Oct 4 15:35:20 2023 +0200

    Move snapshot() to mktree.common
    
    This will make it easier to reuse the function in a mktree backend
    without having to source all of atlocal (to be utilized in the next
    commits).
    
    Also drop the "function" keyword (a Bashism) while at it.
    
    No functional change.
    
    (cherry picked from commit 09e472040ad8bd87d50dac63aa6f72a359ade47e)

commit 0ef20662a5e10f9101be5d4a2a334edb15b66c7d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Oct 4 15:24:40 2023 +0200

    Make snapshot() work without CMake configuration
    
    This will be needed in the following commits where snapshot() will be
    used standalone (in CI), much like how mktree.podman is used currently.
    
    Do this by removing the @FOO@ style variable references, namely @BWRAP@
    and @CMAKE_INSTALL_FULL_BINDIR@.  The former can just be "bwrap" and for
    the latter, use the host's shell default, sane value instead.
    
    (cherry picked from commit cca5d1b1de1099014471185c182e7142ccce2b79)

commit c7d747125247f19f27417991c29cc35ffab98f64
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Oct 4 10:28:29 2023 +0300

    Fix build-order regression from 1c98b67911e19a5f92c7fa4492aaa1000a06edad
    
    Running the test-suite obviously requires on having the project completely
    built first. The test-suite was relying on the cli tools in the top level
    directory for this, but now that we moved the tools elsewhere there are
    zero targets at the top-level. Oops.
    
    Update the property get_property() path accordingly, this should've been
    in commit 1c98b67911e19a5f92c7fa4492aaa1000a06edad. Rename the variable
    and add commentary on why we're doing this the way we are, it's not entirely
    obvious.
    
    Suggested-by: Michal Domonkos <mdomonko@redhat.com>
    (cherry picked from commit ea19571b86ff1f828efc264744715b69e30d6832)

commit bf48213ed90d5b35d2497829cc1eaf882397349f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 3 12:24:07 2023 +0300

    Make 'cmake -L' output meaningful
    
    Mark all the program and library path details as advanced, they're not
    something you need to be acutely aware of when compiling rpm. This
    way -L[H] actually shows the "user configurable" parts.
    
    (cherry picked from commit 56558a5a60f210d18fcce8effece6766e4409b10)

commit a3e43989a7072556ba4f80420eab1b2a85067143
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Sep 28 11:53:55 2023 +0300

    Simplify communicating crypto backend to the test-suite
    
    It's fairly amusing how various aspects of integrating autotest seems
    easier with cmake than autoconf/automake.
    
    (cherry picked from commit ea6dab80d6ca1f9bce475d1feb53ddfe0d89f7c0)

commit 96c41b7e5ddd88cc9ea0bdcf1b0b603819310e49
Author: Petr Viktorin <pviktori@redhat.com>
Date:   Wed Sep 20 17:41:48 2023 +0200

    Python tests: Close open files
    
    Debug builds/modes of Python will complain loudly about unclosed files,
    making tests fail.
    
    (cherry picked from commit 58021924994db8949247cf99883695ce12e4d73b)

commit 4a7353e3be8dd7312b84c44822e9e9187e2eeffe
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Sep 18 12:13:50 2023 +0200

    Fix tagtbl.C placement in build dir
    
    The COMMAND for tagtbl.C generation dumps the file in the top-level
    build directory whereas the OUTPUT is specified in the current (lib/)
    directory.  This leads to unnecessary relinking of all the libraries on
    each make invocation because OUTPUT is always missing.
    
    Fix this by outputting the file in the current directory where OUTPUT
    can find it.
    
    No functional change, just makes rebuilds quicker.
    
    (cherry picked from commit a25d881f287e67568c15a87c9fc9a2c4acc0650e)

commit 0d31493f00098c71f41755e61439f97d593fc48c
Author: Maxwell G <maxwell@gtmx.me>
Date:   Wed Sep 13 02:29:41 2023 +0000

    Add a Provides generator for rpm lua modules
    
    Some packages in Fedora provide shared RPM lua code that's used by other
    packages.
    It would be nice to have automatic Provides for this code like we have
    for rpm macros themselves.
    
    Usecase:
    
    Recently, forge.lua that's used by go-srpm-macros and fonts-srpm-macros
    moved out of redhat-rpm-config.
    I would like to be able to add `Requires: rpm_lua(fedora.srpm.forge)`
    to those packages instead of having to rely on it being implicitly
    pulled in by redhat-rpm-config or adding conditional dependencies on
    forge-srpm-macros.
    
    (cherry picked from commit 6867ef9f8bf6b0aba86d390fe371d3b141df9013)

commit f9882c22bf439bba101d244e45b01b2dd1c2dcc7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 15:51:32 2023 +0300

    Add a testcase for librpm development
    
    Should've been in 6ec0e4069e61fca3a5391c65effe72b2c782730d but at that
    time cmake in Fedora had a dependency on rpm making this hard or
    at least ugly. With that dependency fixed, we can now run cmake in there.
    
    (cherry picked from commit 1120c8cf7c6041c523bcc917173b931560747b91)

commit 0f784aaa25921a8dc9ff0b0172627bbff837257d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 13:19:37 2023 +0300

    Drop top-level source for our global include directories
    
    Having everything accessible to everything encourages fast and loose
    includes from places one shouldn't be using, and makes it easy for
    those cases to hide in plain sight as well. There were reasons for
    the top-level include back in 2007 but our codebase is a rather
    different beast these days. Limiting access through per-target
    include directories on everything nicely highlights the exceptions
    and makes the whole more controllable and manageable.
    
    This change looks huge, but it's just due to stripping no longer valid
    prefixes from all the gazillion internal includes. No rpm-side
    functionality is affected, this is just source-level hygiene operation.
    
    (cherry picked from commit 1c98b67911e19a5f92c7fa4492aaa1000a06edad)

commit c563f0f8f9513b3afc7c10799bbc31eac3185f99
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 12:36:11 2023 +0300

    Move all cli utility sources under tools/
    
    Having stuff in the top-level directory is messy, and the top-level
    cmake file is plenty big enough without all this. No code changes,
    no functional changes.
    
    (cherry picked from commit 86d99a1d20bbebfeb4427c99b1bb1053029c3317)

commit cf14836ff08d35e5c2344ddd54874010a02c959f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 12:48:16 2023 +0300

    Move rpmhash.[CH] into misc/ for clarity
    
    These are nothing like normal sources and are not compiled into librpm,
    but having them in lib/ makes it appear they are. Which also confuses
    the issue of where they are usable which is everywhere within the source
    tree, not just places linking to librpm. No functional changes.
    
    (cherry picked from commit 13eb82e9bfe424fdc56b967b7126267ab6edcc32)

commit 5308d1c89280f36a9d075e87510ebcb51b830154
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 12:29:28 2023 +0300

    Move top-level headers to misc/ and include that everywhere
    
    Having stuff in the top-level directory is messy and prevents control
    over what you can include from where. No functional changes.
    
    (cherry picked from commit d4eb1f2fe6f8712f874becbd10f29a3a542bed46)

commit 069b79e7454e9b38f4827a237212e0ae8b99e6dc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 12:21:24 2023 +0300

    Split our include_directories() per use-case, comment
    
    No functional changes.
    
    (cherry picked from commit 74783883cb46a28c3b1015a6f35513b318481b51)

commit cb68ea37f9871f1f1c67aaa790634aded88ee9c1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 1 15:42:35 2023 +0300

    Drop no longer needed pull from updates-testing for rpm-sequoia
    
    rpm-sequoia >= 1.4.0 has been in stable updates for a good while now.
    
    (cherry picked from commit 2085295187877fdbb23bd1314a2e283b49582146)

commit 66ac70a597ba95517dfb8495e9e1a9ef254c37ea
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Sep 19 12:06:02 2023 +0200

    Preparing for rpm 4.19.0 release

commit 5f595dbfecd141ebf2d77735aa710b2656779319
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Sep 13 10:48:07 2023 +0300

    Fix compile regression from 071be753cf05b2753efb0d3c51d4fa59b9641d09
    
    A declaration immediately following a label is not valid C99, as crazy
    as it is in a language that otherwise allows free placement of declarations.
    It looks like something people forgot to update in the standard, first
    in C99 and apparently C11 too. Recent gcc doesn't complain about it
    but it doesn't make it right.
    
    Suggested-by: Dmitry Mikushin <dmitry@kernelgen.org>
    (cherry picked from commit 34d983fa2a9b9276fc540b6bd554605b2c72689a)

commit 347cd05f93f8639a964331015eeb88e083295351
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Sep 4 10:39:26 2023 +0200

    Preparing for rpm 4.19.0-rc1

commit 4bcda7344505ce2368b5e02867725d5df9aadd3d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 14:33:36 2023 +0200

    Update translation submodule for new translations
    
    (cherry picked from commit 4a12e3fc2163a1b61958be438db9d6a6ccee66f0)

commit 14905a3e7cab8ac760a7d9460204f506fb7d0c5d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 1 15:26:18 2023 +0300

    Always run tests without --nouser and --nogroup, now that we can
    
    With the new container based test-suite we no longer need these hacks.
    Leaving the mknod conditional in place though as that may still be
    restricted.
    
    (cherry picked from commit 7d017eef51bd3138aad0a7859e76e7bfafd3951a)

commit 5c061827c09ccaf976210fe88e9aad421b543dbd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 1 10:39:08 2023 +0300

    Run the test-suite with plugins enabled now that we can, yay
    
    (cherry picked from commit 4712c9c37bbf28f56f1e386df788dac440cc4cb8)

commit 3045b776ce511d030da5fbd92d4fceb73521f066
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 1 10:33:41 2023 +0300

    Emit a debug message instead of silence when DBus unavailable
    
    Make systemd_inhibit plugin behave identically to dbus_announce in the
    previous commit: when DBus service isn't available, emit a debug level
    message rather than completely suppressing the message to keep things
    troubleshootable.
    
    (cherry picked from commit 5f23d76eb90d17daa80732295fd74d01681d765f)

commit c7ab4cfa9c61dc1cb4bcba7dc45e9e18aece0a85
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Sep 1 10:25:03 2023 +0300

    Suppress inhibition lock warning message when DBus service is not available
    
    Same as commit 708e61307bc3fd027b016fdf5a1d1a5274c1843c, this message
    will just annoy and confuse users in situations where DBus service is
    not running at all, such as single-user mode and minimal container type
    environments. Like our own test-suite. Rather than entirely suppress
    the error, issue a debug log though.
    
    (cherry picked from commit 071be753cf05b2753efb0d3c51d4fa59b9641d09)

commit 94a95a32298488a0a46cb73149a8f13c72e10154
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 15:03:33 2023 +0300

    Export our libraries as a cmake find_package() config
    
    This is a fair amount of annoying voodoo boilerplate compared to what I
    would've expected, but the ability to just `find_package(rpm)` is
    very nice on the (API) user side.
    
    Fixes: #2471
    (cherry picked from commit 6ec0e4069e61fca3a5391c65effe72b2c782730d)

commit c37b466f6eace5a75f6c3a0baafdf119351b147a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Aug 31 09:55:52 2023 +0300

    Clean up hashtype definitions
    
    Always #undef the "parameters" right after definition to make sure
    they're always free for the next user. Which avoids annoying
    double-undefs all over the place.
    
    (cherry picked from commit ffd55686abdfdadf6d854be18e52fa7536dadc8f)

commit be7e30d5b6f18c9ce6c1a476395c3aa661e89204
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Aug 29 13:19:15 2023 +0300

    Document the main differences between rpm-sequoia and internal parser
    
    Fixes: #2346
    (cherry picked from commit 5f98b1aa4817d5923caef42208e32eb34094e94b)

commit 944c218235cb06e4e54988e492478e03b5e03ecc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 28 17:14:45 2023 +0300

    Add a build tunables section to the reference manual
    
    The descriptions are terse and I've inevitably missed a whole bunch
    of stuff here, but it's a start.
    
    Fixes: #2466
    (cherry picked from commit 3687458aa0e02e7d2fe50a028693a93260628446)

commit a7834728ac40edf89978c6437f78d10f28916fb5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 28 16:22:56 2023 +0300

    Drop an extraneous Dependencies section from the spec manual
    
    (cherry picked from commit 33c0478f96122cb8f1e8191a1879379822e0a9a7)

commit d96d6380fce322001846625d2f804fe207f3960a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 28 16:20:45 2023 +0300

    Polish the build process docs a bit
    
    Replace source links to documentation (we have it now!) and various
    more cosmetic tweaks.
    
    (cherry picked from commit c10877b6bcceb99eae8b0df97ee25bcc82bbb9e3)

commit e01c49b726df1d39610c50bc1d94ac0c6fbd832f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Aug 23 13:22:07 2023 +0300

    Fix misleading error message on some invalid filetrigger conditions (#2584)
    
    We used to test the first argument in parseScript() and then again
    for all arguments in parseRCPOT(), with different error messages in
    each case as if they were separate issues. Only, the one in parseRCPOT()
    didn't get a chance to execute because it was caught by checkDep() before
    it (probably added after the file trigger check was initially added) and
    so for invalid file trigger conditions (such as an unexpanded macro), you'd
    get a very misleading error about dependency tokens where an absolute path
    is expected, and worse, it was reporting an incorrect line and a line
    number while at it.
    
    Measure twice, cut once doesn't apply here. Check once and be consistent
    about reporting it. Due to the way triggers are handled, we can't
    report the line number correctly so don't even try, the wrong line
    number is far worse than not having it at all. Add some tests to go.
    
    Fixes: #2584
    (cherry picked from commit 21457de886faf2415500a8bb7cc6c816d72939ef)

commit f5530bb54120b2d2a8ae0fb152c222b4fb8a1b39
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Aug 15 14:52:50 2023 +0300

    Default to C.UTF-8 locale, allow fallback to C
    
    Mostly everything around us is UTF-8 these days, we need to get on with
    the times. Especially now that glibc >= 2.35 finally supports it too.
    Default to C.UTF-8 but allow disabling it via cmake option to fallback
    to the traditional C locale instead.
    
    Fixes: #2587
    (cherry picked from commit 3be76d71448279a29674cba753fc7ad811b7931c)

commit 653796bc82cc311f6af7ebd2ff6f8b99aa481794
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 21 13:42:43 2023 +0300

    Behave more consistently when target arch %optflags are not defined
    
    You're about to fall into a deep dark hole, proceed at your own risk.
    
    When building for a target architecture with no defined %optflags
    (such as noarch), one would think that %optflags would be empty. Not so in
    rpm, instead we get %optflags for the detected architecture, and there
    are packages which rely on this behavior. And in this particular dark
    corner, buildarchtranslate is not applied so one can get drastically
    different %optflags than you'd get without an explicit --target, on the
    same system. Which can break builds.
    
    This behavior is just WRONG, %optflags should always reflect the target
    architecture. But as long as there's no %_host_optflags, lets at least try
    to be consistent about it. When we fall back to detected architecture
    %optflags, at least use the ones after buildarchtranslate to return
    consistent data within a host.
    
    This supposedly fixes the case where our newly added x86_64
    subarchitecture definitions haven't been overridden in vendor config and
    somebody's noarch package uses cmake to install data, and falls over due
    to nonsensical optflags from rpm.
    
    Initial report: https://bugzilla.redhat.com/show_bug.cgi?id=2231727
    
    (cherry picked from commit 59bbb932e5a546152a28cea9036958c324669b82)

commit db2dbbd1e91a0bc2f6be1a0e65dd0dced9f974a8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Aug 22 14:03:37 2023 +0300

    Move the %_sysusersdir definition to a more logical spot
    
    Commit c7fd9fed9951dc884c345eb9280987389b291c41 introduced %_sysusersdir
    into the group of global configure-related macros but that's not what
    it's related to at all, it's only related to our sysusers integration
    feature. Move it where it really belongs.
    
    (cherry picked from commit 0e336e24c927b892dc63f723f3b85b066e5bddc6)

commit da078bc2f4401ce282a307c3b0209b65e5b8bd63
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Aug 22 13:42:27 2023 +0300

    Revert recent %_root_prefix macro addition (RhBug:2233454)
    
    Commit cececfb6851234aca3e8d102de1c192c6bdf3e67 introduced %_root_prefix
    macro but this clashes with pre-existing use in scl-utils:
    https://bugzilla.redhat.com/show_bug.cgi?id=223345:
    
    Just query the value from pkg-config if available and otherwise use
    hardcoded value pointing to /usr instead. We don't need an intermediate
    global macro for this.
    
    (cherry picked from commit 24f974cff9e9559f3ab308661572740ea432f2a3)

commit 38f298099beb5b2f1d07884bd893e8a72be61207
Author: Daan De Meyer <daan.j.demeyer@gmail.com>
Date:   Thu Aug 3 21:36:43 2023 +0200

    Add aliases for weak dependency queries to rpmspec.
    
    These are all available on the rpm CLI so let's make them available
    on the rpmspec CLI as well.
    
    (cherry picked from commit aa0d6d8109b9d43188873f3c8e51d106cc061f5d)

commit ac726afff04622ccebfeac38935ea2e540020db5
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 17 18:02:07 2023 +0200

    Avoid warning about double --chdir in "make check"
    
    Newer versions of Bubblewrap emit a warning for some select options
    (--chdir included) about only the last occurrence having effect, which
    is what happens in "make check" due to the --chdir override.
    
    Instead, just cd to the /srv directory in a shell and then run rpmtests
    from there, sigh.  It's not the prettiest but it's better than always
    printing the spurious warning.
    
    (cherry picked from commit 5e9c71296e8cd6c5f2f5a6188b303bbd7a2c74db)

commit 387df13126999e42d67fd6ca27a27bdda8a59a64
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 17 15:40:06 2023 +0200

    Prevent build dir from becoming annoyingly sticky
    
    With OverlayFS and unshare(1) being used in the test-suite, some of the
    directories in the test tree, sandbox and rpmtests.dir/ end up missing
    read/write or execute (for directories) permissions which means removing
    them requires excessive force in the form of "unshare -r rm -rf".
    
    CMake is clever enough to adjust the permissions behind the scenes on
    "make clean" but manual removal should just work too, so fix that with
    chmod(1) in the clean_up() trap.
    
    (cherry picked from commit 94ee5c6c23168ebcaa96e992414af4049844e933)

commit ee49da9e5abbf5236bd0e90a3c491f7a9aeb43af
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 17 17:25:49 2023 +0200

    Move exit trap to a function in mktree.fedora
    
    This is more flexible as we can now add more commands to the trap, see
    the next commit.
    
    No functional changes.
    
    (cherry picked from commit 4fa00264308056d5db26f29707a381ff10141caa)

commit 89f983d83e9a7956ee5eeed611261b4aaa3751a4
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 17 14:00:08 2023 +0200

    Enable DNS resolution in "make shell"
    
    Networking is currently enabled in test containers (we don't use
    --unshare-net) but for domain names to be resolvable, we need an
    /etc/resolv.conf, too, so add it from the host, similar to how e.g.
    Podman does it.
    
    We don't need network access in the test-suite but it can be handy for
    interactive testing in "make shell", e.g. to allow gdb to fetch
    debuginfo data through debuginfod automatically.
    
    (cherry picked from commit 87f1b4545bfdd6d5d09e9c8bb31f8fb96d5313aa)

commit b4eeac2fd414cbc80194b0350b07f4357f951800
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 19:10:29 2023 +0200

    Export the same DNF command-line in "make env"
    
    When managing the test tree with DNF, it's actually desirable to use the
    same options that were used during the tree construction (especially the
    cachedir), so just do that.
    
    (cherry picked from commit 3701e4893ea9f758abad0bff907096d33bafb693)

commit dc2a90f1ca47ab65e17642c5047c3f573b67965c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 17:38:33 2023 +0200

    Extend the MOTD in "make env" with a bit more info
    
    (cherry picked from commit c3ecf8ac443477d1a6c9ea7fa3ca0d1cdca6776f)

commit 471c39fcecb5dd75e4dc9c3da033bd37c284196d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 17:23:38 2023 +0200

    Terminate stray bwrap processes on test failures
    
    (cherry picked from commit 8e9ff82f5559001722766cb13abb5c81f41efda4)

commit e36e87e5e912559040ef58cabcc85d11a2d0babf
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 16:20:50 2023 +0200

    Point RPM to correct database in Dockerfile
    
    This just mirrors what mktree.fedora does already, and is only relevant
    in "make shell" when using the mktree.podman backend, no other
    functional change here.
    
    (cherry picked from commit db35781bf1a3a0f10e101759d8421cdeb2cc56c1)

commit 333a978f77f12a54d7dc7933b171e0709d3135f3
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 13:59:27 2023 +0200

    Set standard, consistent HOME path in tests
    
    Use /root instead of / (in runroot) or $PWD (in atlocal).  We already do
    this in "make shell" so that the root user's dotfiles (e.g. ~/.bashrc)
    are loaded from the base image, this commit extends that to "make env"
    and fixes the following:
    
      - Calling "runroot rpm -qa" interactively now works as expected since
        the rpmdb from the base image built by mktree.fedora (which
        overrides %_dbpath in /root/.rpmmacros) is used
    
      - The user's native prompt is now used, instead of the shell's default
    
    This commit has no effect on the tests themselves since we initialize an
    empty rpmdb before use anyway.
    
    There was no technical reason for HOME being set to /, really, other
    than it being a historical artifact from the fakechroot era.
    
    (cherry picked from commit 258548166223eb5544d7e644a8fd9d8f4b363474)

commit 800427ca86ac87a5833c52a773983e0b2968e7ef
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Aug 16 13:31:01 2023 +0200

    Fix infinite recursion in "make env"
    
    Using which(1) in a shell function that's supposed to shadow the
    original command is silly, it just results in a recursive call.  What
    was I thinking?
    
    Instead, use "command" which is a better fit, see "help command".
    
    (cherry picked from commit 1c3264ed887472e500d35638b81cdfa2e071d7d8)

commit a60b981eb1a05bdc0db271485f77e5ffb1926e7a
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 10 17:38:19 2023 +0200

    Clean up dnf() function in "make env"
    
    The "function" keyword is not needed (not POSIX either) and which(1) is
    better than hardcoding the path.
    
    No functional change.
    
    (cherry picked from commit 44c76481e75342b6f9e1994d1bb7f83575341c55)

commit cb705c766ed836aa5704fb2e8fb493062cc5527b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 10 14:28:51 2023 +0200

    Simplify BYPRODUCTS in "make tree"
    
    The inner structure of mktree.output/ should be treated as an
    implementation detail of the mktree backend in use.  All we care for
    here is that it's purged on a "make clean".
    
    No functional change since only mktree.fedora uses this directory
    currently and it already recreates the other contents (inst/) on each
    rebuild anyway.
    
    (cherry picked from commit ebd0905a3f78fd7d8e28125b00f78a069427c852)

commit 17ff3d2f704c339fdd54c1279d304e89e4f9a2c5
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 10 14:27:32 2023 +0200

    Support common mktree.fedora image in build dirs
    
    Using multiple out-of-source build directories (e.g. for topic branches
    or experiments) currently means redownloading and recreating the base OS
    image in each of them.  This is slow, ineffective and just not needed
    since the image isn't specific to the build and can just be reused.
    
    To fix it, if a mktree.output/ directory exists in the source directory,
    use that, otherwise just use the build directory like we always did so
    that all build artifacts remain in the build directory unless told
    otherwise (which some may prefer).
    
    This means the feature can be enabled by simply creating an empty
    mktree.output/ directory in the source directory.  This is inspired by
    mkosi(1), much like many other things in mktree.
    
    We shall document this later, too.
    
    If the source directory happens to be a git-worktree(1), go look into
    the common worktree for mktree.output/.  This ensures that worktrees, if
    one uses them, are not treated as separate source directories and will
    reuse the same image, too.
    
    If using a common mktree.output/, also use a common mktree.cache/ (DNF
    metadata and package cache) as separating those two makes little sense
    in such a case.
    
    (cherry picked from commit e1ff74c4e5376bc844a244687537fef81145e2bf)

commit 6b1f9e827948db32168c12bdd996cb7a76eb818b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Aug 16 10:18:20 2023 +0300

    Stop looking for apparently non-existent 7zip command
    
    Since the initial commit 185596818f763af1249f19161f38134ee93092d2, we've
    primarily looked for a command named "7zip" but defaulted to 7za when
    not found. Looking closer it seems that there never was any command
    called 7zip at all, at least in the OSS landscape. So don't default to
    something that doesn't even exist, which also means we'll land on an
    actually working value if/when 7z[a] doesn't happen to be present at
    build-time (there's no other reason for it to be there).
    
    Related to #2608
    
    (cherry picked from commit 095502dc0933731eb5a8e877e1c383b8c5e7af44)

commit 79c31962628001cd117fe17d89cbcc97f87e0fe8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 14 12:31:06 2023 +0300

    Look for alternative implementations of 7zip, like autoconf did
    
    Fixes a regression from the cmake transition where we'd just assume 7zip
    as the name of the executable when previously we looked through 7zip,
    7za and 7a. Resume the former behavior.
    
    Fixes: #2608
    (cherry picked from commit f9775b454e1969a8d5c8d8b7435817876ed79482)

commit 7fb96740fa7d38011f67b45589a2fe58fd868287
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 14 12:29:11 2023 +0300

    Unroll the utility finding loop in cmake for flexibility + readability
    
    We need more flexibility than a simple array can provide, and with
    all the name munging, it's not particularly obvious as to what
    values are set and how. Supposedly no functional changes here.
    
    (cherry picked from commit bbb289e303d8c72b9e35410e593b8d92b006bec1)

commit 75546263f11b5da294d2e4e7dfc08e9aa78c063a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Aug 14 09:58:20 2023 +0300

    Remove duplicate line
    
    Initially accidentally added in 9e8f57bf7abdc26262467d20c5a636547c09a277
    and then amusingly commit 1bd14464b9c6206602d1553fd24db7385e64ef55
    indentation fixed.
    
    Fixes: #2613
    (cherry picked from commit 194eb101663b721810096097458c582530e9c3fa)

commit 87da0b5b926db5d4f3ac48c46676b8747db54b60
Author: Dirk Müller <dirk@dmllr.de>
Date:   Tue Aug 8 13:53:38 2023 +0200

    Rewrite --last to just use sed for formatting
    
    This is the only dependency on awk in the runtime commandline part of
    rpm, which is bloating minimal container images a bit. We can rewrite
    that into a single sed statement. We love you anyway, awk.
    
    (cherry picked from commit 224095542246e762617d38e2096fdeba13d266e3)

commit 1fbd827ec67dbb8287fd698da90eac453569bf23
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 3 17:01:17 2023 +0200

    Bump actions/checkout from v2 to latest (v3)
    
    This should've been part of the previous commit, just got forgotten.
    
    (cherry picked from commit 2043f2ac57ae2690cc1b11242f040085df8eed83)

commit f56caf48f64b86a42fbef56bb88ac90b0e625504
Author: Neal Gompa <neal@gompa.dev>
Date:   Fri Jul 28 01:16:24 2023 -0400

    CI: Add initial GitHub Actions configuration
    
    Fixes: #2569
    (cherry picked from commit d4cad0f26aec183e9eb4f42533b91b30c0c04e80)

commit f38ecc573c622d66a9eb8c5570fc28d54682b09e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Aug 3 15:46:52 2023 +0200

    Add support for --interactive in mktree.podman
    
    Pass this option, if specified, to $PODMAN.  This is needed for
    unattended use of mktree.podman where no tty is allocated, such as
    GitHub Actions.
    
    Use it as follows:
    
      ./mktree.podman check --interactive=false ...
    
    Default to true (by keeping -i in the command line) still, it allows
    CTRL-C to work when running the script interactively.
    
    Based on a patch by @Conan-Kudo.
    
    (cherry picked from commit 23875394605183c62db010b3d7bba9a4c5d656e1)

commit 9cc14f2c1b6d63ec48b93ab0a00af2a78309ed50
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 10:25:24 2023 +0200

    Preparing for rpm 4.19.0-beta

commit cd3fa8a5491d0e9d1575ccad4b72e5feeea70443
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 14:33:36 2023 +0200

    Update translation submodule for new translations
    
    (cherry picked from commit 39ebe1e62333ebe811b8825f3caa0ecbff631328)

commit dd2ccea54b57d4e55f505e136b32f1e71314ee1f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 12:21:01 2023 +0200

    Add back ima-evm-utils to mktree.fedora, oops
    
    We actually do need this library in the test tree, in case the build is
    configured with -DWITH_IMAEVM=ON which links librpmsign to it, it's not
    a plugin.  We already include libfsverity for the same reason.
    
    This is a fixup for commit 4c41faf7a592a5bb484cf7d645cc247d850d776a.
    
    (cherry picked from commit 1d8a67485fff3d770b5cb4072b1558d9fad91f54)

commit b683e4d1c021d7f94eb78660516a27ba88dbd79c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 10:37:24 2023 +0200

    Remove forgotten ENABLE_CI cmake option
    
    We no longer have the ci/ directory as the Dockerfile has been moved to
    tests/ and the "make ci" target is now added automatically if Podman or
    Docker is available, so no need for ENABLE_CI anymore.
    
    (cherry picked from commit 02a5151e3eaca789fbf565ee6e7e07f0d5f6d25a)

commit baccabac04c7f36252450b5b2a54a3dfed60f2db
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Aug 1 11:27:11 2023 +0200

    Add back Docker support to CMake
    
    When using the mktree.podman backend (either through "make check"
    directly or "make ci"), detect and choose Docker if Podman is not
    available.
    
    This fixes a regression from the original "make ci" where we also
    supported Docker, and should've been part of commit
    3b2e5eba187feef56b113a59e88aa05634a471d3.
    
    (cherry picked from commit 35a3d229300338fd448373acc27b99a170bebaa7)

commit 323d0e0c27c528c08e70bf02f84082addccd59f8
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 31 14:03:10 2023 +0200

    Minimize the package set in mktree.fedora
    
    We don't need audit and ima-evm-utils, those are for the plugins which
    we disable in the tests.  We do, however, need popt and shadow-utils
    (pulled in by the above) so list those explicitly.
    
    This also conveniently removes systemd (pulled in by audit) which we no
    longer need since commit 2bdd7d7cbd77b13abf512bb919abe7f0537a2c45.  To
    future-proof, though, exclude systemd-udev which is not needed in
    containers.
    
    Lastly, remove gdb-headless which is redundant since we already install
    gdb-minimal.
    
    As a nice side effect, this fixes the spurious warning during the DNF
    transaction that comes from systemctl(1) through the %systemd_post macro
    used by audit (about requiring a /proc mount in the installroot).
    
    (cherry picked from commit 4c41faf7a592a5bb484cf7d645cc247d850d776a)

commit 3ef4f7e045509432c01586d321b61e4c7102c270
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 31 13:59:31 2023 +0200

    Disable systemd-inhibit in mktree.fedora
    
    This plugin doesn't work with --installroot and only prints a spurious
    warning, disable it.
    
    Refactor the contents of .rpmmacros now that we have more than one line
    in it.
    
    (cherry picked from commit d7f7c8b1d3abba725a2d518a0cacbae833be4b9e)

commit 069d628a80708d591297aced6870926f615a7b1f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 28 14:34:25 2023 +0200

    Merge mktree.native into mktree.fedora
    
    Don't make any assumptions about how other Linux distros would need to
    implement the mktree interface.  We simply don't know how much logic
    could be shared between such native backends before some are actually
    written.
    
    Right now, we only have one such backend, for Fedora, that's a sample
    size too small to draw any conclusions.  Let's worry about refactoring
    when it actually makes sense and stick with the most basic layout till
    then.
    
    As an example, while unshare(1) works for running DNF as an unprivileged
    user, it does not seem to work with other package managers and tools
    that I've tried such as zypper or debootstrap.  Those may need another
    way of doing this or even require sudo(8).  Also, --map-auto only exists
    in the newer unshare(1) versions, older versions would need manual
    mapping.
    
    This also simplifies the "env" command quite a bit, which is nice.
    
    No functional changes otherwise.
    
    (cherry picked from commit a1ca8e345d08e45705b9361bf4a366ed65c0c5a8)

commit 80a88fd051f286c7ef46ef743d8a7e09875c5db5
Author: Zoltán Böszörményi <zboszor@gmail.com>
Date:   Fri Jul 28 12:16:56 2023 +0200

    Allow setting platform macro settings externally (#2585)
    
    * Allow setting platform macro settings externally
    
    By default, rpm installs a series of default platforms based on
    the CPU architecture names in subdirectories called
    
        /usr/lib/platform/<arch>-<os>
    
    This is enough for regular Linux distributions. However, some
    distributions may use more specific platform names that refer to
    particular computer systems, like SBCs or specific CPU tuning when
    compiling.
    
    If the platform subdirectory does not exist in /usr/lib/platform
    then rpmbuild does not work.
    
    Allow creating such custom platform subdirectory with feeding
    the necessary data using external variables: RPM_CUSTOM_ARCH,
    RPM_CUSTOM_ISANAME, RPM_CUSTOM_ISABITS, RPM_CUSTOM_CANONARCH
    and RPM_CUSTOM_CANONCOLOR
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>
    
    ---------
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>
    Co-authored-by: Florian Festi <ffesti@redhat.com>
    (cherry picked from commit fde03ae33d55b160a31a6c54946880dcdf8fd0d6)

commit ccdca0973243c6ed197cdaf0f21b3ac49b4e9e37
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jul 28 09:46:01 2023 +0200

    Set default shell to /sbin/nologin
    
    as this is the default location. Moving the the /bin and /sbin content
    into the /usr directories is a distribution dependent thing inherited
    from the Fedora script.
    
    (cherry picked from commit 077afb85925d04067ebd38bfa520cec0e36f5bbf)

commit 0f3e44803080c679762155d652ec314ec0877f68
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jul 25 12:08:42 2023 +0200

    Check inside --root when querying for files
    
    rpm -qf checks if the argument actually exists if it can't be found in
    the rpmdb and gives different messages based on that.
    
    This was done without taking the root dir into account leading to wrong
    messages if the file only exists in the root dir but not outside.
    
    Resolves: #2576
    (cherry picked from commit 3e820eaa4c8cb94a63338366cbf014dc5264eba2)

commit 42b82d9a550ade799a4a16a02661fce451b9a7e9
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jul 26 15:01:35 2023 +0200

    Duplicate filename before passing it to basename
    
    basename is allowed change the string passed to it. While we don't need
    the filename after that just casting away the const seems a bit too
    hacky.
    
    (cherry picked from commit 3fa2ae78db9b31edb4c22f3b5cd36c6c972947f1)

commit 8457ad0b55e585bf97bd577bbcfc65853f3dc2fd
Author: Calvin Buckley <calvin@cmpct.info>
Date:   Tue Jul 11 19:22:41 2023 -0300

    Fix missing basename include on macOS
    
    (cherry picked from commit b2e67642fd8cb64d8cb1cca9e759396c1c10807d)

commit 31d1f8ca096f1947920743f6c79a4d1ea100aa9e
Author: Calvin Buckley <calvin@cmpct.info>
Date:   Tue Jul 11 19:16:11 2023 -0300

    Fix missing signal.h include
    
    macOS doesn't include this by default, so the signal functions
    won't be found with -Wimplicit-function-declaration.
    
    (cherry picked from commit f07875392a09228b1a25c1763a50bbbd0f6798c2)

commit 5b9dfee24163ca54e4db3cd729dcd5b10894eda2
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jul 14 10:45:01 2023 +0200

    Replace systemd-sysusers by new sysusers.sh script
    
    for user and group creation. It creates system users and groups based
    on files in the format described in sysusers.d(5) using useradd and groupadd.
    
    Only supports the --root, --replace and -help parameters.
    
    (cherry picked from commit 2bdd7d7cbd77b13abf512bb919abe7f0537a2c45)

commit dc2303fab04a05b3c7c1494125bb9da3da714177
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jul 25 21:25:49 2023 +0200

    Mount the common tree snapshot as read-only
    
    This ensures no single test can (accidentally or intentionally) alter
    the shared tree and influence the subsequent tests.
    
    It also makes us comply with the following OverlayFS requirement:
    
        Changes to the underlying filesystems while part of a mounted
        overlay filesystem are not allowed. If the underlying filesystem is
        changed, the behavior of the overlay is undefined, though it will
        not result in a crash or deadlock.
    
    This could have previously been violated when running parallel tests.
    
    Contrary to what I thought in commit
        cf8716f204f1eed196ca7ae905288261e0c88c3b,
    to make this work, all we need is to mount a new tmpfs at /tmp in the
    snapshot, as that's where some of the processes (patch(1) in particular)
    need to write.
    
    Update the comment in mktree.rootfs accordingly, too.
    
    (cherry picked from commit 68a36d1d857fb2ec362d757cff08b41d26b7e267)

commit de61899d78d25d0ccdc8a5d19dfb2f6c87b03b82
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 24 21:39:10 2023 +0200

    Add mktree.podman backend
    
    This backend uses Podman with the bundled Dockerfile to build the test
    image.  RPM is built in a container as that's part of the Dockerfile.
    
    This makes the test-suite more portable since only Podman needs to be
    installed when using this backend.  That's especially useful in a CI
    environment where we may not have a native backend for whatever OS the
    VM is running, e.g. Ubuntu LTS in Semaphore CI.
    
    Since it must be able to run without a build system in place, make it
    also usable as a standalone script.  For more portability, allow for
    Docker to be selected in place of Podman by invoking it via a symlink
    (multi-call).
    
    We used to have a "make ci" target previously, add it back now and point
    it to the script.
    
    Make it also serve as a fallback backend now.
    
    (cherry picked from commit 3b2e5eba187feef56b113a59e88aa05634a471d3)

commit 87c30c7ddb420160cbcac903ed178af0f792fb98
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jul 25 17:12:46 2023 +0200

    Add mktree.rootfs backend
    
    Useful when building RPM in a disposable container or VM, see the
    comment block for details.  This is also a prerequisite for the next
    commit.
    
    (cherry picked from commit d30f55fde01985e85705358cb308f7253571d86e)

commit 040942f2ac986dad3cd397c574889181b9586aba
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jul 18 10:57:22 2023 +0200

    Refactor cmake
    
    No functional change, just prepare the ground for the next commit.
    
    (cherry picked from commit 750923966a19e87306f14911f0ba5aca1e24c632)

commit 7d7568cd16e161ea4b84d806a4a65101cd4ae5db
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 24 21:48:33 2023 +0200

    Add mktree.common
    
    No functional change, just prepare the ground for the next commits.
    
    (cherry picked from commit fb7835ba94ff5a008f594f98b0a988214b2d1986)

commit d790435fdf09764c72ead9ce89c2d6e3e1fd4cc9
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 15:54:41 2023 +0200

    Turn Dockerfile into a standalone RPM image
    
    So far we've only used the Dockerfile for *building* RPM and then
    running the test-suite in a container.  Make it actually useful for
    building a complete RPM image out of the source tree.  That's the
    typical purpose of a Dockerfile in a project, after all.
    
    Not much is missing, just basically remove the stock RPM installation
    and replace it with our own.
    
    After this commit, one can just run
    
      podman build -t rpm -f tests/Dockerfile .
      podman run -it rpm
    
    to get a shell with the current checkout built and installed, as a
    podman-based alternative to the native "make shell" support.
    
    To run the new test-suite (in our CI) using this image, a bit more work
    is needed so we'll leave that for the next commits.
    
    Also add a .dockerignore file so that the _build subdirectory that we
    "officially" support is not needlessly copied to the image if present.
    
    (cherry picked from commit 4ecdaee453e5a128cada8fa9ed3d8304120baf68)

commit 57193a1f677b90c4bf331e3f6ea8980c84cdc202
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 15:53:45 2023 +0200

    Drop ci/ directory, move Dockerfile to tests/
    
    Leave Dockerfile.debian out for now as it would need adjustment to the
    new test-suite and that's not really the focus right now.  It was only
    experimental at this point and not really used in CI, anyway.  We may
    add it back at some point, though.
    
    This is in preparation for the next commits.
    
    (cherry picked from commit 53df9991e1d69ac0abc1d56747d8963726ff379c)

commit 9f8d6a3ea119b96254a52084df1499f05a3a7785
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 24 18:38:06 2023 +0200

    Add support for mktree backends
    
    Choose a suitable mktree implementation ("backend") at configure time.
    Prefer one that's named after the host OS but allow to override.  Turn
    the existing mktree into a template and move the Fedora bits to a new
    Fedora backend.
    
    This allows the test-suite to support other (Linux) distros on the host,
    provided that someone writes and contributes backends for them.
    
    It also allows for supporting completely different image building
    methods which is what we're going to do next.
    
    (cherry picked from commit 23944be20b288cae0b9317309c629bd4a2cea187)

commit c444b478ff6c338e6d2e160876f1173ef9779758
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 24 21:45:01 2023 +0200

    Rename mktree.in
    
    No functional change, just prepare the ground for the next commit.
    
    (cherry picked from commit c779f5d3e529ceb44c364f591f68b4ee38ad9dd2)

commit 2fa5b1932f5f9ce18e861e9d3fc8e7cee1e30bfd
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 10 19:38:54 2023 +0200

    Place TESTPROGS binaries into PATH
    
    This makes the test-suite script standalone so that it can be run from
    any location in the filesystem (provided that atlocal is adjacent to it)
    which will be useful in the next commits.
    
    (cherry picked from commit 8ff93e71fd3600ceb731d40892be88818e6e8a96)

commit 6fb6c862c9a8a4be7078ba64c29a6435dd0cd843
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 24 17:19:11 2023 +0200

    Add convenience DNF wrapper to "make env"
    
    (cherry picked from commit 3d0f2d79a874f664a962792937a4f22a27c1f800)

commit 0a3ac8c13cf4bf77f749431de6d9ec1b0a5a769d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 20 16:43:00 2023 +0200

    Base per-test snapshots on the root filesystem
    
    Now that we mount a snapshot at /, we don't need the other one, so drop
    it and refer RPMTREE to the former.
    
    The snapshot must remain writable due to some of the tests launching
    programs that store temporary files outside of the test directory, e.g.
    those using run().
    
    This means per-test snapshots will now be based on a writable tree,
    however that's fine since no single test is (or ever was) supposed to
    make destructive changes to the root filesystem anyway.
    
    (cherry picked from commit cf8716f204f1eed196ca7ae905288261e0c88c3b)

commit 1c9b5243d92f7d2cacb020b5fb70fe21b317997e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 17 10:37:01 2023 +0200

    Containerize the whole test-suite
    
    Run the rpmtests script itself from within a writable snapshot instead
    of natively.  This prevents a misbehaving test from accidentally
    modifying the host filesystem.
    
    It also makes the setup a whole lot simpler since we no longer have to
    mess around with various environment variables just to make the binaries
    launched without runroot() work off of the tree.
    
    This new setup makes the test-suite simply exercise the RPM installation
    in the root filesystem and lets mktree do the job of setting that up.
    
    (cherry picked from commit 1592f160f506f80c0701757d4b4f0b5be18329ce)

commit 8f2c03676e4dac1801baa00a0c11b3de89cf8947
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 21 19:33:24 2023 +0200

    Mention new test features in README
    
    Intentionally brief, we may extend this later.
    
    (cherry picked from commit 3772869758f70eb6aff3829dfe332c54e8841fef)

commit e0ff1777a53fd2cbd87a7ff6fedef97ae7fd2cfb
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 10 10:57:01 2023 +0200

    Add support for "make shell"
    
    This allows for running the current RPM checkout in a container, and is
    just a fancy shorthand for
    
      make env
      runroot_other sh
    
    which additionally mounts the tests/ directory at /srv, sets the
    hostname to "sandbox" and uses the default shell for the root user in
    the image instead of plain sh (if configured).
    
    (cherry picked from commit ed94ebf682dc395566f45d1d472fd9c94075d29c)

commit 0e01a803858d0e4f4198eb357c7cdc120eb5b40f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Sun Jul 9 14:22:50 2023 +0200

    Start with clean environment in bwrap containers
    
    Instead of selectively unsetting variables, just use the --clearenv
    option and then --setenv for those few variables that we actually need.
    
    (cherry picked from commit 1b70fd23bc45d2ec8a97c09b06fc3d7011b34cfc)

commit 473bd7d9adb9c1c63e85afcd21a0d42909dafb96
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Sun Jul 9 14:14:21 2023 +0200

    Replace fakechroot with proper container tech
    
    Use Bubblewrap to spawn real containers instead.  Farewell, fakechroot,
    you served us well but it's time to move on.
    
    Fixes: #1580
    (cherry picked from commit 03126a17b403d4b92996a6ce001ab34f85b75979)

commit 9a4fd3543fa17f729eaab3d0210786e8cc26f31f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Sun Jul 9 15:36:52 2023 +0200

    Add RPM_CONFIGDIR_PATH to atlocal
    
    RPM_CONFIGDIR currently serves two purposes in the test-suite: to
    specify the actual runtime config path for RPM and to obtain the path to
    various utilities (e.g. elfdeps or rpmuncompress).
    
    In the next commit, we'll have to redefine the latter but not the
    former, so prepare ground by adding a separate variable for the latter.
    
    (cherry picked from commit f134eb18942fa50f40f20f34d350ee9969f34ced)

commit 46c79bca470719ca81a4f9bb80d8582962a93be6
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 10 11:03:53 2023 +0200

    Add support for "make env"
    
    Allow for running a shell inside a test-like environment with RPMTEST
    pointing to a writable snapshot.  This feature can be handy when
    debugging a test or just testing your RPM checkout manually.
    
    (cherry picked from commit ec346c49376ba22e1c5319cf1d87133c659c4163)

commit b16b1b3dd1fccd90f0d627c11e6a24589de15af8
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 17 16:40:31 2023 +0200

    Automatically remove test image on "make clean"
    
    (cherry picked from commit b851823b806c1f499bc185b87c0b21b13dc156c4)

commit 52b6676c5ffe8540cb04f326b28436e9b3466471
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 17 15:58:53 2023 +0200

    Bootstrap a self-contained OS image with mktree
    
    Instead of cobbling together a directory tree with a bunch of symlinks
    to the host and letting fakechroot do its "magic" where it resolves
    those before entering a chroot, build an actual OS image containing
    RPM's runtime and test dependencies.
    
    This will allow us to spawn real containers on top of that image and
    thus get rid of fakechroot in a later commit.
    
    Assume the host is running Fedora Linux and use DNF to bootstrap the
    image.  We'll make this pluggable in later commits so that other hosts
    can be supported.
    
    The resulting image now contains actual data and thus is significantly
    larger in size than the previous symlink-based one so instead of
    recursively copying the whole image in each test, use OverlayFS to
    create cheap, disposable copy-on-write snapshots.
    
    The image consists of two layers (directory trees): the base layer (made
    by DNF) and the installation layer (made by "make install").  This
    separation allows for quick "make check" iterations where only the
    installation layer needs to be rebuilt.
    
    These two layers are then combined into a read-only OverlayFS filesystem
    which represents the tree to be tested.  Per-test, writable snapshots
    are created on-demand (i.e. when the RPMTEST_SETUP macro is used) as
    usual.
    
    Make use of Linux user and mount namespaces in order for this to work as
    a regular (non-root) user.
    
    Lastly, adjust the rpmlua test expecting rpm.redirect2null(-1) to return
    "Bad file descriptor" as it would now be "Read-only file system"
    instead.  Do this by giving the test group a writable snapshot.
    
    (cherry picked from commit c3ef4de3667bacd4b44f5c150f55af13e6496a2c)

commit 659725a7864039ee49e3b475f0919e29dc20c798
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 20 18:51:44 2023 +0200

    Use $RPMTEST in dir check
    
    No functional change, just cosmetic.
    
    (cherry picked from commit 1b1100760854fb39c443bb1d3afe508b4e6a5bed)

commit 33bd5a9f718563ce0f76b1c49f508647f9766a7f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 20 14:55:43 2023 +0200

    Rename sandbox() to snapshot()
    
    This will be a better fit after all.
    
    (cherry picked from commit f7496b842cc4a44963ea76d824cbc5d8b250a969)

commit e9ec29646c6dd7ad5228a43da5a9add34fe30416
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 17 14:12:24 2023 +0200

    Refactor mktree
    
    No functional changes, just add some structure into the script so that
    the next commit has a nicer diff.
    
    (cherry picked from commit f83f85093b239f6db5886fb9c3254640680e9ae6)

commit 6b68c1ee5763ef4fd33d8411ccd8c192347fac30
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 13:15:26 2023 +0200

    Silence awk if no RPM_CONFIGDIR in atlocal
    
    We're going to source this file in mktree in the next commit and thus it
    might fail if the RPM install prefix chosen for the build isn't the same
    as the prefix used on the host system.
    
    Ignore the error, DBFORMAT is only useful when sourced by the rpmtests
    script, anyway.
    
    (cherry picked from commit 5d22958d2754041a719f80702195dc61cd764bc5)

commit 1a7009de43b0a56c11ed3e0f932e1c6a2e1f27ae
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 12:54:59 2023 +0200

    Actually ensure no rpmdb in "no rpmdb" test
    
    We currently rely on the fact that a per-test $RPMTEST dir has no rpmdb
    in it but that's not going to be the case in the next commits so fix up
    the test.
    
    (cherry picked from commit 2419aa06e8729662184eba33756c17dc11730bdf)

commit f1e16adcf2100ac035070b5f10432c9fde45da09
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Jul 25 09:04:34 2023 +0200

    Fix broken link to downloads page
    
    in the README
    
    Resolves: #2566
    (cherry picked from commit 33bc736185b6929d9c61678843729ce51833365d)

commit fc54bf257468ed974e155ea61485510fc02d4514
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jul 17 15:17:53 2023 +0200

    Make RUNDIR lower case (rundir)
    
    to match all other directory related CMake variables. Yes, it looks like
    RUNDIR was added to end up as a C macro which are typically upper case
    (and there still is an RUNDIR C macro) but it looks weird in the
    CMakeLists.txt file.
    
    (cherry picked from commit 1bd0f9cd2eb60c30f6076b202942ab8f43c4e41b)

commit 23565b5004ff5f620cce722c5eafc853f96432d3
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jul 17 14:40:36 2023 +0200

    Set %_sysusersdir independent from our prefix
    
    This is always in /usr no matter what prefixes are used either in rpm or
    systemd as it is package installed system configuration.
    
    Setting this hard coded to not require systemd as a build dependency.
    Otherwise the sysusers_dir or sysusersdir pkg-config variable could be
    used.
    
    Borrowing the _root_prefix idea from systemd for /usr independent of _prefix
    
    (cherry picked from commit cececfb6851234aca3e8d102de1c192c6bdf3e67)

commit 38b05f5b509765be127deea89c9c13f654f14d9b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 10:34:43 2023 +0200

    Remove toplevel _dbpath in tests, not just files
    
    Prevent RPM from trying to rename(2) a pre-existing %_dbpath directory
    (last path component) when doing an rpmdb --rebuilddb in the tests.
    
    This makes --rebuilddb work in the tests even if %_dbpath resides on
    lowerdir when using overlayfs, which will come in handy in the next
    commits.
    
    Otherwise, if %_dbpath was on lowerdir and was never copied up or
    recreated on upperdir, --rebuilddb would fail with EXDEV, due to the
    following property of overlayfs (quoted from [1]):
    
        Directory renames only allowed on "pure upper" (already created on
        upper filesystem, never copied up).  Directories which are on lower
        or are merged may not be renamed.  For these -EXDEV is returned and
        userspace has to deal with it.  This means, when copying up a
        directory we can rely on it and ancestors being stable.
    
    Note that this is already an issue in e.g. podman containers where you
    have to manually do the removal before a --rebuilddb (see #2355).
    
    [1] https://github.com/torvalds/linux/blob/v4.8-rc2/fs/overlayfs/copy_up.c#L318-L322
    
    (cherry picked from commit 80b9c7927bc0316dcdbf7ce877921b3875fdc87d)

commit bf6acbf76db8f9291e1b19b5092ee0e3f53cfa05
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jul 7 09:57:02 2023 +0200

    Add sandbox mount command
    
    Initialize the per-test tree in the sandbox wrapper.  We'll replace this
    code in the next commit, this is just to make that diff simpler.
    
    (cherry picked from commit 095a3bf9468937b54d658dde6a70c70a5869d833)

commit dc54fd6382f629c5c04ce1ed7981ac1a6aa61d61
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 6 18:41:48 2023 +0200

    Shuffle configure_file() around a little
    
    Just to make the following commits cleaner.
    
    (cherry picked from commit 88d9e8110b4a4b2ec08419659143dc2c90a7a099)

commit a3335cc292759dac20143364e2096a2faa7944cb
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 6 18:04:17 2023 +0200

    Create the SOURCES symlink in RPMTREE
    
    No need to do this repeatedly for each test in RPMTEST, just do it once
    in RPMTREE.
    
    (cherry picked from commit a46fed4f845095e2a9680db48067df190649c198)

commit 066a09a034e11d8ca51575aba563e6aa67117afa
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 17:56:05 2023 +0200

    Turn populate into mktree
    
    To follow up on the previous commit, also rename the populate script, to
    better express what it does.
    
    Add the build and check subcommands while at it, we're going to extend
    these in the next commits.
    
    Lastly, put the common tree/ into the new mktree.output/, for the same
    reasons.
    
    (cherry picked from commit 17fba03990b7e35df708d898e769cdc397f1cdd6)

commit f8fdc724631edf300a0bf54965c6b87054afca4e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jul 6 16:43:43 2023 +0200

    Rename testing/ to tree/ in tests
    
    Somehow the former name isn't entirely descriptive, use a better one
    (well, in my opinion :P).
    
    The name will be more important in the following commits, too.
    
    (cherry picked from commit 29fa3f4ef555e5a04a7257f43f249958367ffab2)

commit 63e51b426309020f95c77634d079e7f0989a5c8a
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jun 26 16:08:58 2023 +0200

    Add RPMTREE variable to tests
    
    Make it explicit that the initial RPMTEST value is in fact the common
    shared testing/ directory (a.k.a. the image) produced by the populate
    script.
    
    Many tests don't actually initialize their own per-test testing/
    directory (by means of RPMTEST_SETUP or RPMDB_INIT) and only need
    read-only access to the shared one, that's why RPMTEST needs to be
    initially set to that directory, so keep that.
    
    (cherry picked from commit 474f93088ca1a3de674a9ef2065835909da444d2)

commit 681a25f793059e8c355430b19b603e43de662826
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 14 16:26:48 2023 +0200

    Add sandbox exec command
    
    We'll be adding more subcommands to sandbox soon so prepare the ground.
    
    (cherry picked from commit 904a6dd487cff68f726c080b9e36b52c0241183e)

commit 595bf2d71c7c1660353b99bc940dd7ab5ce166b6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 6 13:34:27 2023 +0300

    Gah, another last-minute edit brought back a debug warning...
    
    (cherry picked from commit bd5517da531fc7ddbe83a157ffdcfd718df5413c)

commit 2ed8a950b3e3859c687b48015bf8213a6edfe90a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jul 6 12:18:22 2023 +0300

    Sanitize the helper tool search path in cmake
    
    By default cmake uses $PATH for find_program() lookups, which seems
    reasonable and even obvious until you start seeing things like
    /usr/lib64/ccache/cc in the macros file.
    
    Have cmake use a sanitized path (the usual bins) by default and allow
    augmenting via MYPATH environment variable again (another thing temporarily
    lost in the cmake transition). This gives us more reasonable output even
    with ccache installed while still allowing flexibility for more custom
    setups.
    
    In the autoconf days configure would AS,CC, CPP, CXX, LD and whatnot from
    the auto* environment directly, but cmake has no direct counterpart for
    many of those and for the rest, are equally infected by ccache hacks
    as find_program() is. Handle all the tool lookups with the same logic
    and same lookup. Also take care of c++ <-> CXX mapping, no compiler I know
    of installs a file called "cxx" anywhere in the path, its just "c++".
    
    (cherry picked from commit 5bf144829a5d6929a7b10f0c5677693390db7ce5)

commit 1b97bbba5fe20963cf625b8e322d73f50cccd22e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 14 16:02:11 2023 +0200

    Break the long run*() commands into lines
    
    (cherry picked from commit f08333b06e0379eb60ca6ee17ba99d3392751718)

commit 9f52089df1137957e424b83dfa86f8759781c42f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jul 4 19:23:21 2023 +0200

    Wrap fakechroot in new sandbox function
    
    This is mostly cosmetic right now but will come in handy when we
    actually replace fakechroot in the next commits.
    
    (cherry picked from commit c1be6d7e36891b0eb4f85376847a6569516c0c2e)

commit 2ca55ff1b745bb04595d9d04e480edd4cd3536ce
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jul 4 19:19:52 2023 +0200

    De-duplicate the long command in rundebug()
    
    (cherry picked from commit 070afbf3dbeaffbcc731c411fe43e6a046f100e9)

commit 6c7fd29746434ee53d4d85081b3d5573b1d2b79c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jul 5 15:58:00 2023 +0200

    Drop redundant TOPDIR use from tests
    
    The only two uses of TOPDIR in the actual tests were no-op since those
    tests already got a clean $RPMTEST directory each, anyway.  In fact,
    parametrizing a "rm -rf" call in such a way is just asking for trouble
    (people have lost their $HOME in the past due to a silly typo in some
    test code, not too different from this).
    
    This is a prerequisite for the upcoming test suite overhaul.
    
    (cherry picked from commit 832bd74aba301905b0e905a143006bcf8b79e671)

commit e9708b147e65e3787c5b8ac8ae77246f721e1c15
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 09:49:42 2023 +0200

    Drop redundant atconfig
    
    Similarly to the previous commit, just use the cmake vars directly in
    atlocal.in, and drop atconfig entirely.
    
    For the tests where we used $abs_srcdir to access $RPMTEST/data, replace
    that with $RPMDATA which already contains the whole path.
    
    (cherry picked from commit d90202cd1a25bc8e4595a039776aa87180a9b400)

commit 1f58926a41195e1d08c641f958cc316a34f496a3
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jun 13 13:28:54 2023 +0200

    Drop test-related *dir vars from cmake
    
    No need for such indirection when atlocal.in is itself configured by
    cmake, just use the vars directly.
    
    (cherry picked from commit 8e9b992d2589c61622e61bc1a51b7a9520b96436)

commit 453b08fc672f7b8ee683037b7fea63c938b76958
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jul 3 17:55:48 2023 +0200

    Find required test programs in tests/ cmake file
    
    Albeit cleaner, not terribly important but simplifies the upcoming
    commits a bit.
    
    (cherry picked from commit 65d0ede087f4f21bff116e8c4e8c69373717a2d3)

commit b6d3c4912f66d530a170b225f23919282b157b76
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jun 12 17:17:47 2023 +0200

    Don't init plugins in Python tests
    
    This just reflects what the CLI tests do (--noplugins in atlocal.in) and
    is a prerequisite for running the tests in containers where we don't
    want plugins to interfere (in case the build was configured with them
    enabled).
    
    (cherry picked from commit cecd58910171cf450abdf7a0e9c20c31fff12f51)

commit 16edf1216719baaa614e00b68b8ab8f5abe49b5b
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 17:46:19 2023 +0200

    Let rpmtests target depend on local.at
    
    The local.at file literally is part of the rpmtests build so reflect
    that (practically, this means whenever local.at changes, rpmtests will
    get rebuilt, as it should).
    
    (cherry picked from commit 9aa9b2cf5068a4dc8f87ed5f44c0f1c4ed1a69d5)

commit d974673e630fbf3847dc6b6b241c16c00a41dab7
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jul 5 13:16:42 2023 +0200

    Don't depend on %__cc from build system in tests
    
    This will be needed for when we move the tests into containers as
    otherwise %__cc could point to arbitrary stuff that's likely not in the
    container image (e.g. ccache).
    
    (cherry picked from commit 09bc493804c750f385b25bbeec8f7a80e865def0)

commit 1210332d8ae6a66936add513ecf311d04a17ded9
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jun 13 14:21:30 2023 +0200

    Fix WITH_CAP check in tests
    
    Lost in the cmake translation, the two caps tests in rpmverify.at that
    used CAP_DISABLED were silently skipped for no reason, re-enable them.
    
    This was due to WITH_CAP being an ON/OFF option in cmake, not a 1/0 one.
    While at it, just reference the cmake variable directly, though.
    
    (cherry picked from commit ead14038038b183d93a81f0503e76e083a9fc98d)

commit 757b377ef1c62f6e512942cc151200eabdfb9b5a
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 17:45:53 2023 +0200

    Move COMMANDs onto separate lines
    
    Easier to read (in my opinion, that is).
    
    (cherry picked from commit 784280c4a26135a22346e0830450b9c5d6e7cb08)

commit 35ef2a145df286916aacad6310e03b5d13b66297
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 17:41:58 2023 +0200

    Cluster add_custom_*() calls together
    
    Just cosmetic but will make things more tidy in the next commits.
    
    (cherry picked from commit f2f5355d637d80490d10158da861d149e48e6302)

commit 912cc0cd76e0a8ffaeb608e3c4b3f17f070fa01e
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Jun 21 17:41:07 2023 +0200

    Capitalize our cmake vars in tests/
    
    This is for consistency with the other vars we define here.
    
    (cherry picked from commit 54ab87ec89a627417474d89fd4cfc281021b2fe2)

commit b390f3b9875153376d67c0b07f7f25eb941c469a
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Jun 13 11:45:14 2023 +0200

    Remove redundant runroot_other
    
    (cherry picked from commit afa9eb5f2b1f26b8d3fd06ee93755826e5e32a1c)

commit 036ef782d7b9884d8a44581972e10c09249e6122
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jul 5 14:00:40 2023 +0300

    Fix systemd-sysusers helper path discovery
    
    systemd-sysusers location does not depend on rpm's idea of %_bindir,
    use cmake to discover it along with the other tools we use.
    To handle this, we the need to translate the dash into an underscore
    in the variable name.
    
    (cherry picked from commit 0c18d214e2457155c20c04e9a64e7b4c3462c906)

commit 9996b423c5481c246b4ba72016e85d0da66da204
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Jun 12 16:30:33 2023 +0200

    Replace AT_CHECK and AT_CLEANUP with RPMTEST_*
    
    We're going to do some stuff before and after these macros in the next
    commits/PRs so better do this beforehand.
    
    (cherry picked from commit adafe8d04724b78e0a14a6f499b40d6cf0711d7b)

commit 72fbe804172a1b5d879ed223b844515130744a81
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jul 5 13:21:06 2023 +0300

    Silence mknod "failure" in the test-suite setup
    
    We're only testing whether mknod is usable or not, so a failure is not a
    failure, just information. Silence the distracting message.
    
    (cherry picked from commit 2d68e5fedae86dabf019c3f02330438b7378803c)

commit 76d74b1451d9d2be537f74432861a9a0d9b1178a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jul 5 12:46:35 2023 +0300

    Drop bogus %{?dist} from test-suite specs
    
    The only thing that %{?dist} conditional achieves is breaking the test
    if defined.
    
    (cherry picked from commit b22ab58460a5ff5aea03b1564d991540ec7c4f57)

commit 36379a5cffdeb579ce9713a0be53847244d874bb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jul 5 11:45:01 2023 +0300

    Fix library version test to only look for ourn own libraries
    
    This causes a bogus failure when there's something else in the
    same directory.
    
    (cherry picked from commit a09f68e4f4563f155e852cf9a5820eaabc4713d1)

commit 2444c61916d5821a2260908fc92bef637f0a4f25
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri May 5 14:00:38 2023 +0300

    Test user-creation + verify in a --root operation
    
    (cherry picked from commit 36c48df0fef4be7219b1ef6afe4c81614ab9d592)

commit 98ca49954a69be9609b316ca4fa7f858986da0da
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu May 4 11:59:36 2023 +0300

    Simplify rpmug caching
    
    The simple cache whose efficiency troubled ewt back in 1997
    (see commit 97999ce92c1cad3315d85c02bb3c62007a75d846)
    has proven more than adequate over the years.
    
    In a local testcase based on Fedora 33 server iso contents, an install
    of 1765 packages consisting of 201344 files did a whopping 27 user +
    groups combined. So a few more alloc+free is not going to make the
    damnest difference, don't bother with reallocing the cache buffer, just
    strdup() a new one when needed.
    
    (cherry picked from commit fe645f822dbd71da4145f6174e526a09eb5c815e)

commit e528dc86a1fa5c5c8fa5017b3788d932741c45db
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu May 4 11:10:12 2023 +0300

    Make user/group info reliable operation across chroot
    
    There's no telling what sort of caching getpwnam() and friends perform
    behind the scenes, and worse, there's no way to explicitly reset those
    caches. This can lead to chrooted operations using user/group data from
    the host, which is simply wrong.
    
    Do our own parsing of /etc/passwd and /etc/group to fix. Besides the
    chroot matter, we then only ever lookup local system users and groups
    and not something from eg network name services. We cannot reliably
    do NSS in a chroot because doing so would require relying on binaries
    in the chroot, which in itself is completely unreliable. NSS is also
    unreliable in various rescue mode situations. Bottom line, local files
    are the only ones that can be guaranteed for rpm operation, and this
    change basically enforces that.
    
    Technically we should track chroot status for each lookup and flush the
    cache if the state changed, but this is an internal API and rpm usages
    only ever call it from one side of the chroot for a given operation.
    
    Fixes: #882, #1789
    (cherry picked from commit f3eaeeb7341085e1850e914350cf1f33d538320d)

commit d473f23e2da1a915b8f9424fba8c4791364dfe82
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jul 3 10:35:48 2023 +0300

    Mention systemd dynamic user feature in user/group manual
    
    Suggested by Colin Walters.
    
    (cherry picked from commit 9de8502fc6eafa2a6f4e618ea55523fa27e5bd07)

commit 03ca7ced847f0929f56520fd9b38356a9d5fd2a9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 30 14:22:11 2023 +0300

    Unset RPM_CONFIG_DIR for package building scripts
    
    (cherry picked from commit 9e24ba12691a7a2a2de64104405a2a6a2981e6d8)

commit 6ad7b58a261e8c78609b09a9c776df8d53cf46cb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 28 13:50:22 2023 +0300

    Ensure reproducability test runs with hard requires for user/group
    
    This distro tunable can throw off the results by quite a bit.
    
    (cherry picked from commit 909fd823f1cf26303047917bea92197937ca722d)

commit 5483a77c6118377e2b0670716b5295663a55a0ef
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 28 13:42:47 2023 +0300

    Fix reproducability test --define usage
    
    --define's should never start with % because it can cause unexpected
    expansions to take place, causing the define to do something else than
    intended.
    
    (cherry picked from commit 7ec148c1d61e0b526ae5c917f0ddc2b4a3222146)

commit 7cf0603579431bfc1b463ccae2536849291069a3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jun 28 11:08:00 2023 +0300

    Require real names for contributions
    
    Real names in git commits has always been the expectation, even if there
    have been some slippages. Make it an explicit requirement so the
    contributors know what to expect.
    
    (cherry picked from commit 0aca51b138e1c713a9da9ce5b2616f3d0085b668)

commit 86f7d89fabc3d2c50c2fd5815dc9244659165e00
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 27 15:19:49 2023 +0300

    Really handle hardlinks in the rpmunpack python example, doh
    
    (cherry picked from commit 6f5d9b4677d5f93a6efa2c2a0c4469573adae01b)

commit 57c1ed778cdb3e6d94a26860a44816c25d4a7256
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jun 22 09:20:54 2023 +0300

    Add some Python binding examples
    
    It's not whether these are particularly important examples or not
    (they're not), but adding more will be so much easier once the place
    to add them has been established.
    
    Fixes: #2075
    (cherry picked from commit 9e3bb9fd43ccacefc33ecf895a8544fd7116ad62)

commit 89256ac59ae9ff748ddb30ed14a68196e8391763
Author: Fabian Vogt <fvogt@suse.de>
Date:   Mon Jun 26 16:28:07 2023 +0200

    Actually return an error in parseScript if parsing fails
    
    The return value is stored in the "res" variable which is set to the return
    value of parseLines early in the function. Past that point, any "goto exit;"
    caused the function to return success. This was introduced by 52ce88851abb
    ("Port parseScript() to use parseLines(), no functional changes"). To fix it,
    reintroduce the nextPart variable.
    
    (cherry picked from commit 911a4f253c7213a8570028a7dc2a20b045de8e9e)

commit 150ace92dec11e9040964d021d05782a134f3b5a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jun 26 12:45:09 2023 +0300

    Don't muck with per-process global sqlite configuration from the db backend
    
    sqlite3_config() affects all in-process uses of sqlite. librpm being a
    low-level library, it has no business whatsoever making such decisions
    for the applications running on top of it. Besides that, the callback can
    easily end up pointing to an already closed database, causing an
    innocent API user to crash in librpm on an entirely unrelated error on
    some other database. "Oops."
    
    The sqlite API doesn't seem to provide any per-db or non-global context
    for logging errors, thus we can only remove the call and let sqlite output
    errors the way it pleases (print through stderr, presumably).
    
    Thanks to Jan Palus for spotting and reporting!
    
    (cherry picked from commit ea3187cfcf9cac87e5bc5e7db79b0338da9e355e)

commit 36898d77ac819d8f78217837170780abf6945f67
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 20 12:11:56 2023 +0300

    Drop unnecessary internal includes from the fsverity plugin
    
    Same as 995d1b3fc95a669785136d90c9efa4bc5cb15041, don't know how I
    missed this despite actually looking.
    
    (cherry picked from commit 27c2a7ba9731c3a6eff4d4f9591e0250d83fa91e)

commit daef06e17e8f4169e6bf134d1301c682144ef9f3
Author: Fabian Vogt <fvogt@suse.de>
Date:   Fri May 12 14:03:30 2023 +0200

    For completeness, make sure CPUID leaf 7 is supported before using it
    
    It's theoretically possible for a x86-64-v2 compatible processor to not
    have CPUID leaf 7, in which case it returns the data for a lower leaf instead
    (instead of a sensible value of all zeros...). While this is already covered
    by the use of __builtin_cpu_supports now, do it explicitly for completeness.
    
    (cherry picked from commit d4bf132d6b5a07dc49422c836fe79bb9adaad275)

commit 842ad4e8515c8049218f40e2d1c5980af41e6d13
Author: Fabian Vogt <fvogt@suse.de>
Date:   Fri May 12 13:21:52 2023 +0200

    Use __builtin_cpu_supports in x86-64 CPU feature level detection
    
    Just CPUID is not enough and neither is just __builtin_cpu_supports,
    so use both.
    
    Fixes: #2463
    (cherry picked from commit 34d657bfa8f8cf956546c94582ace50d945c6fbf)

commit 4965ae4c0ea09947ff3c6892c834c21d3e7d09f4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 20 10:11:20 2023 +0300

    Fix per-file plugin hook regression introduced in 4.18
    
    Commit 6dd62720fe84f7e2ad902c915b952fc0b29e3dcd neglected to update
    rpmpluginsCallFsmFilePost() to pass the absolute path in the case
    of unowned directories. Because in that case there's no rpmfi to
    pass to the plugin in that case, there's simply no way for the plugin
    to know what path is being manipulated. Oops.
    
    Fixes: #2543
    (cherry picked from commit 7072b2d2b92e4d2731451bdcca8d83ab6b945016)

commit 31cc47fac58b9ed89a8c8e22a14280467ed1d312
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 20 09:49:57 2023 +0300

    Document spec parse recursing at BuildArch
    
    Fixes: #2545
    (cherry picked from commit cebdb1e88a746b8cd28d6a63c0af57b582c750f2)

commit e7927f090b20f2f11eb409bba1861cf7eb3a06b4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 20 09:34:47 2023 +0300

    Fix rpmDigestBundleFinal() and Update() return code on invalid arguments
    
    Discovered via #2548, these functions merrily return zero for success
    when passed NULL data. In rpm nothing bothers to check for their return
    codes but it doesn't mean it's the right thing to do
    
    (cherry picked from commit 3a50688558f18cfb250b2e70bc34464a8e089d32)

commit c02ddf0363eb08f1a8443552956bc31270b73e47
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Jun 15 13:41:51 2023 +0200

    Only add arch, os and platform, self-provides once
    
    per package even if we do multiple parse passes. This is a quick fix for
    the dynamic spec feature that executes the parsing code multiple times.
    
    This needs to be sorted out properly to only do the necessary things
    (for the build scripts) here and postpone everything else after the
    secondary parses. But that requires larger changes.
    
    (cherry picked from commit ced4d24f0892d588fb6cb7292d35e7555e2f454e)

commit fca0966cc3f108d3b29d1cb987cae63144b11039
Author: yuxiaojun <yuxiaojun1011@outlook.com>
Date:   Wed Jun 14 11:23:24 2023 +0800

    Fix possible null pointer reference in ndb
    
    slot1 and slot2 may be NULL
    
    Signed-off-by: yuxiaojun <yuxiaojun1011@outlook.com>
    (cherry picked from commit 8ec9cfc81c3f8326a1c7ee5b795ef517cd48e6b4)

commit b67216cce4a7fd69fb6b88a2d2a3805091e7cca0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 13 14:54:05 2023 +0300

    Show the tag number for unknown tags in --xml output
    
    --xml is only really useful for diagnostics, and for that purpose in
    particular, showing "(unknown)" text instead of the tag number
    for unknown tags is just offensively dumb. No more!
    
    (cherry picked from commit 119350cd9a9c8cff3fea31baef8a2f354c8ed91d)

commit 879ba8e916a11ed5d295ddb4e0cd7686dc1ecf98
Author: Ralf Habacker <ralf.habacker@freenet.de>
Date:   Mon Jun 12 14:21:57 2023 +0200

    Add doc note that getopt processing only supports short options
    
    See #2541
    
    (cherry picked from commit 0830d4876b5cdec8cf2decdf3551f31c0637ad4d)

commit c1d97ddb6497c50f1d0e79308354f12dc3851adf
Author: Ralf Habacker <ralf.habacker@freenet.de>
Date:   Mon Jun 12 14:20:07 2023 +0200

    Add doc note about 'disabled option processing'
    
    See #2541
    
    (cherry picked from commit c8f06a53534b676fa13bd764a832f844e4560e73)

commit 812898f6b0f26ffd88ba310cd38fee7d1543ebf1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jun 13 12:55:57 2023 +0300

    Drop unnecessary internal includes from the IMA plugin
    
    (cherry picked from commit 995d1b3fc95a669785136d90c9efa4bc5cb15041)

commit 82fefa3631d2a397afd7744931994adebe2a2ee2
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Jun 7 13:33:10 2023 +0200

    Add %specpartsdir to macros.in
    
    so it can be configured from the spec file
    
    Also move the dir beside the %buildsubdir as %{buildsubdir}-SPECPARTS so
    it doesn't pollute the %buildsubdir.
    
    Resolves: #2532
    (cherry picked from commit df8d1fb1b32becf61bbe0366bd7a1966157bf08f)

commit 5905997b05083eae61d8e29ef0ca469696b90952
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jun 9 14:32:10 2023 +0300

    Fix error handling of rpm.execute() and rpm.redirect2null()
    
    The error handling of these Lua functions is wrong in so many ways I
    wont list them all here, but eg. rpm.execute() tries to find an
    strerror() string for an exit code of a process, returns a waitpid()
    error with code 0 and string "success" and rpm.redirect2null() always
    returns a failure despite success and never any meaningful error code.
    The latter probably did the right thing when it was in lposix.c but
    the pushresult() and pusherror() versions in rpmlua.c are rather
    different.
    
    To sort the mess, handle the actual error code checking at call site
    and the pushfoo() functions do just that: push the result on the stack
    and nothing else. Add some test-cases to go.
    
    Fixes: #2528
    (cherry picked from commit 9fce49098878dded2d3dc4c6f0cb282737ff197e)

commit 4700fc0daf27e4505286077edb4d654da21c3342
Author: Arun Ajith S <aajith@arista.com>
Date:   Tue Jun 6 07:20:06 2023 -0700

    rpmrc: Fix how x86 models are derived
    
    The code to autodetect x86 CPU model runs the cpuid instruction after
    setting up 1 in eax. This gives the processor signature back in eax
    which encodes the model number.
    
    As per Intel Application Note 485 and AMD publication #25481, when
    deriving model, we should look at both the base model in eax[7:4] and
    the extended model in eax[19:16]. However current code is only looking
    at base model and this causes some newer CPUs like Icelake(Model 0x6a)
    to be detected wrongly as Pentium 3(Model 0x0a).
    
    Note that this code is only exercised when rpm is built as 32-bit
    binary because all of this is within a `#if defined(__i386__)`.
    
    Because of this misdetection on Icelake, `setarch x86_64 rpm --showrc`
    has `pentium3` as the `installed arch` instead of the expected `x86_64`.
    It doesn't have `x86_64` as one of the `compatible archs` as expected.
    Attempting to install a x86_64 rpm with `setarch x86_64 rpm -i` is
    failing with `is intended for a different architecture` errors.
    
    ```
    ARCHITECTURE AND OS:
    build arch            : i386
    compatible build archs: pentium3 i686 i586 i486 i386 noarch fat
    build os              : Linux
    compatible build os's : Linux
    install arch          : pentium3
    install os            : Linux
    compatible archs      : pentium3 i686 i586 i486 i386 noarch fat
    compatible os's       : Linux
    ```
    
    Fix the code to also consider extended model and extended family when
    applicable. The implementation is similar to the one in the linuxi
    kernel.
    
    References:
    https://www.scss.tcd.ie/~jones/CS4021/processor-identification-cpuid-instruction-note.pdf
    https://www.amd.com/system/files/TechDocs/25481.pdf
    https://elixir.bootlin.com/linux/v6.3.6/source/arch/x86/lib/cpu.c#L19
    
    Fixes: #2535
    (cherry picked from commit 26d3802390602c6aadc523bfb84426914c8fa050)

commit d633b72524ec8de7279320af3551c8aac4a76f22
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Apr 12 12:13:02 2023 +0200

    Add RPM_LD_FLAGS to build environment
    
    Added in Fedora in 2011 to allow to %define _hardened_build 1 in one's
    specfile and have all the necessary gcc and ld flags configured in the
    common cases.
    
    See also rhbz#728974 and FESCO ticket 563 (https://pagure.io/fesco/issue/563)
    
    (cherry picked from commit e9f95c5985bd0b3fa81a0dd75dc5a5b2fdb6220a)

commit 94dea237a1ea7f8f473943f72468bc663e8aadf9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jun 1 09:45:01 2023 +0300

    Remove obscure check for package build time from --rebuilddb (#2527)
    
    Back in 1997, commit be0b90359bcd8156385178eb9b570c0538c0333f added a
    sanity check for --rebuilddb operation, skipping headers which lack
    some basic tags. Name, version and release are real requirements for
    packages, but checking for buildtime is odd, and plain wrong.
    Yes, we expect that to be present in packages built by rpm, but that's
    not used for any processing and certainly is not required for a package
    to be installable. And if it can be installed then it can't be
    right to throw it away when rebuilding, leaving untrackable orphan
    files in the process.
    
    It is also documented as informational and optional by LSB. While
    severely outdated, it is right on this account.
    
    Fixes: #2527
    (cherry picked from commit 6caf2a5f586838f6188dd6667a4df6d9c6ec0163)

commit 0401fe96df50f004d1bc7bb25c2871b7ba6956e8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 29 13:55:20 2023 +0300

    Export rpmGlobPath() to Lua as rpm.glob()
    
    Lua doesn't ship with batteries, or glob functionality. It's not
    unthinkable that packagers and macro writers may find globbing useful
    in this space.
    
    (cherry picked from commit 9f568c459e3c004f3a097e902555c393547c4c03)

commit 5045b76464de6271a0539c526f21ca9541de5cb1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue May 30 11:52:58 2023 +0300

    Fix Lua docs rpmio mode table rendering (missing newline)
    
    (cherry picked from commit 636eaddf03bd4c2213129ba633ec7d784c5825e4)

commit 6f643eb105d9a163159377308c807a2b97450ec7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 29 11:13:47 2023 +0300

    Add %{rpmversion} builtin macro for getting the running rpm version
    
    Seems like a useful thing to have, and a bit crazy that we haven't had any
    reasonable mechanism for this before now.
    
    Fixes: #2523
    (cherry picked from commit b38077eae068200f569331f50980ea96808e4c4a)

commit 8de508be727284997ee0b8ea509a8817949fc535
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu May 25 10:39:05 2023 +0300

    Macro documentation improvements
    
    Use tables where they make sense, group builtins by category that
    can be linked to, add version introduced where relevant. In addition,
    some awkward/misleading wordings fixed.
    
    (cherry picked from commit 015c829c7670c606b952bb34ef69debb60f5985a)

commit d9cc75a8f7b5c247389c77dbd2c20dcd1b3e2189
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue May 23 12:46:22 2023 +0300

    Fix a copy-paste --help description of --whatconflicts (RhBug:2208661)
    
    (cherry picked from commit 03525592c944957f3b7b200b7daeb9f615cdcde7)

commit 7169768e688ea7fcc1c6a030dd68d0123d28c44b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu May 11 09:27:12 2023 +0300

    Silence an apparent false positive warning from gcc in -Og mode
    
    Haven't looked at the assembler but I don't see how xx could be
    uninitialized by the time it gets to the if(), regardless of the
    optimization used.
    
    (cherry picked from commit 93ee7d9c6164467608094a7e0652a0e3d84a6715)

commit 662acd3275ba2cb10f221962f1071e792af4f96d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri May 5 12:33:20 2023 +0300

    Verify user/group in tests when possible
    
    Take advantage of root(less) aware $VERIFYOPTS added in commit
    fb040f16ec09a10c47f968d995c5bb770b8a7a64.
    
    (cherry picked from commit 760eb86380ce2ffba187bfa191c0e13b7552d5c4)

commit f2d51135836eaf06dc538d77e5c76f12dd7c8bba
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri May 5 13:08:22 2023 +0300

    Don't mask the user verify fail on invalid symlink test
    
    This test only runs as root so let it do its job.
    
    (cherry picked from commit f4c6fc4c17981c54e85341a0381b6a3e9a5728e1)

commit 70d4403e97fbb9f9f1d81a23e2759609a6395538
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed May 3 11:03:22 2023 +0300

    Fix thinko in archive size tag(s) description
    
    The archive size tags are on the uncompressed archive, an apparent
    thinko in 50324700562aa6204d93b1e4e9ae9776ecdeeedb.
    
    Fixes: #2498
    (cherry picked from commit a97c376f379ee48c3b0e92e9c79f64c9fd954b64)

commit d127096529af6c112b2213e43c65b85484b9ed15
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 27 15:21:55 2023 +0300

    Fix file signatures getting loaded when not asked for
    
    Our compound masks for disabling file info bits per operation never got
    updated to include the two separate file signature types. This was
    discovered by rpm-ostree on older rpm version crashing on an IMA signature
    despite passing in RPMFI_FLAGS_ONLY_FILENAMES.
    
    Add the file signatures to the most obvious masks, and add a simple test
    as well.
    
    Fixes: #2425
    (cherry picked from commit 14aac7d27ea79feeae37106d2d3a570adecc50e9)

commit 2d83cdd9b8f590642682de6527be5237711c4aa0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 27 15:06:55 2023 +0300

    Make the higher level file info selection flags available to Python
    
    These disabler flags have little other purpose than optimizing cases
    where you know you only need a certain subset of files for large
    number of packages. Rather than expose all the individual flags,
    export just the per-operation level masks to Python.
    
    (cherry picked from commit e6a44dbbf9442f070d486e7dc67e9269bd142d4d)

commit 4bc1b8db77a4738f7cc07a22559b5208b90de349
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Apr 24 16:34:49 2023 +0200

    Fix leftover "lua.h" import from days long gone
    
    We used to bundle our own Lua interpreter but that's not the case for a
    while...
    
    No functional change.
    
    (cherry picked from commit 607e60bffef27a4abe22786e2adc4af2dd0a228e)

commit d1d0bd5ba6c450af9306739adde8cdebcfe86838
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Apr 5 16:33:34 2023 +0200

    Use CMake Lua module
    
    While many distros ship a pkg-config file for Lua, the upstream source
    tree does not provide one and so we shouldn't rely on it.  Turns out,
    CMake provides a native Lua module so just use that.
    
    Unfortunately, the package doesn't define any IMPORTED target so add our
    own, similarly to how we did this recently with libmagic and libimaevm.
    
    Of particular note is that this adds an implicit dependency between
    CMake and Lua (e.g. Lua 5.4 support was only added in CMake 3.18), but
    that hopefully won't have much impact on most OS installations out
    there.
    
    Fixes: #2247
    (cherry picked from commit 49befbc12381e95c2dacab50284ff32328a4ef99)

commit be1a40bfe217e2a339769284893487c20903f89c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Apr 19 09:59:46 2023 +0300

    Bump CI to Fedora 38
    
    (cherry picked from commit 293b625f3ad6924754ff98a4d486c6aa6e6cffa8)

commit c35fe7781e159975d6f778369cc42904d6717f29
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Jun 9 13:26:34 2023 +0200

    Preparing for rpm 4.19.0-alpha2
    
    Since we can't have nice things in CMake (a string in VERSION), let's
    just bump the minor version here and come up with a better way for
    future releases, as outlined in #2477.

commit 568469dd299346634e9beb7b0321200ae469e1e9
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Jun 2 14:47:59 2023 +0200

    Move dbus announce plugin config to DATADIR
    
    Users are not supposed to meddle with this. So it really should not go
    into /etc.
    
    Use the DATADIR from dbus-1 and not our own install prefix.
    
    Resolves: #2474
    (cherry picked from commit 51c596a6c893824d459ddc6ac28ea28e9f391bd4)

commit 11d6a72e7b3bc14e5bb045d61de2fbe1734bcc3a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 29 10:34:57 2023 +0300

    Revert %_smp_build_ncpus change to a parametric macro (RhBug:2210347)
    
    Commit a213101bc3af65c860d045c65fb4e2ef7566a4c6 changed %_smp_build_ncpus
    into a parametric macro, but this breaks common usage via the Lua macros
    table as parametric macros are returned as closures rather than the
    expanded value.
    
    This seems like a design flaw of the macros table, but as an immediate
    remedy for the breakage, add another layer of indirection to revert
    %_smp_build_ncpus back to a non-parametric macro.
    
    Fixes %constrain_build macro in Fedora, which ironically is made obsolete by
    the change that (unintentionally) broke it.
    
    (cherry picked from commit 83413bfd3949d7a1f18f00b03333a59f77d41dc1)

commit 10e6086e656e15fac3951651d6ca07f67c1052dc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon May 22 18:19:24 2023 +0300

    Fix undefined symbols from plugins in some circumstances
    
    Another bit lost in the cmake transition: plugin linkage to librpm and
    librpmio. In rpm itself this doesn't really matter because the running
    process supplies the necessary symbols but it's a different story when eg
    a Python process uses dlopen()'ed bindings.
    
    (cherry picked from commit acfe252822db37fc9f47c221c4e3ae79a5f0be27)

commit 7efa21be39a13d67208c847c24b5202243dc380c
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed May 17 17:23:59 2023 +0200

    Use mkdir -p for creating SPECPARTS dir
    
    to not error out when invoking %setup more than once or shipping the
    directory in the sources.
    
    (cherry picked from commit 021a7d3aaa5458d8956babf0220a3e574a2b8e62)

commit 162110aadad445cc248a68dc4c840fe05b79d00f
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed May 17 12:39:47 2023 +0200

    Enable large file support on 32-bit systems again
    
    Replace 32-bit sizes in types like off_t with 64-bits when building on
    32-bit architectures, to enable large file support there.
    
    This fixes a nasty regression introduced in the cmake transition.  As
    autotools would set this flag to 64 automatically for us, applications
    linking against librpm (such as libdnf, librepo, libsolv or drpm) are
    already adapted to that and are also building with the value of 64
    (explicitly, we never exported this flag through pkg-config ourselves).
    However, us suddenly expecting 32-bits in those types on 32-bit systems
    can blow up badly e.g. in functions that take an off_t parameter, like
    Fseek().
    
    There perhaps aren't that many low-level users of librpm but drpm is one
    such example where exactly this happens when built against our current
    master.  It calls headerRead(), leading to Fseek() which receives a
    64-bit offset parameter where it expects a 32-bit one, thus silently
    overwriting the following parameter from 1 to 0 (SEEK_CUR to SEEK_SET)
    which messes up the whole reading sequence in drpm's rpm_read(),
    producing a failure in drpm's test suite that doesn't make any sense at
    first sight.
    
    While at it, also export the flag through pkg-config so that anyone
    linking against librpm is now guaranteed to work correctly even if they
    don't set the flag themselves (kudos to Petr Pisar for suggesting this).
    
    (cherry picked from commit 2df8008d22b58f87fe665de0fa8c5bbeb4b4a3d8)

commit f6ee7d094bfa269a10fb4543a8e35269bfb5d115
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue May 9 10:10:17 2023 +0300

    Test for the variable rather than it's expansion in cmake files
    
    Testing for the expansion was a cmake newbie mistake that can go wrong
    in weird ways, test for the variable instead, consistently. Don't try to be
    clever with for-loops, just test for each case separately. This makes it
    greppable as well.
    
    (cherry picked from commit ae1b8c8c4eb26dd677e39a91f65f8a17f6bdbbf2)

commit 8e677823efb96aa02ba47ad017db5aba712ff173
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon May 8 17:50:21 2023 +0200

    Fix bzip2 detection
    
    HAVE_BZLIB_H was not set due to a typo leading to the bz2 support not
    being compiled in although the library was detected correctly.
    
    (cherry picked from commit d18d6ce41df4a5887df47a69052a401808aef19f)

commit 0071ad4f0f34ce1813288db01dee629d7c62986e
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue May 2 09:03:50 2023 +0200

    Remove second share/ dir from infodir and mandir
    
    cmake variables and the derived macros.
    
    CMAKE_INSTALL_INFODIR and  CMAKE_INSTALL_MANDIR already include the
    datarootdir. So just prepending the prefix is sufficient.
    
    (cherry picked from commit 07d57462614b1669de1d63661f58fd9fa322411b)

commit 6a5ad2263866fed240dd217280efaee421728ef6
Author: Neal H. Walfield <neal@pep.foundation>
Date:   Wed Apr 12 17:56:19 2023 +0200

    Add pgpVerifySignature2() and pgpPrtParams2()
    
    Add new functions pgpVerifySignature2() and pgpPrtParams2(), which are
    like their earlier versions, but optionally return descriptive error
    messages (in the case of failure) or lints (in the case of success).
    Adjust tests accordingly.
    
    This requires rpm-sequoia 1.4 or later.
    
    See https://github.com/rpm-software-management/rpm-sequoia/issues/39
    and
    https://github.com/rpm-software-management/rpm/issues/2127#issuecomment-1482646398
    
    Fixes #2483.
    
    (cherry picked from commit 87b9e0c28c3df3937f6676ee1b4164d6154dd9d3)

commit 2e25f20f0d4e46cea534e5a5a81a9b1eee02240c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 13 10:36:57 2023 +0300

    Have dist (and snapshot) targets automatically pull in the po submodule

commit c32ad282bfed2e236dde024b5f90c75d55598c4e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 13 10:31:10 2023 +0300

    Revert "Oops, require translations for dist tarballs"
    
    This is actually the wrong thing to depend on.
    
    This reverts commit 4e69677ecde58d49ddfa77996862be41e76e1077.

commit 4e69677ecde58d49ddfa77996862be41e76e1077
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 13 10:10:19 2023 +0300

    Oops, require translations for dist tarballs

commit 6c8b56e3987bc218ca011e3618b1468855559b4a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Apr 12 11:27:43 2023 +0300

    Document the library version update scheme

commit 7baaf865bce55c1bf02c6a121fd548f1aae6e8bc
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Apr 12 10:38:13 2023 +0300

    Bump the soname in anticipation of the 4.19 alpha release
    
    We've removed a tonne of obsolete APIs in this release so...

commit 2080896ce522c93a95697f72a5830958bb6dbafb
Author: Florian Festi <ffesti@redhat.com>
Date:   Tue Apr 11 13:35:04 2023 +0200

    Install /etc/dbus-1/system.d/org.rpm.conf
    
    which was accidentially dropped when converting to cmake
    
    Use CMAKE_INSTALL_FULL_SYSCONFDIR as it expands to /etc instead of
    /usr/etc
    
    Resolves: #2474

commit 909d237b5eddfbc43051f75d8f96688448026496
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Apr 11 12:25:41 2023 +0200

    Handle IMA as an imported target, take II
    
    Another attempt at commit 7184fb80137363e39d79e2b5a0eb2c4fb060cc2e.

commit 62395521a9aea856c225de1baf767707ed235f98
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Apr 11 13:30:55 2023 +0300

    Axe outdated multiple build areas doc

commit b75ae820beb53633e4ef8b476f7cf0aad2d617bc
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Wed Apr 5 15:15:29 2023 +0200

    Don't rely on pkg-config for libmagic just yet
    
    This fixes a regression from automake where we also didn't use
    pkg-config for libmagic.
    
    Fixes: #2246

commit d648cb305cd6d49ca453b3b80941d9fc0cdad1f7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Apr 5 15:42:22 2023 +0300

    Include pre-built API docs and man pages in dist tarballs
    
    There are multiple strange details buried in this all, such as
    having to run the main tarball creation in VERBATIM mode due to
    git submodule foreach variables, and because of that we can't use
    globs in the other commands but have to mask them behind other rules
    to do other steps and then concatenate the tarballs at end.
    
    On the build side we need to manually test for the presence of pre-built
    content in the source directory (normally that content would be in
    binary directories) and install differently in absence of the tooling
    that could actually build those docs.
    
    While at it, put both the API docs and man pages in their expected
    destinations, install(FILES .. TYPE MAN) is not aware of sections
    (:facepalm:) and just puts stuff into the root man directory. With
    DOC that is expected, but not where packaging expects to find it.
    Except that we're now *installing* the API docs too, put them under
    rpm/API docs without any extra html directories in between.

commit 587b53cf6bffbc4526e3d3cc6570fc50abaf1c18
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 11:53:16 2023 +0300

    Match the produced (compressed) tarball name in the target name

commit df6d4e388a6d9646004a8a3c37848f20a27c5952
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 11:43:59 2023 +0300

    Add ChangeLog to the dist tarball

commit 429bc295a7f306b9ef0c89d458ae35ec00531456
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Apr 6 18:32:59 2023 +0200

    Use WITH_IMAEVM in cmake file
    
    as that's was we actually use

commit ea71755e376e02d1a68e1b6122df42b03e794b74
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Apr 6 14:10:31 2023 +0200

    Add WITH_FAPOLICYD build option
    
    defaulting to ON. The if clauses were already in place just the option
    line was missing.

commit 589fb0e3aa15683cc71931da95b328e57a9c58b6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 11:59:00 2023 +0300

    Revert "Handle IMA as an imported target"
    
    This has brainfarts and is broken.
    
    This reverts commit 7184fb80137363e39d79e2b5a0eb2c4fb060cc2e.

commit f8ee4a17f770ad21e2ff032bd1eab27d6f808b11
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 11:33:16 2023 +0300

    Bump our CMake requirement to 3.18
    
    We already violate the 3.12 requirement in a place or two, and
    there are many nice things in the later releases. 3.18 is three years
    old and is available pretty much anywhere that is even remotely relevant
    for us.

commit 7184fb80137363e39d79e2b5a0eb2c4fb060cc2e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 10:48:27 2023 +0300

    Handle IMA as an imported target
    
    Most of our dependencies are imported targets already, so while for just
    one site this isn't actually any shorter in terms of LoC it's more
    consistent with the surroundings in the consuming site, and more so if
    we ever need to link to this from some other place.

commit c61da285a14e98592e5cac1966b169d178868471
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Apr 6 10:45:39 2023 +0300

    Let cmake handle checking for mandatory components
    
    Both find_path() and find_library() accept REQUIRED argument, use it
    instead of rolling our own.

commit 5e1addc04892be381248631e960cea86c4389ea7
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Apr 4 10:41:34 2023 +0300

    Add translations to dist tarballs (if po submodule is present)

commit b34276c4eec0feccc288866fc03578066c24a1b9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Apr 4 10:31:46 2023 +0300

    Include translations in dist tarballs

commit 20bad038fb738eacb2135a59f3bdbd6be552f3d5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Apr 4 09:35:47 2023 +0300

    Update translation submodule for new translations and targets

commit b22b3af388f581b19397d896bbef8284b3c8b8ad
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Apr 3 10:20:13 2023 +0300

    Fix translation directory not getting added on out-of-tree builds

commit 3cec5f81cd202946c2ea033c966919262daacb1e
Author: David Cantrell <dcantrell@redhat.com>
Date:   Mon Apr 3 08:25:35 2023 -0400

    Remove RPM_MASK_RETURN_TYPE from rpmTagReturnType_e; make it a macro
    
    RPM_MASK_RETURN_TYPE is 0xffff0000 which is UINT_MAX.  Per ISO C,
    enumerator values must be in the signed int range.  gcc is more
    forgiving with this than certain versions of clang and if you are on a
    random system, such as FreeBSD 13.1 with clang 13.0.0, you will get
    this error when trying to compile software that links with librpm and
    uses the rpm headers:
    
        error: ISO C restricts enumerator values to range of 'int' (4294901760 is too large) [-Werror,-Wpedantic]
    
    Similar to the other enums in rpmtag.h, RPM_MASK_RETURN_TYPE is not
    actually a value used from the enum, so take it out of the enum and
    make it a macro.
    
    Signed-off-by: David Cantrell <dcantrell@redhat.com>

commit 8310b34a38b419b0ae6a7669805754f11e472c1c
Author: David Cantrell <dcantrell@redhat.com>
Date:   Thu Mar 30 14:18:41 2023 -0400

    Bring RPM_MASK_RETURN_TYPE in to the signed int range
    
    Set to 0xffff0000 (or 4294901760), I was getting:
    
         error: ISO C restricts enumerator values to range of 'int' (4294901760 is too large) [-Werror,-Wpedantic]
    
    This happened not when building rpm itself, but when building
    rpminspect which links with librpm and uses rpm's headers.  The system
    in question was FreeBSD 13.1 which has clang 13.0.0.
    
    It is a corner case, but I like testing things on non-Linux platforms
    as often as I can to find errors like this.
    
    With this change, the rpm test suite passes for me.
    
    Signed-off-by: David Cantrell <dcantrell@redhat.com>

commit cd7736833e36f6088dd49fcbcc3d9e6a7aa6e954
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Apr 3 14:20:44 2023 +0200

    Fix typo in cmake rule
    
    that breaks the OpenSSL build of the interenal PGP parser

commit a5bd7571358c7974da1c909e331525b13dce1264
Author: Ralf Habacker <ralf.habacker@freenet.de>
Date:   Thu Mar 30 12:21:23 2023 +0200

    Added more details to the doc about what is returned by the macros '%-x' and '%-x*'
    
    Fixes: #2457

commit 1a9393f06a1de9f3864c3897674145068415e7ff
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 31 11:18:55 2023 +0300

    Fix docs on weak user requires macro name
    
    The code in commit 6e03ef19a6b166d7b35ca0952e6091f557b892ca uses single
    underscore as intended but the macros file + docs got two due to
    whatever brainlapse.

commit c397a3cec65ae17c66d473ef73f411eff02aa4ff
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 15:42:51 2023 +0300

    Add %preuntrans and %postuntrans to spec docs

commit 7b04017a1760f1f855f3cb5d4c6bffe4661052cd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 15:35:14 2023 +0300

    Document %description and put %package to its own section

commit e38b8d937673e979fa646cbd2010e91e57636d00
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 14:41:47 2023 +0300

    Briefly document %attr() and %defattr() in the manual

commit 13e89c6ae5ff9cb20b0721e80732e7cde55da96c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 28 17:25:31 2023 +0300

    Add rough documentation for user and group handling

commit fb040f16ec09a10c47f968d995c5bb770b8a7a64
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 17 09:25:51 2023 +0200

    Add a proper testcase for full sysusers.d file automation

commit 6e03ef19a6b166d7b35ca0952e6091f557b892ca
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 16 12:06:49 2023 +0200

    Autogenerate requires for users and groups in packages from file data
    
    Ensure proper installation order and dependencies for custom user/group
    usage across packages. These are effectively Requires(pre,postun)
    dependencies to prefer during install and preserve the dependency for
    installed packages as well.
    
    These new requires require distro level bootstrapping of sorts to get
    the provides into place first. To make that less painful, allow turning
    the requires into recommends so they wont cause hard failures but will
    still cause the right thing to happen when ordering (and depsolving too)
    for the packages that do have the provides already.

commit 009d1397331a89413e2c5eead163cadb47ccdb4b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 11:35:40 2023 +0200

    Automatically create sysuser users and groups on install
    
    Add a new built-in %sysusers scriptlet that executes before unpacking
    files and creates any sysuser users and groups provided by this package.
    This scriptlet gets called with the same arguments as %pre, and
    sysusers.d(5) lines are fed into the stdin of the script (ie similar to
    file triggers).
    
    systemd-sysusers is the native solution, but compatibility with
    non-systemd distros can be achieved by pointing %__systemd_sysusers to a
    script that translates the sysusers.d(5) lines into adduser/addgroup
    calls or similar.
    
    Unlike all the other package-related scripts, this runs from the outside
    of a possible chroot to have access to the user-creation utilities
    from the start of the transaction even in case of initial installation.
    
    Users and groups are never deleted, on purpose, as that would lead to
    uid/gid reuse and consequently, data leak and general weirdness.

commit fc09ee9d60cce879e521ac522b24817de32b3611
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 11:27:48 2023 +0200

    Make rpmscript machinery chroot-aware
    
    Normally all scriptlets are of course chrooted when the installation is,
    but we're about to get an exception to that. No functional changes, just
    adding necessary infrastructure for the next steps.

commit afad3167ccfda3c0d3200b918dd8b391d621f408
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 10:03:58 2023 +0200

    Add a tag extension to decode sysuser lines from user/group provides

commit c7fd9fed9951dc884c345eb9280987389b291c41
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Mar 14 14:52:59 2023 +0200

    Generate user() and group() provides from packaged sysusers.d files
    
    Encode the actual sysusers.d line as base64 in the EVR string to be
    passed to systemd-sysusers (or a compatibility script) by rpm during
    installation. The source string is \0 padded as needed to avoid base64's
    '=' padding in the output as this is not a welcome character in EVR
    strings.
    
    For example:
    
        u dnsmasq - "Dnsmasq DHCP and DNS server" /var/lib/dnsmasq
    
    user(dnsmasq) = dSBkbnNtYXNxIC0gIkRuc21hc3EgREhDUCBhbmQgRE5TIHNlcnZlciIgL3Zhci9saWIvZG5zbWFzcQAA
    group(dnsmasq)
    
    The EVR string is omitted from the group as that gets created as a
    side-effect of the user creation and does not require calling
    systemd-sysusers.

commit 15b7025c0059a41afda7493ae2ef61ac3878f3af
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 16 09:58:37 2023 +0200

    Generate user/group provides from packaged /etc/passwd and /etc/group
    
    These often come from a separate package that is installed early on
    and form the basis of system users and groups, augmented by sysusers
    from other packages. We don't want to create such users, but we need to
    be aware of where they come from for dependency resolution and ordering.

commit a213101bc3af65c860d045c65fb4e2ef7566a4c6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 8 10:03:48 2023 +0200

    Make build parallelism memory and address-space aware (#804)
    
    Take advantage of the new %{getncpus:proc/thread} functionality when
    calculating the number of processes/threads to use during build.
    
    The goal here is to avoid gross overallocation of processes/threads
    on constrained systems. In particular threads on 32bit systems where
    address space is limited, but also to allow packagers to easily tune for
    gigantic build jobs such as webkit that may overwhelm otherwise adequate
    systems.
    
    Fixes: #804, RhBug:1118734

commit 48c84b1e71827b644ccfdca6b7840cfbe24eaf59
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 8 10:07:55 2023 +0200

    Make rpmio parallelism memory aware
    
    Take advantage of the new %{getncpus:thread} functionality when
    calculating the number of threads to use for io stream compression
    (when not in parallel region)

commit deaebd0c89a6d453bb971fd8f5a3b858e7a95733
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 8 09:08:42 2023 +0200

    Add optional total/proc/thread arguments to %{getncpus} macro
    
    "total" equals calling with no arguments, "proc" and "thread" consider
    further constraints, what is implemented here is heuristics based on
    available physical memory and address-space and %_smp_tasksize_proc /
    %_smp_tasksize_thread tunables.
    
    Change the previous %getncpus related tests to use %getconfdir instead,
    they are testing unexpected arguments behavior for this type of macro,
    not %getncpus itself. Add a test for the actual functionality: if nproc
    is available, test that our total matches with that, and that defining
    tasksize to total memory only allocates one thread. Optimally we'd
    test separately for 32bit address space limitations but that gets tough
    when we have no idea where this will be executed.

commit 0dad385cbcd7a9731b0cba44a4b4dcc89558ff89
Author: Łukasz Stelmach <l.stelmach@samsung.com>
Date:   Mon Mar 20 09:48:49 2023 +0100

    Conditionally display VCS tag in --info query

commit 97c9d8903c4166b4c2d37e5d67d193f2262e089b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 11:38:04 2023 +0300

    Call RPM_CONFIGDIR just that consistently
    
    For whatever historical reasons RPMCONFIGDIR was used in automake
    whereas the environment variable is RPM_CONFIGDIR. Just call it that
    everywhere.

commit a2b49273aa0935dcb88743c216925fc4d42723a8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 11:24:04 2023 +0300

    Honor rpm vendor setting from cmake, use a saner name
    
    The vendor was hardwired to "redhat" as a leftoever from early cmake
    bootstrapping phase and bugs in the surrounding logic. Simplify the
    setup somewhat: call the setting RPM_VENDOR and pass that around in the
    code tree as well. The CANON fubar along with other similar weirdness
    can thus remain hidden in the makemacros() cmake function.
    
    Reported and initial patch by Neil Gompa.

commit 4f2627e08bf2880a5d16f62a675bba87d027035a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 30 10:39:50 2023 +0300

    Restore snapshot make target in cmake
    
    Refactor the dist rule into a slightly more generic function that
    we can call with suitable values for generating dist and snapshot
    tarballs.
    
    This includes preliminaries for requiring a tag for dist tarball
    but that involves further complications so not done yet. Local HEAD
    is not exactly the right thing to be building dist tarballs from.

commit 909e0aeec642e5925ad5200c60612018d72cd582
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 24 10:22:54 2023 +0200

    Add a note about CI tests to contributing guidelines

commit a1bd9f558ee4fa92918107f45b002222c07801b5
Author: Ralf Habacker <ralf.habacker@freenet.de>
Date:   Thu Mar 23 16:57:48 2023 +0100

    Add test case for macro '%**'

commit 9deedb8afc700234572ac4f1cb17d77d7968a92f
Author: Ralf Habacker <ralf.habacker@freenet.de>
Date:   Wed Mar 22 15:19:00 2023 +0100

    Add documentation for shell like macro '%**'

commit 528a43abc42c04e132faf8c954ed654cba40a78e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 11:11:37 2023 +0200

    Eliminate code duplication from rpmdsNext()
    
    Now that we can, let rpmdsSetIx() take care of the details.

commit 4a2f13bf6b9a48e7c16d8effd4d9a1f679d3642f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 11:05:18 2023 +0200

    Kick out rpmds debugging remnants
    
    I'll add the printf() if I need it...

commit 93256ee95d7cead4b9ada75a6d1c3cd23b97c857
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 11:02:49 2023 +0200

    Kick out one last remaining nopromote remnant from the ABI
    
    Globally exported variables like this are evil. This one hasn't done
    anything in a while, just forgotten. We're bumping soname so we're free
    to remove cruft like this.

commit aa46fd77f2b78722a4cc47386ce3709be5b1fccd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 10:36:45 2023 +0200

    Make rpmdsSetIx() somewhat sane
    
    rpmdsSetIx() has shared the same flaw that was fixed for rpmfiSetFX()
    in commit 318efbaec80a90f1d9ac76d0cd433f6ea3c103fa: sometimes -1 means
    success and sometimes it means error. And like in that case, this is so
    broken that nobody can have relied on the behavior (we had one internal
    user which was lucky if anything).
    
    At least as bad is that it never actually bothered to check whether the
    newly set index is valid.

commit 8d918dd9f0cff01eb16f21da8e9ae663937edf59
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 10:11:38 2023 +0200

    rpmdsSetIx() sanity in rpmdsSearch()
    
    We have rpmdsCompareIndex(), use it so we don't need to muck around with
    the iterator index and attempt to restore with the broken API that
    rpmdsSetIx() is. Cleans up the code quite a bit.

commit b2c200fdb4704db21284a882b3ab4b9cb3216dc5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 09:54:31 2023 +0200

    rpmdsSetIx() sanity in filedepTag()
    
    This trickery used to be necessary once upon a time but no longer is.
    Set the index to what we want and dont bother with rpmdsNext().

commit de342c3abd1792fe2fbf0a204f9c243f2b2a1b3f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 09:50:23 2023 +0200

    rpmdsSetIx() sanity in rpmfcPrint()
    
    This trickery used to be necessary once upon a time but no longer is.
    Set the index to what we want and dont bother with rpmdsNext().

commit b2218e0e8ab96e1002537ca43e3a6e6955115297
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 09:46:10 2023 +0200

    Clean up filedepTag(), support all dependency types (in theory)
    
    Similar to previous commit: grab the deptype from the ds instead of
    recalculating it on our own, as an extra bonus it now supports all
    dependency types but we only ever call it with provides and requires.

commit a0dcb68b062c90cc0aed26d2f3a222d0d3341635
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 22 09:43:17 2023 +0200

    Clean up rpmteColorDS(), support all dependency types
    
    Take advantage of rpmdsD() instead of doing it all manually. As an extra
    bonus it now supports coloring from all dependency types, although
    we only ever call it with requires and provides currently.

commit 0f957330f24cdb2510e0bbdface54ffa8064b8ce
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 16 11:37:47 2023 +0200

    Populate user and group data in cpio payload again
    
    In general, rpm populates the cpio header with the same info as the file
    lists in the header, although it only uses the latter. This is even
    documented in LSB (up to and including version 5). At some point, the
    user and group information has gotten dropped though, all files end up
    owned by root:root according to the cpio header.
    
    The roots of that change go deeper than I care to dig, but I've noted
    this behavior in commit fc36f322e123a7421b798f12358cc701e28afbe0
    already. The actual change has happened earlier, possibly
    8b7b911a17f187822f6e72b162ef3bea39366176 but it's impossible to test
    stuff that old.
    
    While the cpio format is on its way out, packages built with current rpm
    versions will live long into the future so we might as well fix this,
    I see no reason not to. Add a test as well.
    
    Payload digest changes, causing all the other hashes to change too.

commit 856ddc334174fd37fe4ce81bc9f9f11a08cf6c81
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 17 12:53:42 2023 +0200

    Fix a segfault on a non-stringable argument to macro call from Lua
    
    When natively calling a parametric macro from Lua, with the arguments
    inside a table, we can't assume lua_tostring() always succeeds as it
    can fail eg on a table. Report the error instead of crashing in argvAdd(),
    and add a test as well.

commit 8be31c77806604cdca3cf628fb087bc1cc3d5c9e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 17 14:36:26 2023 +0200

    Move variable to nearest available scope
    
    Commit b960c0b43a080287a7c13533eeb2d9f288db1414 moved mayopen all the
    way to the function scope when the local if scope would've been enough.
    In a function with complex loops and all, nothing good comes out of having
    variables at unnecessarily wide scope.

commit b960c0b43a080287a7c13533eeb2d9f288db1414
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Mar 16 19:05:04 2023 +0100

    Fix compiler error on clang
    
    Turns out variable declarations are not allowed after a label, even in
    C99. And while some compilers don't seem to care others do.
    
    Moving the declaration of mayopen to the start of the function to avoid
    this problem.
    
    Resolves: #2435

commit 1525b2d863cf382cd8ec0c7a505155337c240d6d
Author: Shreenidhi Shedi <sshedi@vmware.com>
Date:   Thu Mar 16 16:59:07 2023 +0530

    triggers.md: remove trailing spaces
    
    Signed-off-by: Shreenidhi Shedi <sshedi@vmware.com>

commit 9f23b98ebb894c503e1be6a7a250e0d3751b751a
Author: Shreenidhi Shedi <sshedi@vmware.com>
Date:   Thu Mar 16 15:58:02 2023 +0530

    triggers.md: fix a typo
    
    Signed-off-by: Shreenidhi Shedi <sshedi@vmware.com>

commit ad1bdc6520c1954d2a94fefa0a6090661f972db4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 17 09:48:24 2023 +0200

    Expect NOTTRUSTED for expired and revoked signatures from rpm-sequoia
    
    rpm-sequoia returns NOTTRUSTED for expired, revoked and obsolete
    (but otherwise valid) signatures. Expect that in the testsuite, and
    require rpm-sequoia >= 1.3.0 for this behavior.
    
    Fixes: #2424

commit 343a5d09e0857344fe51204299865ab2e5f7b08c
Author: Florian Festi <ffesti@redhat.com>
Date:   Thu Mar 16 14:39:38 2023 +0100

    Describe the stripped down payload format
    
    in the reference manual
    
    Resolves: #2413

commit 69242a554a042544376247b580c78ee5923dfad2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Mar 17 09:19:46 2023 +0200

    Erm, we can't expect to copy /etc/[g]shadow
    
    Brainfart in commit f93190e15ccb0789c33e8469e71e3ee40f3928fa, the
    test-suite expects to run as a regular user who can't copy shadows.
    And those files missing cause artifacts.

commit 4e244280db8d780ac90313785598487f888b8924
Author: Martin Liska <mliska@suse.cz>
Date:   Wed Mar 15 19:15:00 2023 +0100

    add more libmagic exceptions for HTML, SVG and PNG
    
    I noticed there are ~150K .html files in all libreoffice rpm files
    and the detection is significantly delaying package build. Thus, I
    introduce more exceptions for commonly used file formats.

commit f93190e15ccb0789c33e8469e71e3ee40f3928fa
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 15:25:01 2023 +0200

    Copy rather than link to /etc/passwd and friends
    
    We don't want to muck with the real things in case somebody runs this as
    root. Also allows us to modify them...

commit 4a45aad08c1b2172e485d9356753b8ad5b7050a8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 11:10:10 2023 +0200

    Fix nextfilefunc return type to const char * as per the expectation
    
    The returned pointers are const and must not be freed, only we were
    casting away that difference at the one place it was used in.

commit 7b982a815e4726dab47b0012006965686eca27bb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 15 11:08:38 2023 +0200

    Add a typedef for rpmscript nextfilefunc
    
    No functional changes, just makes it easier to look at and manage.

commit fb5ce339a934cdf7bfcb58b61e0600859053d30f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 13 15:28:08 2023 +0200

    Enforce (some of) our documented build requirement versions
    
    Some of these went missing in the cmake swap, others may have only been
    documented.

commit a8107659ef3dd4855729bf65aa4d70f784cb5a5f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 9 10:21:39 2023 +0200

    Catch runaway forked children from Lua scriptlets centrally
    
    Commit 2d418ad3c11bcf0261d0022ac177d13284a8d5fb added a safety catch
    for runaway children from package scriptlets, but we have many other
    ways to run Lua scriptlets too, and runaway children are equally harmful
    in them all. Catch them all centrally by wrapping lua_pcall() instead.
    
    Besides handling more cases, there are a couple of more subtle
    improvements here: rpmlog() in a child process is undefined behavior
    due to the locking it does, but also nonsensical - rpmlog() is more than
    fprintf() and any warnings/errors it collects end up in the wrong process.
    Check and log from the parent instead.
    
    Finally, make it a warning instead of an error because we're not failing
    the scriptlet because of this, and make the message more generic as
    besides exec(), this can be avoided by waiting for the child in
    the script too.

commit 45103f84764b2a293b068eb0f59456f553ec45d8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Mar 13 12:41:11 2023 +0200

    Use Python >= 3.2 compatible object hash slot type
    
    Python 3.2 changed the object hash type to make them pointer-width on
    all platforms - an incompatible change but apparently 3.2 was early enough
    in the 3.x days for such changes: https://bugs.python.org/issue9778
    
    The hash vs pointer size mismatch has quietly been there all along but
    clang >= 16 started treating this as an error, causing failed builds.
    The fix is easy and obvious enough, but this requires us to bump the
    minimum Python version from 3.1 to 3.2. Which thankfully is old enough that
    we can do without having to care or introduce build-time compatibility
    workarounds.
    
    Suggested-by: Khem Raj <raj.khem@gmail.com>

commit a0cd976e5f8a01774e1ba4b5eaa2c6ad9e93bebb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Mar 8 14:59:05 2023 +0200

    Drop leftover includes
    
    Commit 4dfb381742c27449aafcd907c05f3a84015ffb54 removed the custom
    logic for thread autodetection in xzio, making these includes redundant.

commit 9a1bf2fbda75f7d0c46120f6086787f62e2b499c
Author: Коренберг Марк <mark@ideco.ru>
Date:   Fri Feb 24 10:21:10 2023 +0200

    Fix ignoring exit code of child scripts in case of EINTR

commit 35a0eda22ce02abbda54c8eecec30c77725de01d
Author: Fabian Vogt <fvogt@suse.de>
Date:   Mon Mar 6 17:50:42 2023 +0100

    The bit for LZCNT is in CPUID 0x80000001, not 1
    
    The GCC headers put bit_LZCNT into the list for CPUID 1 %ecx values, but that
    corresponds to VMX. LZCNT is actually advertised in CPUID 0x80000001 %ecx,
    which is also referred to as "ABM" by AMD and some other places.

commit 0c02e4899e72eae8ccb484fbb22c04f12fae2f0d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 22 09:31:06 2023 +0200

    Copy original lead on signing instead of recreating
    
    Fixes a regression from commit 3255273ae0fabd03c9738249a29c9c1e15f28f64
    where the arch and os fields of the lead may change depending on the
    package arch and the host where --addsign/--delsign is executed.
    
    This is hard to test for specifically as the test-suite can run on any
    architecture, but the bit-per-bit comparison test added in the previous
    commit will catch differences here too.
    
    Fixes: #1326

commit be950eabb84a88e5773e096435c37b92e3d47ebb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 22 12:01:59 2023 +0200

    Fix signature reserved space not restored on --delsign (#2382)
    
    Fixes a regression from commit 5c279fb149a44a1bc4d19e11c3c01942732b8486
    simplifying this a bit too much, and failing to restore the reclaimed
    reserved signature space on after --delsign. Add a test-case to ensure
    --addsign + --delsign returns the package to its original state
    bit-by-bit.
    
    Fixes: #2382

commit 6b59cd80ce405c370a42e345fdad325813fd13f5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 2 08:55:22 2023 +0200

    Remove a misleading comment
    
    The rpmdb "instance" number is not and never was an offset of any kind.

commit bf3cca41eea4e00c60b4573cbb2a42499dee6c15
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 2 08:41:42 2023 +0200

    Eliminate uses of rpm_data_t and rpm_constdata_t in header.c
    
    Similar to previous commits, abstracting void pointers behind these
    types does nothing to help anybody, especially the reader.
    Actual type does not change, so it's a NOP.

commit fc71a588fd7d2200a9ff3a921c864a96658e715d
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 2 08:37:17 2023 +0200

    Replace uses of rpm_count_t with the concrete type within header.c
    
    Same rationale as previous commit, and also a NOP.
    And now with entryInfo_s using all concrete types, the signed offset
    stands out the way it needs to.

commit 28111464ef78489fab777014712e7c94af7c5e52
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 2 08:33:50 2023 +0200

    Replace uses of rpm_tag_t with the concrete type within header.c
    
    The rpm_foo_t typing was a somewhat misguided attempt to unify the
    type mess of back in the day. It may actually have helped with that but
    now these are more of an unpleasant obfuscation that nobody (including
    me) knows how and when to use.
    
    The actual type does not change here, so this is a NOP.

commit f53423eb1475fe4818c206a6ee3ddf060b423706
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Mar 2 08:29:58 2023 +0200

    Actually make rpm_tag_t (and thus rpmTagVal too) unsigned
    
    Somehow this last step went missing after the preliminary work in
    commits 1f3e923264c90fecd8670492c341000723178eb6,
    2f9f1ce6d6172c33c7f45d8a94bdab21f16e73e3 and
    2c089bff1a9a37e65a8ca4c6a214288a615a1e54.

commit 6c17e2fbee8ae2aa7ab960a4ede380dfba55e610
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Feb 21 14:21:14 2023 +0100

    Don't repeat %patchN deprecation warning
    
    Avoid flooding the build log for SPECs that contain a lot of these
    lines, one warning should be enough.  Just mention how many were found.
    Including the line itself in the message is no longer relevant so remove
    that, too.
    
    The cost we pay for having the total count is that we'll no longer log
    the warning when an RPMLOG_ERR occurs somewhere in the process.  Moving
    it below the exit label would fix that but also cause the warning to
    always be printed *last*, possibly confusing the user if there's an
    actual error further up in the output... so just go with the former.
    
    Note that we may want to revert this in the future and replace it with a
    proper rpmlog-native suppression mechanism for duplicate warnings.
    
    Fixes: #2383

commit e3c11a790367016aed7ea48cfcc78751a71ce862
Author: Jan Engelhardt <jengelh@inai.de>
Date:   Mon Feb 20 10:00:44 2023 +0100

    docs: update grammar in dependency_generators.md

commit b927c044b8809c4dd892f75737240a20c32c2b90
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 16 12:25:24 2023 +0200

    Disable debuginfod server lookups in build and dependency generator scripts
    
    With recent elfutils (0.182 or so) various seemingly innocuous tools
    such as `readelf` like to do network lookups for ELF symbol information.
    There's no circumstance where we'd want that to happen during rpmbuild,
    so disable these lookups during all spec build scriptlets and also
    dependency generator children.

commit 91467e715769e8ef0b1dafce288e9313aca41bb4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 16 12:18:02 2023 +0200

    Exclude kernel modules from ELF dependency generation
    
    The kernel modules are technically ELF DSO's but we only care about
    library level dependencies which the kernel modules will never have, so
    processing them is just waste of time.
    
    This "regressed" when we dropped the "exeonly" flag from ELF in
    commit 8901a6be1652519c4875436e29e0a663be0790b7.

commit e9caa60d668c8ae6a9cc83dba7f45792757eac46
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 15 09:29:51 2023 +0200

    Fix type mismatch in parseList() prototype

commit 85dc1ea6246a49698c55702f46787bf0afc4e671
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 15 09:23:10 2023 +0200

    Update a few leftover signed lengths to unsigned in header code
    
    No functional changes.

commit 7e347df6d5624caca784a565f6d192e0a7990396
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 15 09:45:06 2023 +0200

    Use ENTRY_IN_REGION() macro where possible

commit 9afa5a14637161838e8e8aaed8a3e4909fef2985
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 15 08:54:50 2023 +0200

    At long long last, make entryInfo opaque outside header.c
    
    This guarantees there aren't any hidden users of these fields that
    we'd need to worry about when changing types. The data itself of
    course ends up being public through rpmtd_s so care is needed...

commit 2f7c3458df601286fea0b9b83289c28873b3a9d5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 15 08:53:32 2023 +0200

    Move header digest calculation to header.c

commit 045dd10e1f52190b6bada3c83e4537354889626f
Author: Pavel Simovec <psimovec@redhat.com>
Date:   Tue Feb 7 15:06:24 2023 +0100

    fix typo

commit 58ea4258f53642ff12e8b54a99704fa7ef38980b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 15:00:56 2023 +0200

    Switch the various header data length arguments to unsigned
    
    With this, data lengths wrt header data should all be unsigned. Yay.

commit bce0af81310c4d151e6f060a3c1a377fa6c6ac31
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 14:57:57 2023 +0200

    Refactor strtaglen() to return the length through a pointer
    
    Similar story as with dataLength() and regionSwab(), mixed types create
    unnecessary headaches. The actual type to be changed later.

commit f11b1135260dfe53bf3a7d2e1115e7c9ad155582
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 14:47:52 2023 +0200

    Switch regionSwab() length return type to unsigned, update callers
    
    And no functional changes, allegedly.

commit 997c4d4e33c6bcb50a90ef62647b1f21e7e3a187
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 14:41:32 2023 +0200

    Refactor dataLength() to return the length through a pointer
    
    Similar to previous commit, dataLength() wants to return -1 on error but
    this clashes with unsigned data length types. Returning separately
    allows changing the type separately, to be done in a later commit.

commit 26600f6ba78d2f3fbeced845cc7d0e3cce1a4c25
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 14:23:18 2023 +0200

    Refactor regionSwab() to return the length through a pointer
    
    regionSwab() wants to return -1 for errors, but data lengths want to
    be unsigned. By separating the two we can change the length type
    independently of other error handling, to be done in a later commit.
    
    One could also consider a zero-length region an error (and we do so
    elsewhere), but technically the header is just a container and an empty
    header should be a valid construct. So rather than make zero an error,
    preserve the option to consider these legit later on.
    
    No functional changes intended.

commit 6720b6d00c45b3fab15697a0dea4e590fa69aafd
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 13:36:41 2023 +0200

    Switch header region index and data lengths to unsigned integers
    
    Or mostly so, anyhow. Take care to check that region size is small enough
    to fit in the negative offset. No functional changes intended.

commit 6f384ef55083a00e3667bf91b6bfc3dce04023d4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 13:22:33 2023 +0200

    Switch header index and datalength types from int32_t to uint32_t
    
    This fixes some type mismatches and introduces others as we work towards
    having everything unsigned (negative data lenghts don't make sense, at
    least in rpm they don't). No functional change, intended anyway.

commit 7dd313949fb7e8f78d88dfcb75f97aa9a6a1f1c2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 11:19:52 2023 +0200

    Switch all header entryinfo pointers from int32_t to uint32_t
    
    No functional change here, the type is only used for grabbing
    index and data length of the header, and where previously we have
    some uses cast to uint32_t and some not (so it was "broken" anyhow),
    now it's only blob->il/dl type that is wrong.

commit 37455ed40291074ec07d6eb541662f4613cf0bbf
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 11:30:20 2023 +0200

    Fix some non-functional signed integer references to unsigned

commit 2c089bff1a9a37e65a8ca4c6a214288a615a1e54
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Feb 10 09:48:22 2023 +0200

    Define RPMTAG_NOT_FOUND in uint32_t terms
    
    The bit-level value doesn't change, but this makes the value
    explicitly unsigned for the compiler, which is what we care about here.

commit 2f9f1ce6d6172c33c7f45d8a94bdab21f16e73e3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 9 15:34:19 2023 +0200

    Fix rpmTagGetValue() error return documentation
    
    It's literally returning RPMTAG_NOT_FOUND, not -1

commit 1f3e923264c90fecd8670492c341000723178eb6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 9 13:09:45 2023 +0200

    Move RPMTAG_NOT_FOUND out of the rpmTag enum into a macro
    
    RPMTAG_NOT_FOUND is not a tag, it's an error code. It never should've
    been a part of the enum, no matter what I thought in commit
    cb13c4398609bb8e9d7a6750075d79d1662a26e1

commit 42694806bf73b07514554233d0d58d17a58cd863
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 9 13:05:24 2023 +0200

    Use proper type for copyTagsFromMainDebug
    
    The array contains a non-enum value (0), this is why headerCopyTags()
    uses rpmTagVal pointer, not rpmTag.

commit 55206653b9be8143fda2debae82302a832c5df5a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 13:55:31 2023 +0200

    Bury ei2h() inside header.c, no external users anymore

commit 5fc039853ac6b8211a6a0e686ac5fcc98e5b03f2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 8 13:53:51 2023 +0200

    Drop unused ei2td() internal helper

commit b03743640e379d59224e55aa3b08ec44835ebf33
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 2 16:18:03 2023 +0200

    Disable io thread autodetection inside OpenMP parallel regions
    
    The low-level IO code has no way of guessing, much less knowing, how
    many threads it would be okay to run inside OpenMP parallel regions
    which may well already be consuming all available resources.
    
    This is far from optimal of course, but getting packages built in the
    first place, and without completely overloading the system while at it,
    is far more important than high-end optimization. That can follow later.

commit 70da964675c35929355a605a15bd282f0fb0ccbb
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 2 11:27:12 2023 +0200

    Further simplify the io thread enablement code
    
    Now that we can, collapse autodetection into the parsing routine so
    we don't need to pass around these -1 and 0 values having different
    semantics on different places. No functional changes.

commit 76bac7ae23bee148fa3dded15061b2ff0ce451c8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 2 11:13:45 2023 +0200

    Simplify io thread number parsing, use common logic
    
    Always use strtol() to get a nice "continue here" pointer, and since
    it returns 0 on no digits, we can simply always call it. And since
    there's more than one place doing the same exact thing, use a common
    helper. No functional changes.

commit 5dc0d0320e71d5c002467436d9110e0e28ef3d91
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Feb 2 10:29:13 2023 +0200

    Require xz >= 5.2.0, it was released in 2016 so old enough
    
    Makes the xz thread enablement logic that much easier to follow.

commit ec4900713f9e2210035dad79ffbb6bf69eda348f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Feb 1 12:17:50 2023 +0200

    Fix numberless T for thread number autodetection in zstdio
    
    Not sure if it ever worked or whether it regressed in recentish
    refactoring, but plain 'T' was not enabling zstd threading before this.

commit 7f8675936c87209f41e248da79277ff5f2a385c2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Feb 6 09:48:22 2023 +0200

    Document rpm codebase comment style

commit 1f47b1cc0eddbb1921d81249a4bd604089c71495
Author: (GalaxyMaster) <galaxy4public@users.noreply.github.com>
Date:   Tue Jan 31 18:24:55 2023 +1100

    support for POSIX getopt() behaviour
    
    [POSIX defines optarg only for options with arguments](https://pubs.opengroup.org/onlinepubs/000095399/functions/getopt.html) and callback() is expecting optarg to be NULL for options without arguments, however, at least on musl optarg will carry a pointer to the argument of the previous option with argument.  This commit makes the behaviour deterministic and expected.

commit a3889fe5b96812c0dd787317cbc9f1ecda917995
Author: Tomas Korbar <tkorbar@redhat.com>
Date:   Thu Jan 26 11:19:46 2023 +0100

    Split ___build_pre macro to make mocking rpm build environment easier
    
    New macro ___build_package_notes_env contains environment variables
    that package-notes depends on. This allows easier mocking of rpm
    build environment and isolated execution of check phase of rpm
    packages possible.

commit a9ac1727a637e24c27570daeb045651cc1b8f45f
Author: Adam Williamson <awilliam@redhat.com>
Date:   Sat Jan 28 12:28:51 2023 +0800

    Update comments

commit b3adc8ce62517cd764a589d2bdccbf97dadb915a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 26 12:11:22 2023 +0200

    Turn `%patch` without arguments and options into an error
    
    Instead of treating `%patch` with no options and errors the same as
    `%patch 0`, just raise an error. There will be folks who have missed the
    warning-only phase, but we don't want to wait another ten years to finally
    rid ourselves of these legacy quirks.
    
    Related: #2205

commit fd2f743b3ef543a5b6fe963b2ec8c3c43b8424b9
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Jan 19 09:55:14 2023 +0200

    Fix macro scoping level on re-entry from %[] expresssion (#2354)
    
    This is the same issue as commit 1767bc4fd82bfacee622e698f9f0ae42c02126fa
    was with Lua, and so the same fix works: restore the nesting level
    from the macro context when re-entering macro engine from %[]
    expression. Analysis and suggested fix by Michael Schroeder,
    reproducer from Miro Hrončok.
    
    Add tests for both %[] and %{expr:...}, although the latter isn't
    affected because the expression is macro-expanded beforehand.
    
    Fixes: #2354

commit c10e1ec1149dec40b6ed11eb8b513992f2af7e62
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Jan 17 12:17:23 2023 +0200

    Try telling cmake that the project needs to be built before testing
    
    Recently there have been a fair amount of random failures in the CI,
    due to apparent ordering errors / lack of dependencies that have been
    hard to reproduce locally. The key is probably CI running "make check"
    right away, which then proceeds on all the relevant targets in
    parallel. And nowhere at all we're telling it that the tests need the
    entire project to be already built. So apparently the "make install" in
    tests/populate often ends up building a significant part of the project
    and ... that two competing makes in the tree ever actually manage to
    complete at all is a small miracle.
    
    There doesn't seem to be a way to add a dependency on the ALL target in
    cmake, so have populate_testing target depend on top-level cli tools
    to enforce at least "mostly sane" situation when running "make check"
    without a preceeding build. This should address the issue of random
    CI failures in ticket #2357.

commit eb5ece1267a22330f6116149997cf5cc1c22b21f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jan 16 12:08:48 2023 +0200

    Issue deprecation warnings on %patchN syntax

commit c18f62e7b0630394e0bf2ccee0239a0cddd93d0a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jan 16 12:06:47 2023 +0200

    Briefly document %setup and %patch in reference manual
    
    Take the opportunity to document the recommended and deprecated syntaxes
    and their availability across rpm versions.
    
    Fixes: #2209

commit 6edbb02d30a862be990c634d859ac80c6239f3f8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jan 16 11:07:33 2023 +0200

    Convert most of our examples to use a modern %patch syntax
    
    In order to properly deprecate the syntax, we need to move ourselves
    off it first...

commit 4c814f88d515aecf358128f6400d0ece55ff1499
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jan 18 15:08:44 2021 +0100

    Add --generate-subpackages to find_lang.sh
    
    using the new dynamic spec feature. It creates one sub package by
    language.
    
    Resolves: #1276

commit 9995991208214bef913fc5440d6f2f34731c7359
Author: Florian Festi <ffesti@redhat.com>
Date:   Sat Nov 26 11:16:45 2022 +0100

    Add test case for %find_lang
    
    as a stepping stone for testing dynamically generated language sub packages

commit e120e7aac288f6983310aa9e63a70dd6047c9e8d
Author: Florian Festi <ffesti@redhat.com>
Date:   Sat Nov 26 11:14:42 2022 +0100

    Add bash to test environment
    
    as it is used by find-lang.sh (and may be others)

commit ccfca4146d3c0c7ac3a3be37b3ea501620954d2f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 11:03:27 2023 +0200

    Use our O_DIRECTORY equivalent when opening files for setmeta
    
    Ie if we expect a directory, ensure we got one.

commit 3a7c8bc401a97f0ebf57bef3987a337129e4371f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 10:57:03 2023 +0200

    Explicitly specify O_RDONLY when opening files for setmeta
    
    On Linux, this is a no-op as O_RDONLY is 0 but this may not be so on
    other platforms. Another 4.18 regression.

commit 5dcc399cd21f607f13eb092a3abfc8b8daa59d4c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 10:44:28 2023 +0200

    Add a test for special device node installation
    
    This is a bit theoretical as it does not work for regular users or in
    containers which are the typical scenarios for running the test-suite.

commit 3a3e10b9813bdfc4223aedc82292386a50510b04
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 10:16:35 2023 +0200

    Never follow links in path-based chown()
    
    This is basically a leftover from the initial conversion to the *at()
    family in commit 1bab34c6e45c549c7829e469ba35bdececbb84e8 - the logic
    was already there and only converted to the *at() form. But this is not
    only potentially insecure (remember all those symlink CVEs) but also
    wrong simply because it's inconsistent with the other metadata ops which
    never follow links in path-based mode.

commit 932013698149d43720cc321c8df2f99f51866e18
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 10:00:37 2023 +0200

    Use fd-based ops for metadata in FA_TOUCH mode too, when possible
    
    Fixes another brainfart in commit 25a435e90844ea98fe5eb7bef22c1aecf3a9c033.

commit 28c92fd54c93371c3062664d8a938438a2be88d6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Jan 13 08:57:27 2023 +0200

    Fix install of block and character special files (#2195, #2275)
    
    While it's possible to open special files, they are, well, special and
    have "side-effects" also known as, ahem, semantics. Opening a device
    file in Unix means accessing that *device*, and FIFOs have their own
    semantics.  In other words, for rpm's purposes, we should never EVER
    open these files as a part of the install / permission setting etc.
    Fix this major brainfart in 25a435e90844ea98fe5eb7bef22c1aecf3a9c033.
    
    OTOH this forces us back to the less secure path based operations for
    these files, which is what we were trying to avoid in the first place.
    There always was a tiny race between create + open for these (because
    there's no atomic way to create + open anything but regular files) but
    this opens up the window quite a bit.
    Nobody should be placing device nodes in user-owned directories but
    FIFO's may be a different story.
    
    We haven't had tests for device nodes because it requires privileges the
    test-suite usually doesn't have, not testing FIFOs I have no excuse for.
    Add that test now.
    
    Fixes: #2195, #2275

commit 4035d6cde6978aa55059e8d7e04a1485cc630cac
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Thu Jan 12 17:40:19 2023 +0100

    Unbreak %dev directives in %files
    
    Somehow this fell through the cracks when refactoring
    processBinaryFile() in commit f062d5744c3ee338daaeb8e11b1fc20f9e44dee3,
    it basically disabled the use of the %dev directive altogether, oops.
    
    Without rpmIsGlob() (which was also yanked in the recent cleanups), we
    can't easily determine whether a string is a glob pattern, so don't
    overcomplicate this and just remove the error message, and always
    consider any metachars in a %dev line literal.
    
    Since %dev is meant for device *creation* [1] at install time and we
    never lstat() those filenames in addFile(), any use of globs within such
    a filename can only possibly be meant literally, period.
    
    That doesn't mean we shouldn't actually document %dev itself in our own
    docs but let's do that separately.
    
    Thanks Panu for discovering this regression and suggesting a fix!
    
    [1] https://jfearn.fedorapeople.org/en-US/RPM/4/html-single/RPM_Guide/index.html
    
    Fixes: #2347

commit a4a0a10b1fc8f02b32bd21d22215b54e049e93f9
Author: Wenlong Zhang <zhangwenlong@loongson.cn>
Date:   Tue Jan 3 14:29:18 2023 +0800

    Revise ISANAME for loongarch
    
    %_isa is already adding -64. No need to have 64 twice.
    
    Signed-off-by: Wenlong Zhang <zhangwenlong@loongson.cn>

commit 2b9342a0ecde00be145653e122e8cd32fabbae5a
Author: yangchenguang <yangchenguang@uniontech.com>
Date:   Fri Jan 6 11:14:03 2023 +0800

    Testcases: rpmbuild source name with space
    
    Signed-off-by: yangchenguang <yangchenguang@uniontech.com>

commit 71dedfd2f434ea54fc3a920e4b44a8737ba6cb25
Author: wangpeng <wangpengb@uniontech.com>
Date:   Fri Jan 6 09:49:50 2023 +0800

    Quote source file names in %setup
    
    Resolves: #2335
    Signed-off-by: wangpeng <wangpengb@uniontech.com>
    Co-authored-by Florian Festi <ffesti@redhat.com>

commit 4fde659835409669b51850a8e49743b468f0631b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Jan 11 11:42:59 2023 +0200

    Un-deprecate %_changelog_trimtime
    
    Deprecating implies plans to remove later, but this is actually just an
    alternative strategy for changelog trimming, and different distros may
    have different needs.

commit 37ec18d86b26f58e3b6aa60aefaefabe4ff15169
Author: yangchenguang <yangchenguang@uniontech.com>
Date:   Tue Dec 20 16:35:11 2022 +0800

    Fix silent wait when missing input RPM package
    
    Signed-off-by: yangchenguang <yangchenguang@uniontech.com>

commit cd46c1704ccd8eeb9b600729a0a1c8738b66b847
Author: Fabian Vogt <fvogt@suse.de>
Date:   Thu Dec 8 12:50:12 2022 +0100

    Add x86-64 architecture levels (v2-v4) as architectures
    
    The x86_64 SysV psABI defines four levels of x86_64 with certain CPU
    features required for each level. Those definitions are meant to be
    generically useful and recognized as such by glibc and gcc as well.
    
    For backward-compatibility and to avoid surprises, default to building
    x86_64 even on v2+ capable machines.

commit ed1b97511434d56652d9ff27b47d72e3318355a8
Author: Richard Phibel <rphibel@googlemail.com>
Date:   Tue Jan 3 17:17:20 2023 +0100

    Fix case of LIBLZMA_FOUND variable
    
    In pkg_check_modules command, LIBLZMA is all uppercase. So in variable
    LIBLZMA_FOUND, LIBLZMA should also be all uppercase.

commit 7b0b5e7d2cf53817ec5e2545c5f591a26db72cec
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Jan 9 09:59:27 2023 +0200

    Use proper macro conditional negation syntax in the manual
    
    Historically only %{!?foo} syntax has been used, the reversed ?! version
    was only introduced in 0d75ef1e0a0609ee61386f02fa311d6d8ac79450 (perhaps
    accidentally) and should not be used, much less recommended.

commit 100004fffe26f856d4e8fa8b46e8d9c2c8b1227f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 15 15:46:25 2022 +0200

    Implement major() macro discovery in cmake similar to autoconf
    
    This basically just duplicates how the major() / minor() macro discovery
    works in autoconf: test for major() in <sys/sysmacros.h> and
    <sys/mkdev.h>, if found define a variable accordingly. If not, assume
    it's in <sys/types.h>.

commit 492be59ece28a7341de0bd88c0a23125ba54d2ce
Author: Sean Molenaar <SMillerDev@users.noreply.github.com>
Date:   Fri Dec 30 19:40:15 2022 +0100

    brp-remove-la-files: use -0 to work on macOS

commit e9bd7c761fbf1e5593a82d5ab4572854d8314593
Author: Dimitrios Soumis <jimsoumis@gmail.com>
Date:   Sat Dec 24 22:37:58 2022 +0200

    Fix typo in macros.in

commit af81c95114bc2c01f005f15f17646a5188b5855d
Author: xujing <xujing125@huawei.com>
Date:   Mon Nov 28 11:34:24 2022 +0800

    Fix fileleak when urlGetFile fails in rpmInstall
    
    The "tfn" is created by calling rpmMkTempFile but not unlinked when
    urlGetFile fails in rpmInstall. Fix it.

commit f0f983b145583eeed618cf3cbc5d39bedd8af5a5
Author: xujing <xujing125@huawei.com>
Date:   Mon Nov 28 11:19:20 2022 +0800

    Fix fileleak and memleak in rpmInstall
    
    The "*eiu->fnp" from "eiu->pkgURL[eiu->pkgx]" which is alloced. when
    Fopen or rpmReadPackageFile fails in tryReadHeader, "*eiu->fnp" is
    set to NULL but not freed. In addition, if "eiu->pkgState[eiu->pkgx]"
    is set, the file is leaked too. Fix it.
    
    Only resource free is added, no other logic change.

commit 688c4ad34d197055eb8f58fb4e45065af881598c
Author: xujing <xujing125@huawei.com>
Date:   Mon Nov 28 11:10:19 2022 +0800

    Fix memleak when fsmRename failed in fsmCommit
    
    The "dest" is alloced in fsmFsPath but not freed when fsmRename failed
    in fsmCommit. Fix it.

commit 7feccb696115e94c81a84807456cb38512281312
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 16 15:50:12 2022 +0100

    rpm2archive: Don't print usage on no arguments
    
    given as we want to default to reading from stdin and writing to stdout in
    that case.

commit 5e22e0c5833fb53f9c54652072316998ed0365e4
Author: Florian Festi <ffesti@redhat.com>
Date:   Fri Dec 16 15:45:20 2022 +0100

    rpm2archive: Properly parse popt options
    
    and issue an error message for unknown options. Before unknown options
    could mess up the argument parsing leading to reading and writing from
    stdin/stdout.
    
    Thanks to Eva Mrakova and the Red Hat QE team for spotting this!

commit e2c504c08381519c81774791fe6b82eb064a072e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Dec 15 12:23:52 2022 +0200

    Move bunch of global compile definitions to the targets needing them
    
    No functional changes, just declutter the global compilation stuff
    a bit.

commit 3b0b9d491f5828a40c15b76b4a19ca00006cf81e
Author: xujing <xujing125@huawei.com>
Date:   Mon Nov 28 11:02:47 2022 +0800

    Fix memleak when running %generate_buildrequires
    
    The "output[i]" is alloced in argvSplit but not freed when running
    %generate_buildrequires. Fix it.

commit 6130bd31038ff17a03fcac6ec7e41ac744163dde
Author: xujing <xujing125@huawei.com>
Date:   Sat Nov 26 11:39:48 2022 +0800

    Fix *sbp leak when running rpmbuild with --quiet
    
    When running rpmbuild with --quiet, the "*sbp" may be alloced many
    times in buildSpec by calling doScript but only freed once. Fix it.

commit 01196e00beefc2ba6f7f0787350c5dd76891829a
Author: xujing <xujing125@huawei.com>
Date:   Fri Nov 25 17:11:22 2022 +0800

    Fix elf leak in getElfColor
    
    The "elf" is leaked in getElfColor when gelf_getehdr return fail.

commit c013821c0c9350b67d9f9a02848e1a7f87fa180b
Author: xujing <xujing125@huawei.com>
Date:   Fri Nov 25 17:04:11 2022 +0800

    Fix prog leak in parseScript
    
    The "prog" will be alloced when using "-p" options, which cause src
    "proc" leak. Add "origproc" to point to src "proc" to fix it.

commit 7fcdfd3b40f69af6a1d4980683859eef05f39b4e
Author: xujing <xujing125@huawei.com>
Date:   Fri Nov 25 16:48:34 2022 +0800

    Fix BANames leak in handlePreambleTag
    
    The "BANames" is alloced from popParseArgvString but not freed
    when spec->packages != pkg. Fix it.

commit 418721a2877b9a85d3010e2ab8084e4df43fcf81
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 13 14:17:09 2022 +0200

    Restore compiler sanity back to the level of the autotools build
    
    Essentially, this reimplements 5ee567ebd600c1dec4a9ceb6161d877d891d8594
    in cmake.

commit 64dea7618bec2f3c4138f13ab057726ee4af15b6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 13 13:37:02 2022 +0200

    Implement proper imaevm detection in the cmake build
    
    Abort the build if imaevm enabled but header+library not present, use
    detected values. Check for lsetxattr() availability. Drop unnecessary
    imaevm linkage from the plugin, the plugin only manipulates xattrs and
    does not need the IMA library.

commit 275742d1fa347ca163d053823e429dc197ef4e55
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 13 13:32:49 2022 +0200

    Move optional/required function lists earlier so we can append to them
    
    No functional change here, needed for the next commit.

commit bcbcfd74401dab79a45fb43d669b7eb34afe17b3
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Dec 13 12:48:23 2022 +0200

    Select default db backend based on what's available
    
    Similar to what we had in autotools build, select the default db backend
    based on availability: sqlite remains the default but if it's not
    compiled in the ndb will be used etc. The dummy backend is always
    present so we don't need error checking.

commit 8e6108a5964c7289f3db70f3d188293276416528
Author: Daniel Alley <dalley@redhat.com>
Date:   Thu Dec 8 09:40:00 2022 -0500

    Use unsigned integers more consistently in the handling of tag data
    
    Not a functional change, it just makes the code more clear and
    self-consistent.

commit cf27c6f4963dcf27302d0f4fa39d7787dd03f942
Author: xujing <xujing125@huawei.com>
Date:   Fri Nov 25 17:18:33 2022 +0800

    Fix Header leak when running rpm2cpio
    
    Header "h" is alloced in rpmReadPackageFile but not freed when
    running rpm2cpio. Fix it. Remove redundant whitespace between
    the Fclose()'s too while at it for logical cleanup grouping.

commit 46bf7b753bf28779e16be881a9fd2585b3479269
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Dec 7 14:57:32 2022 +0200

    Remove rpmquery and rpmverify symlinks on "make clean" again

commit 642dafdfc9920a563796f117923376904cf6671a
Author: olf <Olf0@users.noreply.github.com>
Date:   Tue Nov 29 21:26:15 2022 +0100

    Add missed full stop.

commit a108d36acf29796b443285658a606c1b13866d9a
Author: olf <Olf0@users.noreply.github.com>
Date:   Tue Nov 29 21:17:16 2022 +0100

    Fix broken markdown quoting …
    
    … introduced in [commit 8b635e2](https://github.com/rpm-software-management/rpm/commit/8b635e2016931ec5bb7dddd6608c09b0b16f7b8e):
    - [Lines 98 - 101](https://github.com/rpm-software-management/rpm/commit/8b635e2016931ec5bb7dddd6608c09b0b16f7b8e#diff-f0f022b189e54462e3284599236a3b192b721928da4bea1a85d738b25ba5eaa7R98-R101): The two tildes lacked quoting, hence the text between them was struck out.
    - [Line 96](https://github.com/rpm-software-management/rpm/commit/8b635e2016931ec5bb7dddd6608c09b0b16f7b8e#diff-f0f022b189e54462e3284599236a3b192b721928da4bea1a85d738b25ba5eaa7R96): Eliminate IMO superfluous triple quoting:  "**\`\`\`**" → "*\`*"
    - Rephrase [lines 95 - 96](https://github.com/rpm-software-management/rpm/commit/8b635e2016931ec5bb7dddd6608c09b0b16f7b8e#diff-f0f022b189e54462e3284599236a3b192b721928da4bea1a85d738b25ba5eaa7R95-R96), to be more concise.

commit 7064a63a61ca631e745156a64c5ba9387df5e467
Author: olf <Olf0@users.noreply.github.com>
Date:   Tue Nov 29 23:05:22 2022 +0100

    Fix markdown syntax typo

commit 162ce177b071dc35571da68ec0dd371f2f942130
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 29 13:40:43 2022 +0200

    Default to Sequoia crypto as per roadmap
    
    Defaulting to a deprecated build option tends to looks a bit strange.
    Make Sequoia the default crypto option, update docs and add the
    dependency to CI environment.
    
    Fixes: #2065

commit 806356c608c13aea78da632c384524d298e8401d
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Fri Nov 25 17:40:36 2022 +0100

    Refactor processSpecialDir()
    
    No functional change.

commit a06374be2f85e457cb526edb8ead40f57c82bfd6
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Mon Nov 21 17:36:21 2022 +0100

    Glob special files only once, internally
    
    Currently, special files are globbed twice during build.  When copying
    them from builddir to buildroot using the %doc/%license script, we let
    the shell handle the globbing as we pass the patterns verbatim to cp(1).
    Then, when adding the copied files from buildroot to the internal file
    list, we use rpmGlob() to expand the same patterns in builddir again.
    
    This is not only redundant but also potentially error prone as it
    assumes both shell globbing and rpmGlob() will yield the same results.
    And most importantly, it means we can't just quote the cp commands to
    allow the use of shell control chars like '&' in filenames.  Selectively
    escaping those would be possible but still too brittle.
    
    To fix all that, just use rpmGlob() first and then pass the matches one
    by one to cp, all quoted.
    
    A side effect of this change is that there will be one cp command per
    match, as opposed to one cp command per file entry with matches as
    arguments, and the paths will be absolute.  This will make build logs a
    tiny bit more verbose but also more explicit and safe from hitting the
    maximum number of arguments in a single shell command (although that's
    more of a theoretical scenario, not likely with real packages).
    
    Fixes: #1294

commit 6a950a3a56a86a2ed8825efe69c8fdd74721694b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 28 13:22:50 2022 +0200

    Avoid unnecessary variables for cmake target data, part 4
    
    No advantages with includes either. cmake has some fancier property
    based stuff for dealing with public headers but those appear very recent
    additions.

commit 91d8c1fb9f09237e9c1b420576b55403e68015c8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 28 12:40:02 2022 +0200

    Avoid unnecessary variables for cmake target data, part 3
    
    These don't really add any value over just passing them to install()

commit 7f18bb8a02d590559d7066cd3ad46c4625478475
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 28 12:22:58 2022 +0200

    Avoid unnecessary variables for cmake target data, part 2
    
    Unroll the fancy loops for our cli util handling. This is slightly
    longer but much more straightforward to follow.
    
    Logically, parts of this would've belonged to commit
    71fe36cdc55588ec6776839b0efd058977eaac2e already untangling this isn't
    entirely straightforward.

commit 58ece20d33f78be1dfbf4d3aedae3fe282bc4c21
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 28 11:41:17 2022 +0200

    Avoid unnecessary variables for cmake target data, part 1
    
    The foo_SOURCES style isn't really in cmake ethos, and is wholly
    unnecessary here: target_sources() achieves the same exact thing in a
    slightly more straightforward way.

commit 28d8b2dbd31fe11651ef97c9e51335329dbb1db7
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Nov 28 12:23:03 2022 +0100

    Add _build/ to .gitignore
    
    as that's the suggested way of building in the INSTALL file

commit f1132f1205c1c22012f3c5e8a93a4ec398747ff7
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Oct 26 10:50:59 2022 +0200

    Remove build artifacts from .gitignore
    
    as with cmake builds should not longer be made in-tree

commit 71fe36cdc55588ec6776839b0efd058977eaac2e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 25 16:01:00 2022 +0200

    Use cmake imported targets to let it sort out the compiler flag details
    
    These imported targets passed to target_link_library() are supposed to
    handle all the pesky compilation, linkage etc details behind the scenes.
    I was pretty sure I was missing a trick with this, but this sure isn't
    exactly underlined in the documentation.
    
    Unroll the supposedly helpful loop for handling plugins: turns out doing
    this cmake native way is plenty shorter and more obvious too. The unroll
    kinda belongs to a separate commit but that'd be rather painful for very
    little if any gain.
    
    Fixes: #2269 and a whole class of similar cases, allegedly

commit 17eb3a457a2d9f33ec7e9f031ccf7a951318cc7c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 25 13:08:38 2022 +0200

    Bump CI to Fedora 37
    
    After being stuck on an EOL Fedora for so long, it's nice to be on the
    leading edge for a change.

commit 4c6052c42aee71695a0c1bde0b674e2ad6f8c96b
Author: Robbie Harwood <rharwood@redhat.com>
Date:   Thu Oct 27 15:11:36 2022 -0400

    Add rpmsort utility for sorting RPM versions
    
    rpmsort(8) is intended for use in shell scripts.  sort(1) is not RPM
    versioning-aware, and attempting to work around that is fraught.
    Instead, provide a wrapper around rpmvercmp() using qsort().
    
    Fedora's grub2 has carried a version of this since 2015, and a more
    complex version was also part of the grubby project (provided at
    /usr/libexec/grubby/rpm-sort) since 2018.  This version has been
    simplified and adapted to the RPM project.
    
    Also-authored-by: Peter Jones <pjones@redhat.com>
    Signed-off-by: Peter Jones <pjones@redhat.com>
    Signed-off-by: Robbie Harwood <rharwood@redhat.com>

commit 96f9b82e263bc83a4aacc1d8ccd729170b1a2676
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 25 10:46:21 2022 +0200

    Also make the ci target a boolean option with explicit dependencies
    
    Similar rationale as for 821bd6c271d99b37391398ce8577da5c29f9ec9c

commit faa3b8822c29cf21679243e88f6a36aa9dcc4d65
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 25 10:37:38 2022 +0200

    Make test-suite a boolean option with explicit dependencies
    
    Silently skipping the "check" target generation if one or more of its
    dependencies are missing is unobvious and inconsistent with how other
    optional dependencies are handled. Add an option to disable the
    tests-suite and make it's dependencies explicit.
    
    Fixes: #2288

commit ee4356ef27180c370c311ce57d9829adc74264a1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 23 13:39:59 2022 +0200

    Issue a warning when signing created an OpenPGP v3 signature
    
    https://bugzilla.redhat.com/show_bug.cgi?id=2141686 revealed that much
    of the rpm-ecosystem is still using the obsolete v3 OpenPGP signature
    format, I think largely due to workarounds for legacy rpm versions (from
    around the turn of the millennium) that have just been forgotten in
    place. Lets at least issue a wake-up warning when that happens.
    
    Unfortunately this is can't really be tested as current GnuPG versions
    just ignore any --force-v3-sigs arguments.
    
    Fixes: #2286

commit cf0231964553bdb060ecf71e9e1c545c0fb97dd0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 23 14:10:05 2022 +0200

    Use proper name (OpenPGP) when referring to the standard in messages

commit 86c1d9738de58eb8f8844c5345baeb578ace9485
Author: xujing <xujing125@huawei.com>
Date:   Thu Nov 24 17:33:53 2022 +0800

    Fix h->blob leak when installing source rpms
    
    When installing source rpms, "ei" is malloced and is saved in
    blob->ei by rpmReadPackageFile->rpmpkgRead->hdrblobRead, and then
    blob->ei is saved in h->blob by rpmReadPackageFile->hdrblobImport,
    which is leaked during installation.

commit 0b34438ccc3fdcbdaa6226d2398df88cc7439603
Author: xujing <xujing125@huawei.com>
Date:   Thu Nov 24 17:16:46 2022 +0800

    Fix file leak when src rpm in URL format is used for installation
    
    %{_tmppath}/rpm-tmp.* is created by rpmMkTempFile() when src rpm in
    URL format is used for installation, which is leaked.

commit 084c64d5ea0e1a309d3b57dc95926eb1536d0a7a
Author: xujing <xujing125@huawei.com>
Date:   Thu Nov 24 11:43:28 2022 +0800

    Fix eiu->sourceURL info leak in rpmInstall()
    
    When installing source rpms, eiu->sourceURL info is leaked.

commit 15a0c73f4698bc58fa2a633d46527c7813150f3a
Author: xujing <xujing125@huawei.com>
Date:   Thu Nov 24 10:43:11 2022 +0800

    Fix header leak in rpmInstall()
    
    When rpm installs a package, the header from tryReadHeader()
    in rpmInstall() is leaked in some cases.

commit 9daaf3d2ffa1a8b625e9a2657eac9b7ab3da3d8f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 24 10:51:04 2022 +0200

    Add some basic tests for OpenPGP v3 signatures
    
    Wider exposure of the Sequoia backend taught us that OpenPGP v3 signatures
    are surprisingly common still in the rpm-ecosystem, and in fact more
    common than v4 signatures. It's a bit surprising, considering that gnupg
    has defaulted to creating v4 signatures since 1.4.8 from late 2007 gnupg2
    refuses to create them at all.
    
    For future reference, the sample package here was signed with
    
       rpmsign --addsign --rpmv3 \
            --digest-algo=sha256 \
            --key-id=rsa@rpm.org \
            --define "__gpg /usr/bin/gpg1" \
            --define "_gpg_sign_cmd_extra_args --force-v3-sigs" \
            /tmp/hello-2.0-1.x86_64.rpm
    
    The two defines are the key to creating OpenPGP v3 signatures in 2022,
    the. Note that the --rpmv3 switch has absolutely nothing to do with
    OpenPGP v3 signatures, it's there to force *rpm* v3 signatures on the
    package similar to the other signed sample package.
    
    Fixes: #2276

commit 37b963fa51d6ad31086a6e345ce6701afda5afff
Author: yangchenguang <yangchenguang@uniontech.com>
Date:   Tue Oct 25 16:57:44 2022 +0800

    Allow piping from rpm2archive
    
    If stdout is not a terminal, output the archive(s) to it, instead of
    creating file(s) on disk.  This makes rpm2archive consistent with
    rpm2cpio.
    
    Based on a patch from yangchenguang <yangchenguang@uniontech.com>.
    
    Fixes: #2208

commit 425e2e02963eb2be8c685c75c37e7cc32103326c
Author: Michal Domonkos <mdomonko@redhat.com>
Date:   Tue Nov 22 15:07:23 2022 +0100

    Fix missing headers/footers in generated man pages
    
    Pass -s/--standalone to pandoc as it's needed in order for the man pages
    to render properly in man(1), we also used this option pre-cmake.
    
    While at it, also add the lost "-t man" back, to be explicit and avoid
    educated guesses.
    
    Fixes: #2283

commit 9fe0a099adb2dd373817b1c582200335830334b1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 18 12:00:24 2022 +0200

    Restore compiler warnings to autotools build level
    
    In autotools, we used to test whether -Wempty-body is supported, but
    that was newish in 2009 so maybe we can now just assume.

commit ff8bc357918bbddd7f0409f12ccb24cb381759b0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 18 11:57:04 2022 +0200

    Turn missing utility warning from cmake to debug message
    
    No point cluttering the output with this stuff, autotools didn't either
    and in all these years I haven't seen anybody complain about *that*.

commit d0867bcea9238d2d6438a6e987c5becb0c4f0344
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 18 12:08:55 2022 +0200

    Fix OpenMP enablement in librpmbuild (broken by cmake transition)
    
    find_package(OpenMP) does not actually set any compiler flags in the
    build environment, we need to do this manually.

commit 3c4f309e413ee8eda9f1381f2c20931c802adec8
Author: Miroslav Suchý <msuchy@redhat.com>
Date:   Fri Nov 18 11:06:16 2022 +0100

    document example of dynamic spec

commit 8a7a4e130578b11bf8087b503c53b8633478ed86
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed Nov 16 17:16:05 2022 +0100

    Test if BuildDependencies are checked for %prep
    
    Have package build fail for rpm -bp

commit 0d6429a4d9498786491a7b806a775585d806f96e
Author: Paul Donohue <git@PaulSD.com>
Date:   Tue Nov 8 11:00:23 2022 -0500

    Fix regression: -bp should check BuildRequires
    
    Some source packages assume that BuildRequires are installed before
    %prep is executed.  For example, `openssh` BuildRequires `automake` and
    runs `autoreconf` in %prep.
    
    Prior to 11c56d5 `rpmbuild -bp` checked BuildRequires and printed a
    helpful error message if there were any missing dependencies.  Since
    that commit, `rpmbuild -bp` skips the BuildRequires check, which can
    lead to misleading errors in %prep.
    
    This commit restores the BuildRequires check in `rpmbuild -bp`.
    
    Co-authored-by: Florian Festi <ffesti@redhat.com>

commit 1281c928a78181eb54d4c371d4c8ad5be20904a7
Author: xujing <xujing125@huawei.com>
Date:   Wed Nov 2 16:14:47 2022 +0800

    tests: add test for Obsoletes
    
    add test which is previously uncovered case.

commit 25022624fd7c178c76f75afe25e1ad07f4628370
Author: xujing <xujing125@huawei.com>
Date:   Wed Nov 2 16:08:10 2022 +0800

    tests: add test for %verify in %files
    
    add test which is previously uncovered case.

commit e73c9827a5ad492e6f86d387fa17b1011a09057a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 14 14:29:24 2022 +0200

    Remove unrelated %undefine output from macro scoping test
    
    %undefine output is not what this test is about, it's what happens
    afterwards. Commit aec8bdb53a3013eabf16368e17a65ab69c2136ee changed
    what happens in this very context, but then %undefine is not intended to
    used this way and its output is not what is being tested here, macro
    scope behavior is.

commit 52dc80022ec8c01ab77ecdc5a79a323289ae48ae
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 4 14:50:38 2022 +0300

    Enable malloc checking with random perturb in the test-suite
    
    Glibc provides low-cost memory sanity checking on it's own, it'd be
    foolish not to take advantage of this in the test-suite for our CI.
    As this introduces a level of randomness to the system, record the
    environment in a file (in particular, glibc.malloc.perturb value) to
    make possible failures reproducable.
    
    This is effective for glibc >= 2.34 only, in older versions the
    mechanism to enable differs.
    
    Based on initial patch by Elia Pinto.

commit db1c9da7fe507b7eb0424bf9c76b6cf37094ed36
Author: Neal H. Walfield <neal@walfield.org>
Date:   Thu Nov 10 08:39:20 2022 +0100

    Fix rpmkeys type confusion test.
    
    The `rpmkeys type confusion` test was added in ec13083f46a1e to check
    that the internal OpenPGP parser rejects a certificate with an invalid
    component.  The Sequoia backend happily accepts the certificate and
    ignores the invalid component, which causes the test to fail.  Mark
    the test as specific to the internal OpenPGP backend.
    
    Fixes #2272.

commit e8e2a121ba6c604f342f86d0c73dca32bd7d687c
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jan 11 11:07:59 2021 +0100

    Add Dynamic Spec generation
    
    Read in *.specpart files from %{specpartsdir} aka $RPM_SPECPARTS_DIR
    after the %install script. This allows the build process to add sub
    packages to the build. In the future more changes to the packages may be
    possible - like amending package declarations.
    
    The %{specpartsdir} is created by the %setup pseudo macro inside of the
    buildsubdir. It's presence allows build scripts to check if this feature
    is supported in the running rpmbuild instance.

commit 524bfcb816ea0fa21bbe9891073409df9d239d4f
Author: Florian Festi <ffesti@redhat.com>
Date:   Mon Jan 11 19:11:52 2021 +0100

    Allow starting new spec parts with PART_EMPTY
    
    Don't require %end as first line when PART_NONE is "preceeding"

commit 4b74e8a6ed237829445a31493962a8ca825fd1c1
Author: Florian Festi <ffesti@redhat.com>
Date:   Wed May 20 15:11:19 2020 +0200

    Split actual parsing of spec into its own function
    
    This allows parsing more spec pieces later in the build process

commit 0576d24756fe975d890f5535a21cfdfd35fc2ca4
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 16:02:24 2022 +0200

    Make %_smp_mflags build rather than parse time determined
    
    Decisions about number of CPUs to use need to be determinable at the
    exact time of build, the moment of parsing has little to do with it.
    Have %_smp_mflags take its value from the environment which we do
    control at the time of build, rather than the spec parse moment.

commit b0c9b3d87ae05ba292e037ef28f578da1114c09c
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 15:50:12 2022 +0200

    Calculate number of threads to use during build, not spec parse
    
    I think I initially added the thread stuff into spec parse with the idea
    that spec parse needs to be aware of it for stuff like %_smp_mflags,
    but that logic is busted: we need to calculate it after parsing to have
    any spec overrides affect the result, but in that case it can no longer
    affect what was parsed already (eg that %_smp_mflags stuff), it needs
    to be communicated differently. And in the meanwhile, parsing a spec
    has nothing to do with threads. Building does. So move the dance where
    it belongs, and while at it restore the previous value in OMP after a
    build completes.

commit 1c39ff76cbddf277d5fc1e6fc3309bc37c695004
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 10:48:42 2022 +0200

    Do CI builds with a random install prefix
    
    Another step to cover up for distcheck loss.

commit 1323661b2de213797a1990de35db198f5b0d180b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 10:47:12 2022 +0200

    Enforce read-only tree in CI builds
    
    This is something autotools distcheck target does, and is rather
    useful...

commit b53bae95e5a8349a6dce22c81be3bf88f624b261
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 10:30:42 2022 +0200

    Run CI builds entirely outside source tree
    
    Makes things cleaner and consistent with the Debian variant, plus avoids
    having to guess against locally existing directories when copying files.
    Also, only set WORKDIR when needed, the dnf stuff does not depend on it
    at all.

commit 5049fc701561b258b722b3400460d8828ce9e64e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Mon Nov 7 10:41:34 2022 +0200

    Make CPU and thread-related macros available on all platforms
    
    %_smp_mflags and the related macros that it grew around itself used to
    be platform specific as they relied on external tooling (eg getconf for
    getting processor count), but since rpm 4.15 this has been backed by the
    built-in %{getncpus} macro which is available on all platforms, so
    there's zero reason to duplicate this stuff on all platform files.
    
    Fixes: #2265

commit 3d56ca240a8396537dff9bb3005d1351d16d5224
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Nov 8 09:34:56 2022 +0200

    Eliminate remaining %{u2p:...} uses
    
    The build and source directories are plain old directories, never any
    sort of URLs. Drop the misleading and obfuscating u2p macro uses from
    the build environment setting.
    
    As of this commit, u2p is unused within rpm.

commit ff731cdde53b8f26d61aa8aa8bed968339327908
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 4 14:01:04 2022 +0200

    Add a Debian based alternative Dockerfile CI for giggles
    
    This is unused for now, but besides amusement it helps keep us straight
    wrt bashism and other distro differences.

commit cdecb62ad4263654dc24ea1739a7d2471d29e528
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 4 13:51:49 2022 +0200

    Avoid bashisms in test-suite specs
    
    On Debian and derivates, /bin/sh points to /bin/dash which among other
    things doesn't support brace expansion.

commit 00c1bdfd7cf1b9894537a20b2c3b8ee9f4ea4b39
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 4 12:44:18 2022 +0200

    Try to use pre-compiled libmagic, fall back to recreating if not found
    
    Fedora ships the magic source, but at least Debian does not and so
    our clever `file -C` trick for avoiding paths ends up being less clever
    in that case: there's nothing for file to compile so you get an empty
    .mgc. Which has consequences.

commit 36efef2eb4810b66a6893b3889010bdb5d70ef1f
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 4 11:21:43 2022 +0200

    Try to look up utility paths instead of just assuming /usr/bin

commit 1e1e93ee53361ff741d52dc0364089aa59ffbfc0
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Fri Nov 4 10:11:53 2022 +0200

    Avoid buggy (if harmless) bin symlink in test when using /usr prefix

commit 40d66336a243093d6d67d1203f511d3831ecbc7a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 15:46:40 2022 +0200

    Handle testing directory ro/rw state from cmake (mostly)
    
    In particular, re-enable read-write after completing the test-suite.
    This fixes the testing directory being annoyingly sticky and requiring
    use of exessive force to remove.
    
    Ideally we'd like to handle this entirely withing the check target
    (or rpmtests run) but PRE_BUILD commands execute far too late for this
    purposes, so just turn it ro from after populating it.

commit aa80e49574875aff76fe132080d7669158dda4ad
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 14:50:21 2022 +0200

    Bump cmake requirement to 3.12 to reflect actual use
    
    We already rely on a bunch of stuff (HOMEPAGE_URL and whatnot) that was
    introduced in 3.12.

commit e9f03dec404fef8cc8b6cdfc799f7fe607ff72a8
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 14:42:09 2022 +0200

    Fix fsverity plugin build, obviously never worked with cmake before, doh

commit 3dcf09b0f2f3f5914d163d741a653e7aa4de093b
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 14:28:08 2022 +0200

    Fix libacl and libaudit linkage to use info from pkg-config

commit c0578ad982d5cb79551453570673a1ff5438190e
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 14:06:05 2022 +0200

    Drop misplaced sqlite3 linkage from bdb_ro which certainly doesn't...

commit 89953f647a4b85143e7a7b78ac0122580998ebd6
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 13:16:40 2022 +0200

    Fix some cmake newbie variable testing confusion
    
    Where pkg_check_modules(FOO foo) sets FOO_FOUND if found, find_package()
    is similar but the module names are randomly miXedCase and so you get
    miXedCase_FOUND, if you're lucky.  Now, find_program(FOO foo) though,
    that's entirely different. It always defines FOO, regardless of whether
    it found something, and no other variables. And worse, it's defined to
    FOO-NOTFOUND, so you can't use the obvious if() shortcuts there. A simple
    way around this is testing for program existence - a trick lifted from
    libdnf, cheers if you're reading.
    
    Newbie errors and all, but one may have expected a bit more consistency
    from this much touted cmake thing...

commit d1e234bd567300b80172d8e1cdba9c6759b3eeb2
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Thu Nov 3 08:45:27 2022 +0200

    Remember to set include directories from pkgconfig for Lua
    
    We should really do this for all our dependencies, but notably Debian
    and derivates have multiple versions of Lua available, each in different
    includedir, and build fails without this.
    
    Fixes: #2258

commit c94051f99a6d134e719be9af1c8934d818594c74
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Thu Mar 17 03:05:33 2022 -0400

    Reject multiple PGPTAG_PUBLIC_KEY packets
    
    RPM’s simple public key parser cannot handle multiple public keys in the
    same input stream.  While this could be fixed, it would require
    substantial refactoring in code that will eventually be replaced.  This
    is because the pgpDigParams struct can only hold a single public key.
    
    Currently, a second public key packet does not update the
    algorithm-specific data for the public key.  However, it *will* update
    the public key algorithm, if no signature packet has appeared in the
    meantime.  This prevents the security check in the previous commits from
    working and leads to a type confusion bug.
    
    Fix this bug by returning an error if a second PGPTAG_PUBLIC_KEY packet
    is found in the input stream.  This *does not* affect `rpmkeys --import`
    because it explicitly checks for multiple PGPTAG_PUBLIC_KEY packets and
    imports them separately.  It *does* affect the rpmPubkeyRead() and
    rpmPubkeyNew() functions; these will need to be fixed if this limitation
    is a problem for them.

commit 201cd279ec4ea743123d067cf31b04d76f86829e
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Fri Mar 4 10:43:44 2022 -0500

    Check packet types of signatures and public keys
    
    pgpVerifySignature() should check that the provided signature is in fact
    a signature, and that provided key is in fact a public key.  Otherwise,
    a type confusion bug could result if something that is not a signature
    or public key is passed.  RPM itself never calls pgpVerifySignature()
    without having checked the types so all calls in RPM are safe.

commit ec13083f46a1efe8700925538b4f98dc45af93bc
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Thu Mar 3 23:34:01 2022 -0500

    Avoid type confusion when verifying signatures
    
    In RPM, both signatures and public keys are stored as heap-allocated
    opaque structs.  The type of the struct is determined by whether this is
    a signature or a key and by the public-key algorithm in the associated
    pgpDigParams_s struct.  However, when verifying a signature, RPM did not
    check that the signature and public key used the same public-key
    algorithm.  If they did not, the signature verification code will
    interpret a pointer to the struct specified by the public key’s
    public-key algorithm as a pointer to the struct specified by the
    signature’s public-key algorithm.  This is not a problem when verifying
    package signatures, as findbySig() (in rpmio/rpmkeyring.c) checks that
    the public-key algorithms used by the signature and the public key
    match.  If they do not, it returns NULL, causing both rpmKeyringLookup()
    and rpmKeyringVerifySig() to return RPMRC_NOKEY.  However, the code that
    checks subkey binding signatures does *not* check this, so the type
    confusion can be triggered when importing a crafted key.  This is
    demonstrated by the included test case, which segfaults when OpenSSL is
    used as the underlying cryptographic library.  Fix the problem by
    checking that the algorithms match in pgpVerifySignature().

commit 752ed08d1026aeb4aa1716f32064453005e12d5e
Author: Frank Dana <ferdnyc@gmail.com>
Date:   Wed Nov 2 10:11:24 2022 -0400

    Docs: macros: Add some missing fencing, fix grammar

commit 43155029ccf530a5cd184a53c68ddcb46ce7983b
Author: Frank Dana <ferdnyc@gmail.com>
Date:   Mon Oct 31 19:51:05 2022 -0400

    Docs: Macros: Attempt to fix literal backslash

commit 14e14a5c2a5140b00816ac7b8f104af810ab5208
Author: FeRD (Frank Dana) <ferdnyc@gmail.com>
Date:   Tue Nov 1 15:21:33 2022 -0400

    Docs: macros: backtick-fence more literals in body

commit 4df74a9644b18136b722e36cf3cac812e2c0a1a5
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Tue Oct 25 13:22:19 2022 +0300

    Axe man page translations
    
    These are all horrendously outdated, the newest proper updates to these
    files being from 2002-2007. Nothing has happened since, yep...
    Translations of these are better handled elsewhere and by other means.

commit 275a0ea28f2f8b32a3341fa135cd766c430d63e1
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 2 14:10:10 2022 +0200

    Add rpm-l10n as a submodule into po/
    
    The average rpm hacker does not need the translations for anything,
    those who do now need to do `git submodule init` to pull them. Not
    documenting it further for now as the details will change and these are
    only supposed to affect rpm maintainers creating dist tarballs anyhow.

commit fef87ca940214991366258ba7164f1550d29f33a
Author: Panu Matilainen <pmatilai@redhat.com>
Date:   Wed Nov 2 13:46:07 2022 +0200

    Split off translations to a separate project
    
    With Weblate managing our translations, carrying them does nothing but
    create conflicts and annoyances of various kinds. Besides, the
    translation updates are nothing but an annoyance in the git history.
    Translators deserve credit for their work as much as anyone, but the
    code history is the wrong place for that. As a nice side-effect, this
    effectively prevents people from filing PR's for translation updates which
    we can't process anyway.
    
    The translations now live at a separate repository at
    https://github.com/rpm-software-management/rpm-l10n, integration with
    dist tarball creation and source string scanning to be done. For now,
    just skip the po/ directory if translations are not present.

commit 292f806157c8fd913a7803aa060d146adc316795
Author: Jingge Chen <mariocanfly@hotmail.com>
Date:   Sat Oct 29 13:21:57 2022 +0000

    Translated using Weblate (Chinese (Simplified) (zh_CN))
    
    Currently translated at 79.5% (724 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/zh_CN/

commit 6b3551f1f260b05938a0cb6faa5f7dab99ad0605
Author: Olga Smirnova <mistresssilvara@hotmail.com>
Date:   Wed Oct 26 23:59:24 2022 +0000

    Translated using Weblate (Occidental)
    
    Currently translated at 18.4% (168 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/ie/

commit a80ec46aa142de129e84f757ca1c19d6bd3bc5bd
Author: Olga Smirnova <mistresssilvara@hotmail.com>
Date:   Wed Oct 26 23:06:43 2022 +0000

    Translated using Weblate (Russian)
    
    Currently translated at 58.6% (534 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/ru/

commit c9c6e85d93f64cf356fce00b00917ddf9ed9d4bf
Author: Olga Smirnova <mistresssilvara@hotmail.com>
Date:   Thu Oct 27 01:03:41 2022 +0200

    Added translation using Weblate (Occidental)

commit 82c87a38e29e9b2db7e5799c965ccd0f303d81e3
Author: Yang Yulin <yylteam@icloud.com>
Date:   Mon Oct 3 00:55:40 2022 +0000

    Translated using Weblate (Chinese (Simplified) (zh_CN))
    
    Currently translated at 79.4% (723 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/zh_CN/

commit 94d1d50141560a4028754f741e21c22c14f4065a
Author: Yang Yulin <yylteam@icloud.com>
Date:   Thu Sep 22 09:24:03 2022 +0000

    Translated using Weblate (Chinese (Simplified) (zh_CN))
    
    Currently translated at 79.2% (721 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/zh_CN/

commit cf6e17cf35b700471c73a61abdeae01c97748d26
Author: V I <xasertop@gmail.com>
Date:   Fri Sep 16 16:39:29 2022 +0000

    Translated using Weblate (Russian)
    
    Currently translated at 58.4% (532 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/ru/

commit c74ec80bbb1b0a00d96cf41ee34636d307065709
Author: Olga Smirnova <mistresssilvara@hotmail.com>
Date:   Fri Sep 16 18:39:27 2022 +0200

    Translated using Weblate (Russian)
    
    Currently translated at 58.4% (532 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/ru/

commit 5a014a11419faaeb1bcdb8dcb7310c6e65030cb1
Author: V I <xasertop@gmail.com>
Date:   Fri Sep 16 18:39:26 2022 +0200

    Translated using Weblate (Russian)
    
    Currently translated at 58.4% (532 of 910 strings)
    
    Translation: rpm/master
    Translate-URL: https://translate.fedoraproject.org/projects/rpm/master/ru/

commit ae88e563671030fc593e1e6153e2296a2e055152
